			SENDMAIL RELEASE NOTES


This listing shows the version of the sendmail binary, the version
of the sendmail configuration files, the date of release, and a
summary of the changes in that release.

8.16.1/8.16.1	201X/XX/XX
	SECURITY: If sendmail tried to reuse an SMTP session which had
                already been closed by the server, then the connection
                cache could have invalid information about the session.
                One possible consequence was that STARTTLS was not
                used even if offered.  This problem has been fixed
                by clearing out all relevant status information
                when a closed session is encountered.
	OpenSSL versions before 0.9.8 are no longer supported.
	New options SSLEngine and SSLEnginePath to support OpenSSL engines.
		Note: this feature has so far only been tested with the
		"chil" engine; please report problems with other engines
		if you encounter any.
	New option CRLPath to specify a directory which contains
		hashes pointing to certificate revocations files.
		Based on patch from Al Smith.
	New rulesets tls_srv_features and tls_clt_features which
		can return a (semicolon separated) list of TLS related
		options, e.g., CipherList, CertFile, KeyFile,
		see doc/op/op.me for details.
	To automatically handle TLS interoperability problems for outgoing
		mail, sendmail can now immediately try a connection again
		without STARTTLS after a TLS handshake failure.
		This can be configured globally via the option
		TLSFallbacktoClear or per session via the 'C' flag
		of tls_clt_features.
		This also adds the new value "CLEAR" for the macro
		{verify}: STARTTLS has been disabled internally for
		a clear text delivery attempt.
	Apply Timeout.starttls also to the server waiting for the TLS
		handshake to begin.  Based on patch from Simon Hradecky.
	New compile time option TLS_EC to enable the use of elliptic
		curve cryptography in STARTTLS (previously available as
		_FFR_TLS_EC).
	CONFIG: New FEATURE(`tls_session_features') to enable standard
		rules for tls_srv_features and tls_clt_features; for
		details see cf/README.
	CONFIG: New options confSSL_ENGINE and confSSL_ENGINE_PATH
		for SSLEngine and SSLEnginePath, respectively.
	CONFIG: New option confTLS_FALLBACK_TO_CLEAR for TLSFallbacktoClear.
	CONFIG: New FEATURE(`tls_failures') allows downgrading SMTP
		deliveries from TLS to cleartext sessions after several
		tries if the previous delivery failed with a PROTOCOL
		or SOFTWARE TLS error.
	CONFIG: New extension CITag: for TLS restrictions, see cf/README
		for details.
	CONTRIB: cidrexpand updated to support IPv6 CIDR ranges and to
		canonicalize IPv6 addresses; if cidrexpand is used with IPv6
		addresses then UseCompressedIPv6Addresses must be disabled.
	DOC: The dns map can return multiple values in a single result
		if the -z option is used.
	LIBMILTER: Fix typo in a macro. Patch from Ignacio Goyret
		of Alcatel-Lucent.
	Portability:
		Add support for Darwin 14.x (Mac OS X 10.10) and
			Darwin 15.x (Mac OS X 10.11).
	Added Files:
		cf/feature/tls_failures.m4
		devtools/OS/Darwin.14.x
		devtools/OS/Darwin.15.x
		sendmail/ratectrl.h

8.15.2/8.15.2	2015/07/03
	If FEATURE(`nopercenthack') is used then some bogus input triggered
		a recursion which was caught and logged as
		SYSERR: rewrite: excessive recursion (max 50) ...
		Fix based on patch from Ondrej Holas.
	DHParameters now by default uses an included 2048 bit prime.
		The value 'none' previously caused a log entry claiming
		there was an error "cannot read or set DH parameters".
		Also note that this option applies to the server side only.
	The U= mailer field didn't accept group names containing hyphens,
		underbars, or periods.  Based on patch from David Gwynne
		of the University of Queensland.
	CONFIG: Allow connections from IPv6:0:0:0:0:0:0:0:1 to relay again.
		Patch from Lars-Johan Liman of Netnod Internet Exchange.
	CONFIG: New option UseCompressedIPv6Addresses to select between
		compressed and uncompressed IPv6 addresses.  The default
		value depends on the compile-time option IPV6_FULL:
		For 1 the default is False, for 0 it is True, thus
		preserving the current behaviour.  Based on patch from
		John Beck of Oracle.
	CONFIG: Account for IPv6 localhost addresses in
		FEATURE(`block_bad_helo').  Suggested by Andrey Chernov
		from FreeBSD and Robert Scheck from the Fedora Project.
	CONFIG: Account for IPv6 localhost addresses in check_mail ruleset.
	LIBMILTER: Deal with more invalid protocol data to avoid potential
		crashes.  Problem noted by Dimitri Kirchner.
	LIBMILTER: Allow a milter to specify an empty macro list ("", not
		NULL) in smfi_setsymlist() so no macro is sent for the
		selected stage.
	MAKEMAP: A change to check TrustedUser in fewer cases which was
		made in 2013 caused a potential regression when makemap
		was run as root (which should not be done anyway).
	Note: sendmail often contains options "For Future Releases"
		(prefix _FFR_) which might be enabled in a subsequent
		version or might simply be removed as they turned out not
		to be really useful.  These features are usually not
		documented but if they are, then the required (FFR)
		options are listed in
		- doc/op/op.* for rulesets and macros,
		- cf/README for mc/cf options.

8.15.1/8.15.1	2014/12/06
	SECURITY: Properly set the close-on-exec flag for file descriptors
		(except stdin, stdout, and stderr) before executing mailers.
	If header rewriting fails due to a temporary map lookup failure,
		queue the mail for later retry instead of sending it
		without rewriting the header.  Note: this is done
		while the mail is being sent and hence the transaction
		is aborted, which only works for SMTP/LMTP mailers
		hence the handling of temporary map failures is
		suppressed for other mailers. SMTP/LMTP servers may
		complain about aborted transactions when this problem
		occurs.
		See also "DNS Lookups" in sendmail/TUNING.
	Incompatible Change: Use uncompressed IPv6 addresses by default,
		i.e., they will not contain "::".  For example,
		instead of ::1 it will be 0:0:0:0:0:0:0:1.  This
		permits a zero subnet to have a more specific match,
		such as different map entries for IPv6:0:0 vs IPv6:0.
		This change requires that configuration data
		(including maps, files, classes, custom ruleset,
		etc) must use the same format, so make certain such
		configuration data is updated before using 8.15.
		As a very simple check search for patterns like
		'IPv6:[0-9a-fA-F:]*::' and 'IPv6::'. If necessary,
		the prior format can be retained by compiling with:
		APPENDDEF(`conf_sendmail_ENVDEF', `-DIPV6_FULL=0')
		in your devtools/Site/site.config.m4 file.
	If debugging is turned on (-d0.14) also print the OpenSSL
		versions, both build time and run time
		(provided STARTTLS is compiled in).
	If a connection to the MTA is dropped by the client before its
		hostname can be validated, treat it as "may be forged",
		so that the unvalidated hostname is not passed to a
		milter in xxfi_connect().
	Add a timeout for communication with socket map servers
		which can be specified using the -d option.
	Add a compile time option HESIOD_ALLOW_NUMERIC_LOGIN to allow
		numeric logins even if HESIOD is enabled.
	The new option CertFingerprintAlgorithm specifies the finger-
		print algorithm (digest) to use for the presented cert.
		If the option is not set, md5 is used and the macro
		{cert_md5} contains the cert fingerprint.
		However, if the option is set, the specified algorithm
		(e.g., sha1) is used and the macro {cert_fp} contains
		the cert fingerprint.
		That is, as long as the option is not set, the behaviour
		does not change, but otherwise, {cert_md5} is superseded
		by {cert_fp} even if you set CertFingerprintAlgorithm
		to md5.
	The options ServerSSLOptions and ClientSSLOptions can be used
		to set SSL options for the server and client side
		respectively. See SSL_CTX_set_options(3) for a list.
		Note: this change turns on SSL_OP_NO_SSLv2 and
		SSL_OP_NO_TICKET for the client. See doc/op/op.me
		for details.
	The option CipherList sets the list of ciphers for STARTTLS.
		See ciphers(1) for possible values.
	Do not log "STARTTLS: internal error: tls_verify_cb: ssl == NULL"
		if a CRLFile is in use (and LogLevel is 14 or higher.)
	Store a more specific TLS protocol version in ${tls_version}
		instead of a generic one, e.g., TLSv1 instead of
		TLSv1/SSLv3.
	Properly set {client_port} value on little endian machines.
		Patch from Kelsey Cummings of Sonic.net.
	Per RFC 3848, indicate in the Received: header whether SSL or
		SMTP AUTH was negotiated by setting the protocol clause
		to ESMTPS, ESMTPA, or ESMTPSA instead of ESMTP.
	If the 'C' flag is listed as TLSSrvOptions the requirement for the
		TLS server to have a cert is removed.  This only works
		under very specific circumstances and should only be used
		if the consequences are understood, e.g., clients
		may not work with a server using this.
	The options ClientCertFile, ClientKeyFile, ServerCertFile, and
		ServerKeyFile can take a second file name, which must be
		separated from the first with a comma (note: do not use
		any spaces) to set up a second cert/key pair. This can
		be used to have certs of different types, e.g., RSA
		and DSA.
	A new map type "arpa" is available to reverse an IP (IPv4 or IPv6)
		address. It returns the string for the PTR lookup, but
		without trailing {ip6,in-addr}.arpa.
	New operation mode 'C' just checks the configuration file, e.g.,
		sendmail -C new.cf -bC
		will perform a basic syntax/consistency check of new.cf.
	The mailer flag 'I' is deprecated and will be removed in a
		future version.
	Allow local (not just TCP) socket connections to the server, e.g.,
		O DaemonPortOptions=Family=local, Addr=/var/mta/server.sock
		can be used.
	If the new option MaxQueueAge is set to a value greater than zero,
		entries in the queue will be retried during a queue run
		only if the individual retry time has been reached which
		is doubled for each attempt.  The maximum retry time is
		limited by the specified value.
	New DontBlameSendmail option GroupReadableDefaultAuthInfoFile
		to relax requirement for DefaultAuthInfo file.
	Reset timeout after receiving a message to appropriate value if
		STARTTLS is in use.  Based on patch by Kelsey Cummings
		of Sonic.net.
	Report correct error messages from the LDAP library for a range of
		small negative return values covering those used by OpenLDAP.
	Fix compilation with Berkeley DB 5.0 and 6.0.  Patch from
		Allan E Johannesen of Worcester Polytechnic Institute.
	CONFIG: FEATURE(`nopercenthack') takes one parameter: reject or
		nospecial which describes whether to disallow "%" in the
		local part of an address.
	DEVTOOLS: Fix regression in auto-detection of libraries when only
		shared libraries are available.  Problem reported by
		Bryan Costales.
	LIBMILTER: Mark communication socket as close-on-exec in case
		a user's filter starts other applications.
		Based on patch from Paul Howarth.
	Portability:
		SunOS 5.12 has changed the API for sigwait(2) to conform
		with XPG7.  Based on patch from Roger Faulkner of Oracle.
	Deleted Files:
		libsm/path.c

8.14.9/8.14.9	2014/05/21
	SECURITY: Properly set the close-on-exec flag for file descriptors
		(except stdin, stdout, and stderr) before executing mailers.
	Fix a misformed comment in conf.c: "/*" within comment
		which may cause a compilation error on some systems.
		Problem reported by John Beck of Oracle.
	DEVTOOLS: Fix regression in auto-detection of libraries when only
		shared libraries are available.  Problem reported by
		Bryan Costales.

8.14.8/8.14.8	2014/01/26
	Properly initialize all OpenSSL algorithms for versions before
		OpenSSL 0.9.8o. Without this SHA2 algorithms may not
		work properly, causing for example failures for certs
		that use sha256WithRSAEncryption as signature algorithm.
	When looking up hostnames, ensure only to return those records
		for the requested family (AF_INET or AF_INET6).
		On system that have NEEDSGETIPNODE and NETINET6
		this may have failed and cause delivery problems.
		Problem noted by Kees Cook.
	A new mailer flag '!' is available to suppress an MH hack
		that drops an explicit From: header if it is the
		same as what sendmail would generate.
	Add an FFR (for future release) to use uncompressed IPv6 addresses,
		i.e., they will not contain "::".  For example, instead
		of ::1 it will be 0:0:0:0:0:0:0:1.  This means that
		configuration data (including maps, files, classes,
		custom ruleset, etc) have to use the same format.
		This will be turned on in 8.15.  It can be enabled in 8.14
		by compiling with:
		APPENDDEF(`conf_sendmail_ENVDEF', `-D_FFR_IPV6_FULL')
		in your devtools/Site/site.config.m4 file.
	Add an additional case for the WorkAroundBrokenAAAA check when
		dealing with broken nameservers by ignoring SERVFAIL
		errors returned on T_AAAA (IPv6) lookups at delivery time.
		Problem noted by Pavel Timofeev of OCS.
	If available, pass LOGIN_SETCPUMASK and LOGIN_SETLOGINCLASS to
		setusercontext() on deliveries as a different user.
		Patch from Edward Tomasz Napierala from FreeBSD.
	Avoid compiler warnings from a change in Cyrus-SASL 2.1.25.
		Patch from Hajimu UMEMOTO from FreeBSD.
	Add support for DHParameters 2048-bit primes.
	CONFIG: Accept IPv6 literals when evaluating the HELO/EHLO argument
		in FEATURE(`block_bad_helo').  Suggested by Andrey Chernov.
	LIBSMDB: Add a missing check for malloc() in libsmdb/smndbm.c.
		Patch from Bill Parker.
	LIBSMDB: Fix minor memory leaks in libsmdb/ if allocations
		fail.  Patch from John Beck of Oracle.
	Portability:
		Add support for Darwin 12.x and 13.x (Mac OS X 10.8 and 10.9).
		On Linux use socklen_t as the type for the 3rd argument
		for getsockname/getpeername if the glibc version is at
		least 2.1.
	Added Files:
		devtools/OS/Darwin.12.x
		devtools/OS/Darwin.13.x

8.14.7/8.14.7	2013/04/21
	Drop support for IPv4-mapped IPv6 addresses to prevent the MTA
		from using a mapped address over a legitimate IPv6 address
		and to enforce the proper semantics over the IPv6
		connection.  Problem noted by Ulrich Sporlein.
	Fix a regression introduced in 8.14.6: the wrong list of
		macros was sent to a milter in the EHLO stage.
		Problem found by Fabrice Bellet, reported via RedHat
		(Jaroslav Skarvada).
	Fix handling of ORCPT parameter for DSNs: xtext decoding
		was not performed and a wrong syntax check was applied
		to the "addr-type" field.  Problem noted by Dan Lukes
		of Obludarium.
	Fix handling of NUL characters in the MIME conversion functions
		so that message bodies containing them will be sent
		on properly. Note: this usually also affects mails
		that are not converted as those functions are used
		for other purposes too.  Problem noted by Elchonon
		Edelson of Lockheed Martin.
	Do not perform "duplicate" elimination of recipients if they
		resolve to the error mailer using a temporary failure
		(4xy) via ruleset 0.  Problem noted by Akira Takahashi
		of IIJ.
	CONTRIB: Updated version of etrn.pl script from John Beck
		of Oracle.
	Portability:
		Unlike gcc, clang doesn't apply full prototypes to K&R
		definitions.

8.14.6/8.14.6	2012/12/23
	Fix a regression introduced in 8.14.5: if a server offers
		two AUTH lines, the MTA would not read them after
		STARTTLS has been used and hence SMTP AUTH for
		the client side would fail.  Problem noted by Lena.
	Do not cache hostnames internally in a non case sensitive way
		as that may cause addresses to change from lower case
		to upper case or vice versa. These header modifications
		can cause problems with milters that rely on receiving
		headers in the same way as they are being sent out such
		as a DKIM signing milter.
	If MaxQueueChildren is set then it was possible that new queue
		runners could not be started anymore because an
		internal counter was subject to a race condition.
	If a milter decreases the timeout it waits for a communication
		with the MTA, the MTA might experience a write() timeout.
		In some situations, the resulting error might have been
		ignored.  Problem noted by Werner Wiethege.
		Note: decreasing the communication timeout in a milter
		should not be done without considering the potential
		problems.
	smfi_setsymlist() now properly sets the list of macros for
		the milter which invoked it, instead of a global
		list for all milters.  Problem reported by
		David Shrimpton of the University of Queensland.
	If Timeout.resolver.retrans is set to a value larger than 20,
		then resolver.retry was temporarily set to 0 for
		gethostbyaddr() lookups. Now it is set to 1 instead.
		Patch from Peter.
	If sendmail could not lock the statistics file due to a system
		error, and sendmail later sends a DSN for a mail that
		triggered such an error, then sendmail tried to access
		memory that was freed before (causing a crash on some
		systems).  Problem reported by Ryan Stone.
	Do not log negative values for size= nor pri= to avoid confusing
		log parsers, instead limit the values to LONG_MAX.
	Account for an API change in newer versions of Cyrus-SASL.
		Patch from Hajimu UMEMOTO from FreeBSD.
	Do not try to resolve link-local addresses for IPv4 (just as it
		is done for IPv6).  Patch from John Beck of Oracle.
	Improve logging of client and server STARTTLS connection failures
		that may be due to incompatible cipher lists by including
		the reason for the failure in a single log line.  Suggested
		by James Carey of Boeing.
	Portability:
		Add support for Darwin 11.x (Mac OS X 10.7).
		Add support for SunOS 5.12 (aka Solaris 12). Patch from
		John Beck of Oracle.
	Added Files:
		devtools/OS/Darwin.11.x
		devtools/OS/SunOS.5.12

8.14.5/8.14.5	2011/05/17
	Do not cache SMTP extensions across connections as the cache
		is based on hostname which may not be a unique identifier
		for a server, i.e., different machines may have the
		same hostname but provide different SMTP extensions.
		Problem noted by Jim Hermann.
	Avoid an out-of-bounds access in case a resolver reply for a DNS
		map lookup returns a size larger than 1K.  Based on a
		patch from Dr. Werner Fink of SuSE.
	If a job is aborted using the interrupt signal (e.g., control-C from
		the keyboard), perform minimal cleanup to avoid invoking
		functions that are not signal-safe. Note: in previous
		versions the mail might have been queued up already
		and would be delivered subsequently, now an interrupt
		will always remove the queue files and thus prevent
		delivery.
	Per RFC 6176, when operating as a TLS client, do not offer SSLv2.
	Since TLS session resumption is never used as a client, disable
		use of RFC 4507-style session tickets.
	Work around gcc4 versions which reverse 25 years of history and
		no longer align char buffers on the stack, breaking calls
		to resolver functions on strict alignment platforms.
		Found by Stuart Henderson of OpenBSD.
	Read at most two AUTH lines from a server greeting (up to two
		lines are read because servers may use "AUTH mechs" and
		"AUTH=mechs"). Otherwise a malicious server may exhaust
		the memory of the client.  Bug report by Nils of MWR
		InfoSecurity.
	Avoid triggering an assertion in the OpenLDAP code when the
		connection to an LDAP server is lost while making a query.
		Problem noted and patch provided by Andy Fiddaman.
	If ConnectOnlyTo is set and sendmail is compiled with NETINET6
		it would try to use an IPv6 address if an IPv4 (or
		unparseable) address is specified.
	If SASLv2 is used, make sure that the macro {auth_authen} is
		stored in xtext format to avoid problems with parsing
		it.  Problem noted by Christophe Wolfhugel.
	CONFIG: FEATURE(`ldap_routing') in 8.14.4 tried to add a missing
		-T<TMPF> that is required, but failed for some cases
		that did not use LDAP.  This change has been undone
		until a better solution can be implemented.  Problem
		found by Andy Fiddaman.
	CONFIG: Add cf/ostype/solaris11.m4 for Solaris11 support.
		Contributed by Casper Dik of Oracle.
	CONTRIB: qtool.pl: Deal with H entries that do not have a
		letter between the question marks.  Patch from
		Stefan Christensen.
	DOC: Use a better description for the -i option in sendmail.
		Patch from Mitchell Berger.
	Portability:
		Add support for Darwin 10.x (Mac OS X 10.6).
		Enable HAVE_NANOSLEEP for FreeBSD 3 and later.  Patch
		from John Marshall.
		Enable HAVE_NANOSLEEP for OpenBSD 4.3 and later.
		Use new directory "/system/volatile" for PidFile on
		Solaris 11.  Patch from Casper Dik of Oracle.
		Fix compilation on Solaris 11 (and maybe some other
		OSs) when using OpenSSL 1.0.  Based on patch from
		Jan Pechanec of Oracle.
		Set SOCKADDR_LEN_T and SOCKOPT_LEN_T to socklen_t
		for Solaris 11.  Patch from Roger Faulkner of Oracle.
	New Files:
		cf/ostype/solaris11.m4

8.14.4/8.14.4	2009/12/30
	SECURITY: Handle bogus certificates containing NUL characters
		in CNs by placing a string indicating a bad certificate
		in the {cn_subject} or {cn_issuer} macro.  Patch inspired
		by Matthias Andree's changes for fetchmail.
	During the generation of a queue identifier an integer overflow
		could occur which might result in bogus characters
		being used.  Based on patch from John Vannoy of
		Pepperdine University.
	The value of headers, e.g., Precedence, Content-Type, et.al.,
		was not processed correctly.  Patch from Per Hedeland.
	Between 8.11.7 and 8.12.0 the length limitation on a return
		path was erroneously reduced from MAXNAME (256) to
		MAXSHORTSTR (203).  Patch from John Gardiner Myers
		of Proofpoint; the problem was also noted by Steve
		Hubert of University of Washington.
	Prevent a crash when a hostname lookup returns a seemingly
		valid result which contains a NULL pointer (this seems
		to be happening on some Linux versions).
	The process title was missing the current load average when
		the MTA was delaying connections due to DelayLA.
		Patch from Dick St.Peters of NetHeaven.
	Do not reset the number of queue entries in shared memory if
		only some of them are processed.
	Fix overflow of an internal array when parsing some replies
		from a milter.  Problem found by Scott Rotondo
		of Sun Microsystems.
	If STARTTLS is turned off in the server (via M=S) then it
		would not be initialized for use in the client either.
		Patch from Kazuteru Okahashi of IIJ.
	If a Diffie-Hellman cipher is selected for STARTTLS, the
		handshake could fail with some TLS implementations
		because the prime used by the server is not long enough.
		Note: the initialization of the DSA/DH parameters for
		the server can take a significant amount of time on slow
		machines. This can be turned off by setting DHParameters
		to none or a file (see doc/op/op.me).  Patch from
		Petr Lampa of the Brno University of Technology.
	Fix handling of `b' modifier for DaemonPortOptions on little
		endian machines for loopback address.  Patch from
		John Beck of Sun Microsystems.
	Fix a potential memory leak in libsmdb/smdb1.c found by parfait.
		Based on patch from Jonathan Gray of OpenBSD.
	If a milter sets the reply code to "421" during the transfer
		of the body, the SMTP server will terminate the SMTP session
		with that error to match the behavior of the other callbacks.
	Return EX_IOERR (instead of 0) if a mail submission fails due to
		missing disk space in the mail queue.  Based on patch
		from Martin Poole of RedHat.
	CONFIG: Using FEATURE(`ldap_routing')'s `nodomain' argument would
		cause addresses not found in LDAP to be misparsed.
	CONFIG: Using a CN restriction did not work for TLS_Clt as it
		referred to a wrong macro.  Patch from John Gardiner
		Myers of Proofpoint.
	CONFIG: The option relaytofulladdress of FEATURE(`access_db')
		did not work if FEATURE(`relay_hosts_only') is used too.
		Problem noted by Kristian Shaw.
	CONFIG: The internal function lower() was broken and hence
		strcasecmp() did not work either, which could cause
		problems for some FEATURE()s if upper case arguments
		were used.  Patch from Vesa-Matti J Kari of the
		University of Helsinki.
	LIBMILTER: Fix internal check whether a milter application
		is compiled against the same version of libmilter as
		it is linked against (especially useful for dynamic
		libraries).
	LIBMILTER: Fix memory leak that occurred when smfi_setsymlist()
		was used.  Based on patch by Dan Lukes.
	LIBMILTER: Document the effect of SMFIP_HDR_LEADSPC for filters
		which add, insert, or replace headers.  From Benjamin
		Pineau.
	LIBMILTER: Fix error messages which refer to "select()" to be
		correct if SM_CONF_POLL is used.  Based on patch from
		John Nemeth.
	LIBSM: Fix handling of LDAP search failures where the error is
		carried in the search result itself, such as seen with
		OpenLDAP proxy servers.
	VACATION: Do not refer to a local variable outside its scope.
		Based on patch from Mark Costlow of Southwest Cyberport.
	Portability:
		Enable HAVE_NANOSLEEP for SunOS 5.11. Patch from
		John Beck of Sun Microsystems.
		Drop NISPLUS from default SunOS 5.11 map definitions.
		Patch from John Beck of Sun Microsystems.

8.14.3/8.14.3	2008/05/03
	During ruleset processing the generation of a key for a map
		lookup and the parsing of the default value was broken
		for some macros, e.g., $|, which caused the BlankSub
		character to be inserted into the workspace and thus
		failures, e.g., rules that should have matched did not.
	8.14.2 caused a regression: it accessed (macro) storage which was
		freed before. First instance of the problem reported by
		Matthew Dillon of DragonFlyBSD; variations of the same
		bug reported by Todd C. Miller of OpenBSD, Moritz
		Jodeit, and Dave Hayes.
	Improve pathname length checks for persistent host status.  Patch
		from Joerg Sonnenberger of DragonFlyBSD.
	Reword misleading SMTP reply text for FEATURE(`badmx').  Problem
		noted by Beth Halsema.
	The read timeout was fixed to be Timeout.datablock if STARTTLS
		was activated. This may cause problems if that value
		is lowered from its default. Problem noted by Jens Elkner.
	CONFIG: Using LOCAL_TLS_CLIENT caused the tls_client ruleset
		to operate incorrectly.  Problem found by Werner Wiethege.
	LIBMILTER: Omitting some protocol steps via the xxfi_negotiate()
		callback did not work properly. The patchlevel of
		libmilter has been set to 1 so a milter can determine
		whether libmilter contains this fix.
	MAKEMAP: If a delimiter is specified (-t) use that also when
		dumping a map.  Patch from Todd C. Miller of OpenBSD.
	Portability:
		Add support for Darwin 9.x (Mac OS X 10.5).
		Support shared libraries in Darwin 8 and 9.  Patch from
		Chris Behrens of Concentric.
		Add support for SCO OpenServer 6, patch from Boyd Gerber.
	DEVTOOLS: Clarify that confSHAREDLIBDIR requires a trailing slash.
	Added Files:
		devtools/OS/Darwin.9.x
		devtools/OS/OSR.i386

8.14.2/8.14.2	2007/11/01
	If a message was queued and it contained 8 bit characters in
		a From: or To: header, then those characters could be
		"mistaken" for internal control characters during a queue
		run and trigger various consistency checks.  Problem
		noted by Neil Rickert of Northern Illinois University.
	If MaxMimeHeaderLength is set to a value greater than 0 (which
		it is by default) then even if the Linelimit parameter
		is 0, sendmail corrupted in the non-transfer-encoding
		case every MAXLINE-1 characters.  Patch from John Gardiner
		Myers of Proofpoint.
	Setting the suboption DeliveryMode for DaemonPortOptions did not
		work in earlier 8.14 versions.
	Note: DeliveryMode=interactive is silently converted to
		background if a milter can reject or delete a recipient.
		Prior to 8.14 this happened only if milter could delete
		recipients.
	ClientRate should trigger when the limit was exceeded (as
		documented), not when it was reached.  Patch from
		John Beck of Sun Microsystems.
	Force a queue run for -qGqueuegroup even if no runners are
		specified (R=0) and forking (F=f) is requested.
	When multiple results are requested for a DNS map lookup
		(-z and -Z), return only those that are relevant for
		the query (not also those in the "additional section".)
	If the message transfer time to sendmail (when acting as server)
		exceeds Timeout.queuewarn or Timeout.queuereturn and
		the message is refused (by a milter), sendmail previously
		created a delivery status notification (DSN).  Patch
		from Doug Heath of The Hertz Corporation.
	A code change in Cyrus-SASL 2.1.22 for sasl_decode64() requires
		the MTA to deal with some input (i.e., "=") itself.
		Problem noted by Eliot Lear.
	sendmail counted a delivery as successful if PIPELINING is
		compiled in but not offered by the server and the
		delivery failed temporarily.  Patch from Werner Wiethege.
	If getting the result of an LDAP query times out then close the
		map so it will be reopened on the next lookup.  This
		should help "failover" configurations that specify more
		than one LDAP server.
	If check_compat returns $#discard then a "savemail panic" could
		be triggered under some circumstances (e.g., requiring
		a system which does not have the compile time flag
		HASFLOCK set). Based on patch by Motonori Nakamura
		of National Institute of Informatics, Japan.
	If a milter rejected a recipient, the count for nrcpts= in the
		logfile entry might have been wrong.  Problem found by
		Petra Humann of TU Dresden.
	If a milter invoked smfi_chgfrom() where ESMTP arguments are not
		NULL, the message body was lost.  Patch from Motonori
		Nakamura of National Institute of Informatics, Japan.
	sendmail(8) had a bogus space in -qGname.  Patch from Peng Haitao.
	CONTRIB: buildvirtuser: Preserve ownership and permissions when
		replacing files.
	CONTRIB: buildvirtuser: Skip dot-files (e.g., .cvsignore) when
		reading the /etc/mail/virtusers/ directory.
	CONTRIB: buildvirtuser: Emit warnings instead of exiting where
		appropriate.
	LIBMILTER: Fix ABI backwards compatibility so milters compiled
		against an older libmilter.so shared library can use an
		8.14 libmilter.so shared library.
	LIBMILTER: smfi_version() did not properly extract the patchlevel
		from the version number, however, the returned value was
		correct for the current libmilter version.

8.14.1/8.14.1	2007/04/03
	Even though a milter rejects a recipient the MTA will still keep
		it in its list of recipients and deliver to it if the
		transaction is accepted. This is a regression introduced
		in 8.14.0 due to the change for SMFIP_RCPT_REJ.  Bug
		found by Andy Fiddaman.
	The new DaemonPortOptions which begin with a lower case character
		could not be set in 8.14.0.
	If a server shut down the connection in response to a STARTTLS
		command, sendmail would log a misleading error message
		due to an internal inconsistency.  Problem found by
		Werner Wiethege.
	Document how some sendmail.cf options change the behavior of mailq.
		Noted by Paul Menchini of the North Carolina School of
		Science and Mathematics.
	CONFIG: Add confSOFT_BOUNCE m4 option for setting SoftBounce.
	CONFIG: 8.14.0's RELEASE_NOTES failed to mention the addition
		of the confMAX_NOOP_COMMANDS and confSHARED_MEMORY_KEY_FILE
		m4 options for setting MaxNOOPCommands and
		SharedMemoryKeyFile.
	CONFIG: Add confMILTER_MACROS_EOH and confMILTER_MACROS_DATA m4
		options for setting Milter.macros.eoh and Milter.macros.data.
	CONTRIB: Use flock() and fcntl() in qtool.pl if necessary.
		Patch from Daniel Carroll of Mesa State College.
	LIBMILTER: Make sure an unknown command does not affect the
		currently available macros.  Problem found by Andy Fiddaman.
	LIBMILTER: The MTA did not offer SMFIF_SETSYMLIST during option
		negotiation.  Problem reported by Bryan Costales.
	LIBMILTER: Fix several minor errors in the documentation.
		Patches from Bryan Costales.
	PORTABILITY FIXES:
		AIX 5.{1,2}: libsm/util.c failed to compile due to
			redefinition of several macros, e.g., SIG_ERR.
			Patch from Jim Pirzyk with assistance by Bob
			Booth, University of Illinois at Urbana-Champaign.
		Add support for QNX.6.  Patch from Sean Boudreau of QNX
			Software Systems.
	New Files:
		devtools/M4/depend/QNX6.m4
		devtools/OS/QNX.6.x
		include/sm/os/sm_os_qnx.h

	New Files added in 8.14.0, but not shown in the release notes entry:
		libmilter/docs/smfi_chgfrom.html
		libmilter/docs/smfi_version.html

8.14.0/8.14.0	2007/01/31
	Header field values are now 8 bit clean.  Notes:
		- header field names are still restricted to 7 bit.
		- RFC 2822 allows only 7 bit (US-ASCII) characters in
		  headers.
	Preserve spaces after the colon in a header.  Previously, any
		number of spaces after the colon would be changed to
		exactly one space.
	In some cases of deeply nested aliases/forwarding, mail can
		be silently lost.  Moreover, the MaxAliasRecursion
		limit may be reached too early, e.g., the counter
		may be off by a factor of 4 in case of a sequence of
		.forward files that refer to others.  Patch from
		Motonori Nakamura of Kyoto University.
	Fix a regression in 8.13.8: if InputMailFilters is set then
		"sendmail -bs" can trigger an assertion because the
		hostname of the client is undefined.  It is now set
		to "localhost" for the xxfi_connect() callback.
	Avoid referencing a freed variable during cleanup when terminating.
		Problem reported and diagnosed by Joe Maimon.
	New option HeloName to set the name for the HELO/EHLO command.
		Patch from Nik Clayton.
	New option SoftBounce to issue temporary errors (4xy) instead of
		permanent errors (5xy).  This can be useful for testing.
	New suboptions for DaemonPortOptions to set them individually
		per daemon socket:
			DeliveryMode	DeliveryMode
			refuseLA	RefuseLA
			delayLA		DelayLA
			queueLA		QueueLA
			children	MaxDaemonChildren
	New option -K for LDAP maps to replace %1 through %9 in the
		lookup key with the LDAP escaped contents of the
		arguments specified in the map lookup.  Loosely based
		on patch from Wolfgang Hottgenroth.
	Log the time after which a greet_pause delay triggered.  Patch
		from Nik Clayton.
	If a client is rejected via TCP wrapper or some other check
		performed by validate_connection() (in conf.c) then do
		not also invoke greet_pause.  Problem noted by Jim Pirzyk
		of the University of Illinois at Urbana-Champaign.
	If a client terminates the SMTP connection during a pause
		introduced by greet_pause, then a misleading message
		was logged previously.  Problem noted by Vernon Schryver
		et.al., patch from Matej Vela.
	New command "mstat" for control socket to provide "machine
		readable" status.
	New named config file rule check_eom which is called at the end
		of a message, its parameter is the size of the message.
	If the macro {addr_type} indicates that the current address
		is a header address it also distinguishes between
		recipient and sender addresses (as it is done for
		envelope addresses).
	When a macro is set in check_relay, then its value is accessible
		by all transactions in the same SMTP session.
	Increase size of key for ldap lookups to 1024 (MAXKEY).
	New option MaxNOOPCommands to override default of 20 for the
		number of "useless" commands before the SMTP server will
		slow down responding.
	New option SharedMemoryKeyFile: if shared memory support is
		enabled, the MTA can be asked to select a shared memory
		key itself by setting SharedMemoryKey to -1 and specifying
		a file where to store the selected key.
	Try to deal with open HTTP proxies that are used to send spam
		by recognizing some commands from them. If the first command
		from the client is GET, POST, CONNECT, or USER, then the
		connection is terminated immediately.
	New PrivacyOptions noactualrecipient to avoid putting
		X-Actual-Recipient lines in DSNs revealing the actual
		account that addresses map to.  Patch from Dan Harkless.
	New options B, z, and Z for DNS maps:
		-B: specify a domain that is always appended to queries.
		-z: specify the delimiter at which to cut off the result of
			a query if it is too long.
		-Z: specify the maximum number of entries to be concatenated
			to form the result of a lookup.
	New target "check" in the Makefile of libsm: instead of running tests
		implicitly while building libsm, they must be explicitly
		started by using "make check".
	Fixed some inconsistent checks for NULL pointers that have been
		reported by the SATURN tool which has been developed by
		Isil Dillig and Thomas Dillig of Stanford University.
	Fix a potential race condition caused by a signal handler for
		terminated child processes.  Problem noted by David F. Skoll.
	When a milter deleted a recipient, that recipient could cause a
		queue group selection. This has been disabled as it was not
		intended.
	New operator 'r' for the arith map to return a random number.
		Patch from Motonori Nakamura of Kyoto University.
	New compile time option MILTER_NO_NAGLE to turn off the Nagle
		algorithm for communication with libmilter ("cork" on Linux),
		which may improve the communication performance on some
		operating systems.  Patch from John Gardiner Myers of
		Proofpoint.
	If sendmail received input that contained a CR without subsequent LF
		(thus violating RFC 2821 (2.3.7)), it could previously
		generate an additional blank line in the output as the last
		line.
	Restarting persistent queue runners by sending a HUP signal to
		the "queue control process" (QCP) works now.
	Increase the length of an input line to 12288 to deal with
		really long lines during SMTP AUTH negotiations.
		Problem noted by Werner Wiethege.
	If ARPANET mode (-ba) was selected STARTTLS would fail (due to
		a missing initialization call for that case).  Problem
		noted by Neil Rickert of Northern Illinois University.
	If sendmail is linked against a library that initializes Cyrus-SASL
		before sendmail did it (such as libnss-ldap), then SMTP AUTH
		could fail for the sendmail client.  A patch by Moritz Both
		works around the API design flaw of Cyrus-SASLv2.
	CONFIG: Make it possible to unset the StatusFile option by
		undefining STATUS_FILE.  By not setting StatusFile,
		the MTA will not attempt to open a statistics file on
		each delivery.
	CONFIG: New FEATURE(`require_rdns') to reject messages from SMTP
		clients whose IP address does not have proper reverse DNS.
		Contributed by Neil Rickert of Northern Illinois University
		and John Beck of Sun Microsystems.
	CONFIG: New FEATURE(`block_bad_helo') to reject messages from SMTP
		clients which provide a HELO/EHLO argument which is either
		unqualified, or is one of our own names (i.e., the server
		name instead of the client name).  Contributed by Neil
		Rickert of Northern Illinois University and John Beck of
		Sun Microsystems.
	CONFIG: New FEATURE(`badmx') to reject envelope sender addresses
		(MAIL) whose domain part resolves to a "bad" MX record.
		Based on contribution from William Dell Wisner.
	CONFIG: New macros SMTP_MAILER_LL and RELAY_MAILER_LL to override
		the maximum line length of the smtp mailers.
	CONFIG: New option `relaytofulladdress' for FEATURE(`access_db')
		to allow entries in the access map to be of the form
			To:user@example.com	RELAY
	CONFIG: New subsuboptions eoh and data to specify the list of
		macros a milter should receive at those stages in the
		SMTP dialogue.
	CONFIG: New option confHELO_NAME for HeloName to set the name
		for the HELO/EHLO command.
	CONFIG: dnsbl and enhdnsbl can now also discard or quarantine
		messages by using those values as second argument.
		Patches from Nelson Fung.
	CONTRIB: cidrexpand uses a hash symbol as comment character and
		ignores everything after it unless it is in quotes or
		preceded by a backslash.
	DEVTOOLS: New macro confMKDIR: if set to a program that creates
		directories, then it used for "make install" to create
		the required installation directories.
	DEVTOOLS: New macro confCCLINK to specify the linker to use for
		executables (defaults to confCC).
	LIBMILTER: A new version of the milter API has been created that
		has several changes which are listed below and documented
		in the webpages reachable via libmilter/docs/index.html.
	LIBMILTER: The meaning of the version macro SMFI_VERSION has been
		changed.  It now refers only to the version of libmilter,
		not to the protocol version (which is used only internally,
		it is not user/milter-programmer visible).  Additionally,
		a version function smfi_version() has been introduced such
		that a milter program can check the libmilter version also
		at runtime which is useful if a shared library is used.
	LIBMILTER: A new callback xxfi_negotiate() can be used to
		dynamically (i.e., at runtime) determine the available
		protocol actions and features of the MTA and also to
		specify which of these a milter wants to use.  This allows
		for more flexibility than hardcoding these flags in the
		xxfi_flags field of the smfiDesc structure.
	LIBMILTER: A new callback xxfi_data() is available so milters
		can act on the DATA command.
	LIBMILTER: A new callback xxfi_unknown() is available so milters
		can receive also unknown SMTP commands.
	LIBMILTER: A new return code SMFIS_NOREPLY has been added which
		can be used by the xxfi_header() callback provided the
		milter requested the SMFIP_NOHREPL protocol action.
	LIBMILTER: The new return code SMFIS_SKIP can be used in the
		xxfi_body() callback to skip over further body chunks
		and directly advance to the xxfi_eom() callback.  This
		is useful if a milter can make a decision based on the
		body chunks it already received without reading the entire
		rest of the body and the milter wants to invoke functions
		that are only available from the xxfi_eom() callback.
	LIBMILTER: A new function smfi_addrcpt_par() can be used to add
		new recipients including ESMTP parameters.
	LIBMILTER: A new function smfi_chgfrom() can be used to change the
		envelope sender including ESMTP parameters.
	LIBMILTER: A milter can now request to be informed about rejected
		recipients (RCPT) too.  This requires to set the protocol
		flag SMFIP_RCPT_REJ during option negotiation.  Whether
		a RCPT has been rejected can be checked by comparing the
		value of the macro {rcpt_mailer} with "error".
	LIBMILTER: A milter can now override the list of macros that it
		wants to receive from the MTA for each protocol step
		by invoking the function smfi_setsymlist() during option
		negotiation.
	LIBMILTER: A milter can receive header field values with all
		leading spaces by requesting the SMFIP_HDR_LEADSPC
		protocol action.  Also, if the flag is set then the MTA
		does not add a leading space to headers that are added,
		inserted, or replaced.
	LIBMILTER: If a milter sets the reply code to "421" for the HELO
		callback, the SMTP server will terminate the SMTP session
		with that error to match the behavior of all other callbacks.
	New Files:
		cf/feature/badmx.m4
		cf/feature/block_bad_helo.m4
		cf/feature/require_rdns.m4
		devtools/M4/UNIX/check.m4
		include/sm/misc.h
		include/sm/sendmail.h
		include/sm/tailq.h
		libmilter/docs/smfi_addrcpt_par.html
		libmilter/docs/smfi_setsymlist.html
		libmilter/docs/xxfi_data.html
		libmilter/docs/xxfi_negotiate.html
		libmilter/docs/xxfi_unknown.html
		libmilter/example.c
		libmilter/monitor.c
		libmilter/worker.c
		libsm/memstat.c
		libsm/t-memstat.c
		libsm/t-qic.c
		libsm/util.c
		sendmail/daemon.h
		sendmail/map.h

8.13.8/8.13.8	2006/08/09
	Fix a regression in 8.13.7: if shared memory is activated, then
		the server can erroneously report that there is
		insufficient disk space.  Additionally make sure that
		an internal variable is set properly to avoid those
		misleading errors.  Based on patch from Steve Hubert
		of University of Washington.
	Fix a regression in 8.13.7: the PidFile could be removed after
		the process that forks the daemon exited, i.e., if
		sendmail -bd is invoked.  Problem reported by Kan Sasaki
		of Fusion Communications Corp. and Werner Wiethege.
	Avoid opening qf files if QueueSortOrder is "none".  Patch from
		David F. Skoll.
	Avoid a crash when finishing due to referencing a freed variable.
		Problem reported and diagnosed by Moritz Jodeit.
	CONTRIB: cidrexpand now deals with /0 by issuing the entire IPv4
		range (0..255).
	LIBMILTER: The "hostname" argument of the xxfi_connect() callback
		previously was the equivalent of {client_ptr}.  However,
		this did not match the documentation of the function, hence
		it has been changed to {client_name}.  See doc/op/op.me
		about these macros.

8.13.7/8.13.7	2006/06/14
	A malformed MIME structure with many parts can cause sendmail to
		crash while trying to send a mail due to a stack overflow,
		e.g., if the stack size is limited (ulimit -s).  This
		happens because the recursion of the function mime8to7()
		was not restricted.  The function is called for MIME 8 to
		7 bit conversion and also to enforce MaxMimeHeaderLength.
		To work around this problem, recursive calls are limited to
		a depth of MAXMIMENESTING (20); message content after this
		limit is treated as opaque and is not checked further.
		Problem noted by Frank Sheiness.
	The changes to the I/O layer in 8.13.6 caused a regression for
		SASL mechanisms that use the security layer, e.g.,
		DIGEST-MD5.  Problem noted by Robert Stampfli.
	If a timeout occurs while reading a message (during the DATA phase)
		a df file might have been left behind in the queue.
		This was another side effect of the changes to the I/O
		layer made in 8.13.6.
	Several minor problems have been fixed that were found by a
		Coverity scan of sendmail 8 as part of the NetBSD
		distribution. See http://scan.coverity.com/
		Note: the scan generated also a lot of "false positives",
		e.g., "error" reports about situations that cannot happen.
		Most of those code places are marked with lint(1) comments
		like NOTREACHED, but Coverity does not understand those.
		Hence an explicit assertion has been added in some cases
		to avoid those false positives.
	If the start of the sendmail daemon fails due to a configuration
		error then in some cases shared memory segments or pid
		files were not removed.
	If DSN support is disabled via access_db, then related ESMTP
		parameters for MAIL and RCPT should be rejected.  Problem
		reported by Akihiro Sagawa.
	Enabling zlib compression in OpenSSL 0.9.8[ab] breaks the padding
		bug work-around.  Hence if sendmail is linked against
		either of these versions and compression is available,
		the padding bug work-around is turned off.  Based on
		patch from Victor Duchovni of Morgan Stanley.
	CONFIG: FEATURE(`dnsbl') and FEATURE(`enhdnsbl') used
		blackholes.mail-abuse.org as default domain for lookups,
		however, that list is no longer available.  To avoid
		further problems, no default value is available anymore,
		but an argument must be specified.
	Portability:
		Fix compilation on OSF/1 for sfsasl.c.  Patch from
		Pieter Bowman of the University of Utah.

8.13.6/8.13.6	2006/03/22
	SECURITY: Replace unsafe use of setjmp(3)/longjmp(3) in the server
		and client side of sendmail with timeouts in the libsm I/O
		layer and fix problems in that code.  Also fix handling of
		a buffer in sm_syslog() which could have been used as an
		attack vector to exploit the unsafe handling of
		setjmp(3)/longjmp(3) in combination with signals.
		Problem detected by Mark Dowd of ISS X-Force.
	Handle theoretical integer overflows that could triggered if
		the server accepted headers larger than the maximum
		(signed) integer value.  This is prevented in the default
		configuration by restricting the size of a header, and on
		most machines memory allocations would fail before reaching
		those values.  Problems found by Phil Brass of ISS.
	If a server returns 421 for an RSET command when trying to start
		another transaction in a session while sending mail, do
		not trigger an internal consistency check.  Problem found
		by Allan E Johannesen of Worcester Polytechnic Institute.
	If a server returns a 5xy error code (other than 501) in response
		to a STARTTLS command despite the fact that it advertised
		STARTTLS and that the code is not valid according to RFC
		2487 treat it nevertheless as a permanent failure instead
		of a protocol error (which has been changed to a
		temporary error in 8.13.5).  Problem reported by Jeff
		A. Earickson of Colby College.
	Clear SMTP state after a HELO/EHLO command.  Patch from John
		Myers of Proofpoint.
	Observe MinQueueAge option when gathering entries from the queue
		for sorting etc instead of waiting until the entries are
		processed.  Patch from Brian Fundakowski Feldman.
	Set up TLS session cache to properly handle clients that try to
		resume a stored TLS session.
	Properly count the number of (direct) child processes such that
		a configured value (MaxDaemonChildren) is not exceeded.
		Based on patch from Attila Bruncsak.
	LIBMILTER: Remove superfluous backslash in macro definition
		(libmilter.h).  Based on patch from Mike Kupfer of
		Sun Microsystems.
	LIBMILTER: Don't try to set SO_REUSEADDR on UNIX domain sockets.
		This generates an error message from libmilter on
		Solaris, though other systems appear to just discard the
		request silently.
	LIBMILTER: Deal with sigwait(2) implementations that return
		-1 and set errno instead of returning an error code
		directly.  Patch from Chris Adams of HiWAAY Informations
		Services.
	Portability:
		Fix compilation checks for closefrom(3) and statvfs(2)
		in NetBSD.  Problem noted by S. Moonesamy, patch from
		Andrew Brown.

8.13.5/8.13.5	2005/09/16
	Store the filesystem identifier of the df/ subdirectory (if it
		exists) in an internal structure instead of the base
		directory.  This structure is used decide whether there
		is enough free disk space when selecting a queue, hence
		without this change queue selection could fail if a df/
		subdirectory exists and is on a different filesystem
		than the base directory.
	Use the queue index of the df file (instead of the qf file) for
		checking whether a link(2) operation can be used to split
		an envelope across queue groups.  Problem found by
		Werner Wiethege.
	If the list of items in the queue is larger than the maximum
		number of items to process, sort the queue first and
		then cut the list off instead of the other way around.
		Patch from Matej Vela of Rudjer Boskovic Institute.
	Fix helpfile to show full entry for ETRN.  Problem noted by
		Penelope Fudd, patch from Neil Rickert of Northern Illinois
		University.
	FallbackSmartHost should also be tried on temporary errors.
		From John Beck of Sun Microsystems.
	When a server responds with 421 to the STARTTLS command then treat
		it as a temporary error, not as protocol error.  Problem
		noted by Andrey J. Melnikoff.
	Properly define two functions in libsm as static because their
		prototype used static too.  Patch from Peter Klein.
	Fix syntax errors in helpfile for MAIL and RCPT commands.
	LIBMILTER: When smfi_replacebody() is called with bodylen equals
		zero then do not silently ignore that call.  Patch from
		Gurusamy Sarathy of Active State.
	LIBMILTER: Recognize "421" also in a multi-line reply to terminate
		the SMTP session with that error.  Fix from Brian Kantor.
	Portability: New option HASSNPRINTF which can be set if the OS
			has a properly working snprintf(3) to get rid
			of the last two (safe) sprintf(3) calls in the
			source code.
		Add support for AIX 5.3.
		Add support for SunOS 5.11 (aka Solaris 11).
		Add support for Darwin 8.x.  Patch from Lyndon Nerenberg.
		OpenBSD 3.7 has removed support for NETISO.
	CONFIG: Add OSTYPE(freebsd6) for FreeBSD 6.X.
		Set DontBlameSendmail to AssumeSafeChown and
			GroupWritableDirPathSafe for OSTYPE(darwin).
			Patch from Lyndon Nerenberg.
		Some features still used 4.7.1 as enhanced status code which
			was supposed to be eliminated in 8.13.0 because some
			broken systems misinterpret it as a permanent error.
			Patch from Matej Vela of Rudjer Boskovic Institute.
		Some default values in a generated cf file did not match
			the defaults in the sendmail binary.  Problem noted
			by Mike Pechkin.
	New Files:
		cf/ostype/freebsd6.m4
		devtools/OS/AIX.5.3
		devtools/OS/Darwin.8.x
		devtools/OS/SunOS.5.11
		include/sm/time.h

8.13.4/8.13.4	2005/03/27
	The bug fixes in 8.13.3 for connection handling uncovered a
		different error which could result in connections that
		stay in CLOSE_WAIT state due to a variable that was not
		properly initialized.  Problem noted by Michael Sims.
	Deal with empty hostnames in hostsignature().  This bug could lead
		to an endless loop when doing LMTP deliveries to another
		host.  Problem first reported by Martin Lathoud and
		tracked down by Gael Roualland.
	Make sure return parameters are initialized in getmxrr().  Problem
		found by Gael Roualland using valgrind.
	If shared memory is used and the RunAsUser option is set, then the
		owner and group of the shared memory segment is set to
		the ids specified RunAsUser and the access mode is set
		to 0660 to allow for updates by sendmail processes.
	The number of queue entries that is (optionally) kept in shared
		memory was wrong in some cases, e.g., envelope splitting
		and bounce generation.
	Undo a change made in 8.13.0 to silently truncate long strings
		in address rewriting because the message can be triggered
		for header checks where long strings are legitimate.
		Problem reported by Mary Verge DeSisto, and tracked
		down with the help of John Beck of Sun Microsystems.
	The internal stab map did not obey the -m flag.  Patch from
		Rob McMahon of Warwick University, England.
	The socket map did not obey the -f flag.  Problem noted by
		Dan Ringdahl, forwarded by Andrzej Filip.
	The addition of LDAP recursion in 8.13.0 broke enforcement of
		the LDAP map -1 argument which tells the MTA to only
		return success if and only if a single LDAP match is found.
	Add additional error checks in the MTA for milter communication
		to avoid a possible segmentation fault.  Based on patch
		by Joe Maimon.
	Do not trigger an assertion if X509_digest() returns success but
		does not assign a value to its output parameter.  Based
		on patch by Brian Kantor.
	Add more checks when resetting internal AUTH data (applies only
		to Cyrus SASL version 2).  Otherwise an SMTP session might
		be dropped after an AUTH failure.
	Portability:
		Add LA_LONGLONG as valid LA_TYPE type for systems that use
			"long long" to read load average data, e.g.,
			AIX 5.1 in 32 bit mode.  Note: this has to be set
			"by hand", it is not (yet) automatically detected.
			Problem noted by Burak Bilen.
		Use socklen_t for accept(), etc. on AIX 5.x.  This should
			fix problems when compiling in 64 bit mode.
			Problem first reported by Harry Meiert of
			University of Bremen.
	New Files:
		include/sm/sem.h
		libsm/sem.c
		libsm/t-sem.c

8.13.3/8.13.3	2005/01/11
	Enhance handling of I/O errors, especially EOF, when STARTTLS
		is active.
	Make sure a connection is not reused after it has been closed
		due to a 421 error.  Problem found by Allan E Johannesen
		of Worcester Polytechnic Institute.
	Avoid triggering an assertion when sendmail is interrupted while
		closing a connection.  Problem found by Allan E Johannesen
		of Worcester Polytechnic Institute.
	Regression: a change in 8.13.2 caused sendmail not to try the
		next MX host (or FallbackMXhost if configured) when, at
		connection open, the current server returns a 4xy or 5xy
		SMTP reply code.  Problem noted by Mark Tranchant.

8.13.2/8.13.2	2004/12/15
	Do not split the first header even if it exceeds the internal
		buffer size.  Previously a part of such a header would
		end up in the body of the message.  Problem noted by
		Simple Nomad of BindView.
	Do not complain about "cataddr: string too long" when checking
		headers that do not contain RFC 2822 addresses.
		Problem noted by Rich Graves of Brandeis University.
	If a server returns a 421 reply to the RSET command between
		message deliveries, do not attempt to deliver any more
		messages on that connection.  This prevents bogus "Bad
		file number" recipient status.  Problem noted by
		Allan E Johannesen of Worcester Polytechnic Institute.
	Allow trailing white space in EHLO command as recommended by RFC
		2821.  Problem noted by Ralph Santagato of SBC Services.
	Deal with clients which use AUTH but negotiate a smaller buffer size
		for data exchanges than the value used by sendmail, e.g.,
		Cyrus IMAP lmtp server.  Based on patch by Jamie Clark.
	When passing ESMTP arguments for RCPT to a milter, do not cut
		them off at a comma.  Problem noted by Krzysztof Oledzki.
	Add more logging to milter change header functions to
		complement existing logging.  Based on patch from
		Gurusamy Sarathy of Active State.
	Include <lber.h> in include/sm/config.h when LDAPMAP is defined.
		Patch from Edgar Hoch of the University of Stuttgart.
	Fix DNS lookup if IPv6 is enabled when converting an IP address
		to a hostname for use with SASL.  Problem noted by Ken Jones;
		patch from Hajimu UMEMOTO.
	CONFIG: For consistency enable MODIFY_MAILER_FLAGS for the prog
		mailer.  Patch from John Beck of Sun Microsystems.
	LIBMILTER: It was possible that xxfi_abort() was called after
		xxfi_eom() for a message if some timeouts were triggered.
		Patch from Alexey Kravchuk.
	LIBMILTER: Slightly rearrange mutex use in listener.c to allow
		different threads to call smfi_opensocket() and smfi_main().
		Patch from Jordan Ritter of Cloudmark.
	MAIL.LOCAL: Properly terminate MBDB before exiting.  Problem
		noted by Nelson Fung.
	MAIL.LOCAL: make strip-mail.local used a wrong path to access
		mail.local.  Problem noted by William Park.
	VACATION: Properly terminate MBDB before exiting.  Problem noted
		by Nelson Fung.
	Portability:
		Add support for DragonFly BSD.
	New Files:
		cf/ostype/dragonfly.m4
		devtools/OS/DragonFly
		include/sm/os/sm_os_dragonfly.h
	Deleted Files:
		libsm/vsscanf.c

8.13.1/8.13.1	2004/07/30
	Using the default AliasFile ldap: specification would cause the
		objectClasses of the LDAP response to be included in the
		alias expansion.  Problem noted by Brenden Conte of
		Rensselaer Polytechnic Institute.
	Fix support for a fallback smart host for system where DNS is
		(partially) available. From John Beck of Sun Microsystems.
	Fix SuperSafe=PostMilter behavior when a milter replaces a body
		but the data file is not yet stored on disk because it is
		smaller than the size of the memory buffer.  Problem noted
		by David Russell.
	Fix certificate revocation list support; if a CRL was specified
		but the other side presented a cert that was signed by
		a different (trusted) CA than the one which issued the CRL,
		verification would always fail.  Problem noted by Al Smith.
	Run mailer programs as the RunAsUser when RunAsUser is set and
		the F=S mailer flag is set without a U= mailer equate.
		Problem noted by John Gardiner Myers of Proofpoint.
	${nbadrcpts} was off by one if BadRcptThrottle is zero.
		Patch from Sung-hoon Choi of DreamWiz Inc.
	CONFIG: Emit a warning if FEATURE(`access_db') is used after
		FEATURE(`greet_pause') because then the latter will not
		use the access map.  Note: if no default value is given
		for FEATURE(`greet_pause') then it issues an error if
		FEATURE(`access_db') is not specified before it.
		Problem noted by Alexander Dalloz of University of
		Bielefeld.
	CONFIG: Invoke ruleset Local_greet_pause if FEATURE(`greet_pause')
		is used to give more flexibility for local changes.
	Portability:
		Fix a 64 bit problem in the socket map code.  Problem
			noted by Geoff Adams.
		NetBSD 2.0F has closefrom(3).  Patch from Andrew Brown.
		NetBSD can use sysctl(3) to get the number of CPUs in
			a system.  Patch from Andrew Brown.
		Add a README file in doc/op/ to explain potential
			incompatibilities with various *roff related
			tools.  Problem tracked down by Per Hedeland.
	New Files:
		doc/op/README

8.13.0/8.13.0	2004/06/20
	Do not include AUTH data in a bounce to avoid leaking confidential
		information.  See also cf/README about MSP and the section
		"Providing SMTP AUTH Data when sendmail acts as Client".
		Problem noted by Neil Rickert of Northern Illinois
		University.
	Fix compilation error in libsm/clock.c for -D_FFR_SLEEP_USE_SELECT=n
		and -DSM_CONF_SETITIMER=0.  Problem noted by Juergen Georgi
		of RUS University of Stuttgart.
	Fix bug in conversion from 8bit to quoted-printable. Problem found
		by Christof Haerens, patch from Per Hedeland.
	Add support for LDAP recursion based on types given to attribute
		specifications in an LDAP map definition.  This allows
		LDAP queries to return a new query, a DN, or an LDAP
		URL which will in turn be queried.  See the ``LDAP
		Recursion'' section of doc/op/op.me for more information.
		Based on patch from Andrew Baucom.
	Extend the default LDAP specifications for AliasFile
		(O AliasFile=ldap:) and file classes (F{X}@LDAP) to
		include support for LDAP recursion via new attributes.
		See ``USING LDAP FOR ALIASES, MAPS, and CLASSES'' section
		of cf/README for more information.
	New option for LDAP maps: the -w option allows you to specify the
		LDAP API/protocol version to use.  The default depends on
		the LDAP library.
	New option for LDAP maps: the -H option allows you to specify an
		LDAP URI instead of specifying the LDAP server via -h host
		and -p port.  This also allows for the use of LDAP over
		SSL and connections via named sockets if your LDAP
		library supports it.
	New compile time flag SM_CONF_LDAP_INITIALIZE: set this if
		ldap_initialize(3) is available (and LDAPMAP is set).
	If MaxDaemonChildren is set and a command is repeated too often
		during a SMTP session then terminate it just like it is
		done for too many bad SMTP commands.
	Basic connection rate control support has been added: the daemon
		maintains the number of incoming connections per client
		IP address and total in the macros {client_rate} and
		{total_rate}, respectively.  These macros can be used
		in the cf file to impose connection rate limits.
		A new option ConnectionRateWindowSize (default: 60s)
		determines the length of the interval for which the
		number of connections is stored.  Based on patch from
		Jose Marcio Martins da Cruz, Ecole des Mines de Paris.
	Add optional protection from open proxies and SMTP slammers which
		send SMTP traffic without waiting for the SMTP greeting.
		If enabled by the new ruleset greet_pause (see
		FEATURE(`greet_pause')), sendmail will wait the specified
		amount of time before sending the initial 220 SMTP
		greeting.  If any traffic is received before then, a 554
		SMTP response is sent and all SMTP commands are rejected
		during that connection.
	If 32 NOOP (or unknown/bad) commands are issued by a client the SMTP
		server could sleep for a very long time.  Fix based on
		patch from Tadashi Kobayashi of IIJ.
	Fix a potential memory leak in persistent queue runners if the
		number of entries in the queue exceeds the limit of jobs.
		Problem noted by Steve Hubert of University of Washington.
	Do not use 4.7.1 as enhanced status code because some broken systems
		misinterpret it as a permanent error.
	New value for SuperSafe: PostMilter which will delay fsync() until
		all milters accepted the mail.  This can increase
		performance if many mails are rejected by milters due to
		body scans.  Based on patch from David F. Skoll.
	New macro {msg_id} which contains the value of the Message-Id:
		header, whether provided by the client or generated by
		sendmail.
	New macro {client_connections} which contains the number of open
		connections in the SMTP server for the client IP address.
		Based on patch from Jose Marcio Martins da Cruz, Ecole des
		Mines de Paris.
	sendmail will now remove its pidfile when it exits.  This was done
		to prevent confusion caused by running sendmail stop
		scripts two or more times, where the second and subsequent
		runs would report misleading error messages about sendmail's
		pid no longer existing.  See section 1.3.15 of doc/op/op.me
		for a discussion of the implications of this, including
		how to correct broken scripts which may have depended on
		the old behavior.  From John Beck of Sun Microsystems.
	Support per-daemon input filter lists which override the default
		filter list specified in InputMailFilters.  The filters
		can be listed in the I= equate of DaemonPortOptions.
	Do not add all domain prefixes of the hostname to class 'w'.  If
		your configuration relies on this behavior, you have to
		add those names to class 'w' yourself.  Problem noted
		by Sander Eerkes.
	Support message quarantining in the mail queue.  Quarantined
		messages are not run on normal queue displays or runs
		unless specifically requested with -qQ.  Quarantined queue
		files are named with an hf prefix instead of a qf prefix.
	The -q command line option now can specify which queue to display
		or run.  -qQ operates on quarantined queue items.  -qL
		operates on lost queue items.
	Restricted mail queue runs and displays can be done based on the
		quarantined reason using -qQtext to run or display
		quarantined items if the quarantine reason contains the
		given text.  Similarly, -q!Qtext will run or display
		quarantined items which do not have the given text in the
		quarantine reason.
	Items in the queue can be quarantined or unquarantined using the
		new -Q option.  See doc/op/op.me for more information.
	When displaying the quarantine mailq with 'mailq -qQ', the
		quarantine reason is shown in a new line prefixed by
		"QUARANTINE:".
	A new error code for the $#error mailer, $@ quarantine, can be used
		to quarantine messages in check_* (except check_compat) and
		header check rulesets.  The $: of the mailer triplet will
		be used for the quarantine reason.
	Add a new quarantine count to the mailstats collected.
	Add a new macro ${quarantine} which is the quarantine reason for a
		message if it is quarantined.
	New map type "socket" for a trivial query protocol over UNIX domain
		or TCP sockets (requires compile time option SOCKETMAP).
		See sendmail/README and doc/op/op.me for details as well as
		socketmapServer.pl and socketmapClient.pl in contrib.
		Code donated by Bastiaan Bakker of LifeLine Networks.
	Define new macro ${client_ptr} which holds the result of the PTR
		lookup for the client IP address.  Note: this is the same
		as ${client_name} if and only if ${client_resolve} is OK.
	Add a new macro ${nbadrcpts} which contains the number of bad
		recipients received so far in a transaction.
	Call check_relay with the value of ${client_name} to deal with bogus
		DNS entries.  See also FEATURE(`use_client_ptr').  Problem
		noted by Kai Schlichting.
	Treat Delivery-Receipt-To: headers the same as Return-Receipt-To:
		headers (turn them into DSNs).  Delivery-Receipt-To: is
		apparently used by SIMS (Sun Internet Mail System).
	Enable connection caching for LPC mailers.  Patch from Christophe
		Wolfhugel of France Telecom Oleane.
	Do not silently truncate long strings in address rewriting.
	Add support for Cyrus SASL version 2.  From Kenneth Murchison of
		Oceana Matrix Ltd.
	Add a new AuthOption=m flag to require the use of mechanisms which
		support mutual authentication.  From Kenneth Murchison of
		Oceana Matrix Ltd.
	Fix logging of TLS related problems (introduced in 8.12.11).
	The macros {auth_author} and {auth_authen} are stored in xtext
		format just like the STARTTLS related macros to avoid
		problems with parsing them.  Problem noted by Pierangelo
		Masarati of SysNet s.n.c.
	New option AuthRealm to set the authentication realm that is
		passed to the Cyrus SASL library.  Patch from Gary Mills
		of the University of Manitoba.
	Enable AUTH mechanism EXTERNAL if STARTTLS verification was
		successful, otherwise relaying would be allowed if
		EXTERNAL is listed in TRUST_AUTH_MECH() and STARTTLS
		is active.
	Add basic support for certificate revocation lists.  Note: if a
		CRLFile is specified but the file is unusable, STARTTLS
		is disabled.  Based on patch by Ralf Hornik.
	Enable workaround for inconsistent Cyrus SASLv1 API for mechanisms
		DIGEST-MD5 and LOGIN.
	Write pid to file also if sendmail only acts as persistent queue
		runner.  Proposed by Gary Mills of the University of Manitoba.
	Keep daemon pid file(s) locked so other daemons don't try to
		overwrite each other's pid files.
	Increase maximum length of logfile fields for {cert_subject} and
		{cert_issuer} from 128 to 256.  Requested by Christophe
		Wolfhugel of France Telecom.
	Log the TLS verification message on the STARTTLS= log line at
		LogLevel 12 or higher.
	If the MSP is invoked with the verbose option (-v) then it will
		try to use the SMTP command VERB to propagate this option
		to the MTA which in turn will show the delivery just like
		it was done before the default 8.12 separation of MSP and
		MTA.  Based on patch by Per Hedeland.
	If a daemon is refusing connections for longer than the time specified
		by the new option RejectLogInterval (default: 3 hours) due
		to high load, log this information.  Patch from John Beck
		of Sun Microsystems.
	Remove the ability for non-trusted users to raise the value of
		CheckpointInterval on the command line.
	New mailer flag 'B' to strip leading backslashes, which is a
		subset of the functionality of the 's' flag.
	New mailer flag 'W' to ignore long term host status information.
		Patch from Juergen Georgi of RUS University of Stuttgart.
	Enable generic mail filter API (milter) by default.  To turn
		it off, add -DMILTER=0 to the compile time options.
	An internal SMTP session discard flag was lost after an RSET/HELO/EHLO
		causing subsequent messages to be sent instead of being
		discarded.  This also caused milter callbacks to be called
		out of order after the SMTP session was reset.
	New option RequiresDirfsync to turn off the compile time flag
		REQUIRES_DIR_FSYNC at runtime.  See sendmail/README for
		further information.
	New command line option -D logfile to send debug output to
		the indicated log file instead of stdout.
	Add Timeout.queuereturn.dsn and Timeout.queuewarn.dsn to control
		queue return and warning times for delivery status
		notifications.
	New queue sort order option: 'n'one for not sorting the queue entries
		at all.
	Several more return values for ruleset srv_features have been added
		to enable/disable certain features in the server per
		connection.  See doc/op/op.me for details.
	Support for SMTP over SSL (smtps), activated by Modifier=s
		for DaemonPortOptions.
	Continue with DNS lookups on ECONNREFUSED and TRY_AGAIN when
		trying to canonify hostnames.  Suggested by Neil Rickert
		of Northern Illinois University.
	Add support for a fallback smart host (option FallbackSmartHost) to
		be tried as a last resort after all other fallbacks.  This
		is designed for sites with partial DNS (e.g., an accurate
		view of inside the company, but an incomplete view of
		outside).  From John Beck of Sun Microsystems.
	Enable timeout for STARTTLS even if client does not start the TLS
		handshake.  Based on patch by Andrey J. Melnikoff.
	Remove deprecated -v option for PH map, use -k instead.  Patch from
		Mark Roth of the University of Illinois at Urbana-Champaign.
	libphclient is version 1.2.x by default, if version 1.1.x is required
		then compile with -DNPH_VERSION=10100.  Patch from Mark Roth
		of the University of Illinois at Urbana-Champaign.
	Add Milter.macros.eom, allowing macros to be sent to milter
		applications for use in the xxfi_eom() callback.
	New macro {time} which contains the output of the time(3) function,
		i.e., the number of seconds since 0 hours, 0 minutes,
		0 seconds, January 1, 1970, Coordinated Universal Time (UTC).
	If check_relay sets the reply code to "421" the SMTP server will
		terminate the SMTP session with a 421 error message.
	Get rid of dead code that tried to access the environment variable
		HOSTALIASES.
	Deprecate the use of ErrorMode=write.  To enable this in 8.13
		compile with -DUSE_TTYPATH=1.
	Header check rulesets using $>+ (do not strip comments) will get
		the header value passed in without balancing quotes,
		parentheses, and angle brackets.  Based on patch from
		Oleg Bulyzhin.
	Do not complain and fix up unbalanced quotes, parentheses, and
		angle brackets when reading in rulesets.  This allows
		rules to be written for header checks to catch strings
		that contain quotes, parentheses, and/or angle brackets.
		Based on patch from Oleg Bulyzhin.
	Do not close socket when accept(2) in the daemon encounters
		some temporary errors like ECONNABORTED.
	Added list of CA certificates that are used by members of the
		sendmail consortium, see CACerts.
	Portability:
		Two new compile options have been added:
			HASCLOSEFROM	System has closefrom(3).
			HASFDWALK	System has fdwalk(3).
			Based on patch from John Beck of Sun Microsystems.
		The Linux kernel version 2.4 series has a broken flock() so
			change to using fcntl() locking until they can fix
			it.  Be sure to update other sendmail related
			programs to match locking techniques.
		New compile time option NEEDINTERRNO which should be set
			if <errno.h> does not declare errno itself.
		Support for UNICOS/mk and UNICOS/mp added, some changes for
			UNICOS.  Patches contributed by Aaron Davis and
			Brian Ginsbach, Cray Inc., and Manu Mahonen of
			Center for Scientific Computing.
		Add support for Darwin 7.0/Mac OS X 10.3 (a.k.a. Panther).
		Extend support to Darwin 7.x/Mac OS X 10.3 (a.k.a. Panther).
		Remove path from compiler definition for Interix because
			Interix 3.0 and 3.5 put gcc in different locations.
			Also use <sys/mkdev.h> to get the correct
			major()/minor() definitions.  Based on feedback
			from Mark Funkenhauser.
	CONFIG: Add support for LDAP recursion to the default LDAP searches
		for maps via new attributes.  See the ``USING LDAP FOR
		ALIASES, MAPS, and CLASSES'' section of cf/README and
		cf/sendmail.schema for more information.
	CONFIG: Make sure confTRUSTED_USER is valid even if confRUN_AS_USER
		is of the form "user:group" when used for submit.mc.
		Problem noted by Carsten P. Gehrke, patch from Neil Rickert
		of Northern Illinois University.
	CONFIG: Add a new access DB value of QUARANTINE:reason which
		instructs the check_* (except check_compat) to quarantine
		the message using the given reason.
	CONFIG: Use "dns -R A" as map type for dnsbl (just as for enhdnsbl)
		instead of "host" to avoid problem with looking up other
		DNS records than just A.
	CONFIG: New option confCONNECTION_RATE_WINDOW_SIZE to define the
		length of the interval for which the number of incoming
		connections is maintained.
	CONFIG: New FEATURE(`ratecontrol') to set the limits for connection
		rate control for individual hosts or nets.
	CONFIG: New FEATURE(`conncontrol') to set the limits for the
		number of open SMTP connections for individual hosts or nets.
	CONFIG: New FEATURE(`greet_pause') enables open proxy and SMTP
		slamming protection described above.  The feature can
		take an argument specifying the milliseconds to wait and/or
		use the access database to look the pause time based on
		client hostname, domain, IP address, or subnet.
	CONFIG: New FEATURE(`use_client_ptr') to have check_relay use
		$&{client_ptr} as its first argument.  This is useful for
		rejections based on the unverified hostname of client,
		which turns on the same behavior as in earlier sendmail
		versions when delay_checks was not in use.  See also entry
		above about check_relay being invoked with ${client_name}.
	CONFIG: New option confREJECT_LOG_INTERVAL to specify the log
		interval when refusing connections for this long.
	CONFIG: Remove quotes around usage of confREJECT_MSG; in some cases
		this requires a change in a mc file.  Requested by
		Ted Roberts of Electronic Data Systems.
	CONFIG: New option confAUTH_REALM to set the authentication realm
		that is passed to the Cyrus SASL library.  Patch from
		Gary Mills of the University of Manitoba.
	CONFIG: Rename the (internal) classes {tls}/{src} to {Tls}/{Src}
		to follow the naming conventions.
	CONFIG: Add a third optional argument to local_lmtp to specify
		the A= argument.
	CONFIG: Remove the f flag from the default mailer flags of
		local_lmtp.
	CONFIG: New option confREQUIRES_DIR_FSYNC to turn off the compile
		time flag REQUIRES_DIR_FSYNC at runtime.
	CONFIG: New LOCAL_UUCP macro to insert rules into the generated
		cf file at the same place where MAILER(`uucp') inserts
		its rules.
	CONFIG: New options confTO_QUEUERETURN_DSN and confTO_QUEUEWARN_DSN
		to control queue return and warning times for delivery
		status notifications.
	CONFIG: New option confFALLBACK_SMARTHOST to define FallbackSmartHost.
	CONFIG: Add the mc file which has been used to create the cf
		file to the end of the cf file when using make in cf/cf/.
		Patch from Richard Rognlie.
	CONFIG: FEATURE(nodns) has been removed, it was a no-op since 8.9.
		Use ServiceSwitchFile to turn off DNS lookups, see
		doc/op/op.me.
	CONFIG: New option confMILTER_MACROS_EOM (sendmail Milter.macros.eom
		option) defines macros to be sent to milter applications for
		use in the xxfi_eom() callback.
	CONFIG: New option confCRL to specify file which contains
		certificate revocations lists.
	CONFIG: Add a new value (sendertoo) for the third argument to
		FEATURE(`ldap_routing') which will reject the SMTP
		MAIL From: command if the sender address doesn't exist
		in LDAP.  See cf/README for more information.
	CONFIG: Add a fifth argument to FEATURE(`ldap_routing') which
		instructs the rulesets on whether or not to do a domain
		lookup if a full address lookup doesn't match.  See cf/README
		for more information.
	CONFIG: Add a sixth argument to FEATURE(`ldap_routing') which
		instructs the rulesets on whether or not to queue the mail
		or give an SMTP temporary error if the LDAP server can't be
		reached.  See cf/README for more information.  Based on
		patch from Billy Ray Miller of Caterpillar.
	CONFIG: Experimental support for MTAMark, see cf/README for details.
	CONFIG: New option confMESSAGEID_HEADER to define a different
		Message-Id: header format.  Patch from Bastiaan Bakker
		of LifeLine Networks.
	CONTRIB: New version of cidrexpand which uses Net::CIDR.  From
		Derek J. Balling.
	CONTRIB: oldbind.compat.c has been removed due to security problems.
		Found by code inspection done by Reasoning, Inc.
	DEVTOOLS: Add an example file for devtools/Site/, contributed
		by Neil Rickert of Northern Illinois University.
	LIBMILTER: Add new function smfi_quarantine() which allows the
		filter's EOM routine to quarantine the current message.
		Filters which use this function must include the
		SMFIF_QUARANTINE flag in the registered smfiDesc structure.
	LIBMILTER: If a milter sets the reply code to "421", the SMTP server
		will terminate the SMTP session with that error.
	LIBMILTER: Upon filter shutdown, libmilter will not remove a
		named socket in the file system if it is running as root.
	LIBMILTER: Add new function smfi_progress() which allows the filter
		to notify the MTA that an EOM operation is still in progress,
		resetting the timeout.
	LIBMILTER: Add new function smfi_opensocket() which allows the filter
		to attempt to establish the interface socket, and detect
		failure to do so before calling smfi_main().
	LIBMILTER: Add new function smfi_setmlreply() which allows the
		filter to return a multi-line SMTP reply.
	LIBMILTER: Deal with more temporary errors in accept() by ignoring
		them instead of stopping after too many occurred.
		Suggested by James Carlson of Sun Microsystems.
	LIBMILTER: Fix a descriptor leak in the sample program found in
		docs/sample.html.  Reported by Dmitry Adamushko.
	LIBMILTER: The sample program also needs to use SMFIF_ADDRCPT.
		Reported by Carl Byington of 510 Software Group.
	LIBMILTER: Document smfi_stop() and smfi_setdbg().  Patches
		from Bryan Costales.
	LIBMILTER: New compile time option SM_CONF_POLL; define this if
		poll(2) should be used instead of select(2).
	LIBMILTER: New function smfi_insheader() and related protocol
		amendments to support header insertion operations.
	MAIL.LOCAL: Add support for hashed mail directories, see
		mail.local/README.  Contributed by Chris Adams of HiWAAY
		Informations Services.
	MAILSTATS: Display quarantine message counts.
	MAKEMAP: Add new flag -D to specify the comment character to use
		instead of '#'.
	VACATION: Add new flag -j to auto-respond to messages regardless of
		whether or not the recipient is listed in the To: or Cc:
		headers.
	VACATION: Add new flag -R to specify the envelope sender address
		for the auto-response message.
	New Files:
		CACerts
		cf/feature/conncontrol.m4
		cf/feature/greet_pause.m4
		cf/feature/mtamark.m4
		cf/feature/ratecontrol.m4
		cf/feature/use_client_ptr.m4
		cf/ostype/unicos.m4
		cf/ostype/unicosmk.m4
		cf/ostype/unicosmp.m4
		contrib/socketmapClient.pl
		contrib/socketmapServer.pl
		devtools/OS/Darwin.7.0
		devtools/OS/UNICOS-mk
		devtools/OS/UNICOS-mp
		devtools/Site/site.config.m4.sample
		include/sm/os/sm_os_unicos.h
		include/sm/os/sm_os_unicosmk.h
		include/sm/os/sm_os_unicosmp.h
		libmilter/docs/smfi_insheader.html
		libmilter/docs/smfi_progress.html
		libmilter/docs/smfi_quarantine.html
		libmilter/docs/smfi_setdbg.html
		libmilter/docs/smfi_setmlreply.html
		libmilter/docs/smfi_stop.html
		sendmail/ratectrl.c
	Deleted Files:
		cf/feature/nodns.m4
		contrib/oldbind.compat.c
		devtools/OS/CRAYT3E.2.0.x
		devtools/OS/CRAYTS.10.0.x
		libsm/vsprintf.c
	Renamed Files:
		devtools/OS/Darwin.7.0 => devtools/OS/Darwin.7.x

8.12.11/8.12.11	2004/01/18
	Use QueueFileMode when opening qf files.  This error was a
		regression in 8.12.10.  Problem detected and diagnosed
		Lech Szychowski of the Polish Power Grid Company.
	Properly count the number of queue runners in a work group and
		make sure the total limit of MaxQueueChildren is not
		exceeded.  Based on patch from Takayuki Yoshizawa of
		Techfirm, Inc.
	Take care of systems that can generate time values where the
		seconds can exceed the usual range of 0 to 59.
		Problem noted by Randy Diffenderfer of EDS.
	Avoid regeneration of identical queue identifiers by processes
		whose process id is the same as that of the initial
		sendmail process that was used to start the daemon.
		Problem noted by Randy Diffenderfer of EDS.
	When a milter invokes smfi_delrcpt() compare the supplied
		recipient address also against the printable addresses
		of the current list to deal with rewritten addresses.
		Based on patch from Sean Hanson of The Asylum.
	BadRcptThrottle now also works for addresses which return the
		error mailer, e.g., virtusertable entries with the
		right hand side error:.  Patch from Per Hedeland.
	Fix printing of 8 bit characters as octals in log messages.
		Based on patch by Andrey J. Melnikoff.
	Undo change of algorithm for MIME 7-bit base64 encoding to 8-bit
		text that has been introduced in 8.12.3.  There are some
		examples where the new code fails, but the old code works.
		To get the 8.12.3-8.12.10 version, compile sendmail with
		-DMIME7TO8_OLD=0.  If you have an example of improper
		7 to 8 bit conversion please send it to us.
	Return normal error code for unknown SMTP commands instead of
		the one specified by check_relay or a milter for a
		connection.  Problem noted by Andrzej Filip.
	Some ident responses contain data after the terminating CRLF which
		causes sendmail to log "POSSIBLE ATTACK...newline in string".
		To avoid this everything after LF is ignored.
	If the operating system supports O_EXLOCK and HASFLOCK is set
		then a possible race condition for creating qf files
		can be avoided.  Note: the race condition does not
		exist within sendmail, but between sendmail and an
		external application that accesses qf files.
	Log the proper options name for TLS related mising files for
		the CACertPath, CACertFile, and DHParameters options.
	Do not split an envelope if it will be discarded, otherwise df
		files could be left behind.  Problem found by Wolfgang
		Breyha.
	The use of the environment variables HOME and HOSTALIASES has been
		deprecated and will be removed in version 8.13.  This only
		effects configuration which preserve those variable via the
		'E' command in the cf file as sendmail clears out its entire
		environment.
	Portability:
		Add support for Darwin 7.0/Mac OS X 10.3 (a.k.a. Panther).
		Solaris 10 has unsetenv(), patch from Craig Mohrman of
			Sun Microsystems.
	LIBMILTER: Add extra checks in case a broken MTA sends bogus data
		to libmilter.  Based on code review by Rob Grzywinski.
	SMRSH: Properly assemble commands that contain '&&' or '||'.
		Problem noted by Eric Lee of Talking Heads.
	New Files:
		devtools/OS/Darwin.7.0

8.12.10/8.12.10	2003/09/24 (Released: 2003/09/17)
	SECURITY: Fix a buffer overflow in address parsing.  Problem
		detected by Michal Zalewski, patch from Todd C. Miller
		of Courtesan Consulting.
	Fix a potential buffer overflow in ruleset parsing.  This problem
		is not exploitable in the default sendmail configuration;
		only if non-standard rulesets recipient (2), final (4), or
		mailer-specific envelope recipients rulesets are used then
		a problem may occur.  Problem noted by Timo Sirainen.
	Accept 0 (and 0/0) as valid input for set MaxMimeHeaderLength.
		Problem noted by Thomas Schulz.
	Add several checks to avoid (theoretical) buffer over/underflows.
	Properly count message size when performing 7->8 or 8->7 bit MIME
		conversions.  Problem noted by Werner Wiethege.
	Properly compute message priority based on size of entire message,
		not just header.  Problem noted by Axel Holscher.
	Reset SevenBitInput to its configured value between SMTP
		transactions for broken clients which do not properly
		announce 8 bit data.  Problem noted by Stefan Roehrich.
	Set {addr_type} during queue runs when processing recipients.
		Based on patch from Arne Jansen.
	Better error handling in case of (very unlikely) queue-id conflicts.
	Perform better error recovery for address parsing, e.g., when
		encountering a comment that is too long.  Problem noted by
		Tanel Kokk, Union Bank of Estonia.
	Add ':' to the allowed character list for bogus HELO/EHLO
		checking.  It is used for IPv6 domain literals.  Patch from
		Iwaizako Takahiro of FreeBit Co., Ltd.
	Reset SASL connection context after a failed authentication attempt.
		Based on patch from Rob Siemborski of CMU.
	Check Berkeley DB compile time version against run time version
		to make sure they match.
	Do not attempt AAAA (IPv6) DNS lookups if IPv6 is not enabled
		in the kernel.
	When a milter adds recipients and one of them causes an error,
		do not ignore the other recipients.  Problem noted by
		Bart Duchesne.
	CONFIG: Use specified SMTP error code in mailertable entries which
		lack a DSN, i.e., "error:### Text".  Problem noted by
		Craig Hunt.
	CONFIG: Call Local_trust_auth with the correct argument.  Patch
		from Jerome Borsboom.
	CONTRIB: Better handling of temporary filenames for doublebounce.pl
		and expn.pl to avoid file overwrites, etc.  Patches from
		Richard A. Nelson of Debian and Paul Szabo.
	MAIL.LOCAL: Fix obscure race condition that could lead to an
		improper mailbox truncation if close() fails after the
		mailbox is fsync()'ed and a new message is delivered
		after the close() and before the truncate().
	MAIL.LOCAL: If mail delivery fails, do not leave behind a
		stale lockfile (which is ignored after the lock timeout).
		Patch from Oleg Bulyzhin of Cronyx Plus LLC.
	Portability:
		Port for AIX 5.2.  Thanks to Steve Hubert of University
			of Washington for providing access to a computer
			with AIX 5.2.
		setreuid(2) works on OpenBSD 3.3.  Patch from
			Todd C. Miller of Courtesan Consulting.
		Allow for custom definition of SMRSH_CMDDIR and SMRSH_PATH
			on all operating systems.  Patch from Robert Harker
			of Harker Systems.
		Use strerror(3) on Linux.  If this causes a problem on
			your Linux distribution, compile with
			-DHASSTRERROR=0 and tell sendmail.org about it.
	Added Files:
		devtools/OS/AIX.5.2

8.12.9/8.12.9	2003/03/29
	SECURITY: Fix a buffer overflow in address parsing due to
		a char to int conversion problem which is potentially
		remotely exploitable.  Problem found by Michal Zalewski.
		Note: an MTA that is not patched might be vulnerable to
		data that it receives from untrusted sources, which
		includes DNS.
	To provide partial protection to internal, unpatched sendmail MTAs,
		8.12.9 changes by default (char)0xff to (char)0x7f in
		headers etc.  To turn off this conversion compile with
		-DALLOW_255 or use the command line option -d82.101.
	To provide partial protection for internal, unpatched MTAs that may be
		performing 7->8 or 8->7 bit MIME conversions, the default
		for MaxMimeHeaderLength has been changed to 2048/1024.
		Note: this does have a performance impact, and it only
		protects against frontal attacks from the outside.
		To disable the checks and return to pre-8.12.9 defaults,
		set MaxMimeHeaderLength to 0/0.
	Do not complain about -ba when submitting mail.  Problem noted
		by Derek Wueppelmann.
	Fix compilation with Berkeley DB 1.85 on systems that do not
		have flock(2).  Problem noted by Andy Harper of Kings
		College London.
	Properly initialize data structure for dns maps to avoid various
		errors, e.g., looping processes.  Problem noted by
		Maurice Makaay of InterNLnet B.V.
	CONFIG: Prevent multiple application of rule to add smart host.
		Patch from Andrzej Filip.
	CONFIG: Fix queue group declaration in MAILER(`usenet').
	CONTRIB: buildvirtuser: New option -t builds the virtusertable
		text file instead of the database map.
	Portability:
		Revert wrong change made in 8.12.7 and actually use the
			builtin getopt() version in sendmail on Linux.
			This can be overridden by using -DSM_CONF_GETOPT=0
			in which case the OS supplied version will be used.

8.12.8/8.12.8	2003/02/11
	SECURITY: Fix a remote buffer overflow in header parsing by
		dropping sender and recipient header comments if the
		comments are too long.  Problem noted by Mark Dowd
		of ISS X-Force.
	Fix a potential non-exploitable buffer overflow in parsing the
		.cf queue settings and potential buffer underflow in
		parsing ident responses.  Problem noted by Yichen Xie of
		Stanford University Compilation Group.
	Fix ETRN #queuegroup command: actually start a queue run for
		the selected queue group.  Problem noted by Jos Vos.
	If MaxMimeHeaderLength is set and a malformed MIME header is fixed,
		log the fixup as "Fixed MIME header" instead of "Truncated
		MIME header".  Problem noted by Ian J Hart.
	CONFIG: Fix regression bug in proto.m4 that caused a bogus
		error message: "FEATURE() should be before MAILER()".
	MAIL.LOCAL: Be more explicit in some error cases, i.e., whether
		a mailbox has more than one link or whether it is not
		a regular file.  Patch from John Beck of Sun Microsystems.

8.12.7/8.12.7	2002/12/29
	Properly clean up macros to avoid persistence of session data
		across various connections.  This could cause session
		oriented restrictions, e.g., STARTTLS requirements,
		to erroneously allow a connection.  Problem noted
		by Tim Maletic of Priority Health.
	Do not lookup MX records when sorting the MSP queue.  The MSP
		only needs to relay all mail to the MTA.  Problem found
		by Gary Mills of the University of Manitoba.
	Do not restrict the length of connection information to 100
		characters in some logging statements.  Problem noted by
		Erik Parker.
	When converting an enhanced status code to an exit status, use
		EX_CONFIG if the first digit is not 2, 4, or 5 or if *.1.5
		is used.
	Reset macro $x when receiving another MAIL command.  Problem
		noted by Vlado Potisk of Wigro s.r.o.
	Don't bother setting the permissions on the build area statistics
		file, the proper permissions will be put on the file at
		install time.  This fixes installation over NFS for some
		users.  Problem noted by Martin J. Dellwo of 3-Dimensional
		Pharmaceuticals, Inc.
	Fix problem of decoding SASLv2 encrypted data.  Problem noted by
		Alex Deiter of Mobile TeleSystems, Komi Republic.
	Log milter socket open errors at MilterLogLevel 1 or higher instead
		of 11 or higher.
	Print early system errors to the console instead of silently
		exiting.  Problem noted by James Jong of IBM.
	Do not process a queue group if Runners is set to 0, regardless
		of whether F=f or sendmail is run in verbose mode (-v).
		The use of -qGname will still force queue group "name"
		to be run even if Runners=0.
	Change the level for logging the fact that a daemon is refusing
		connections due to high load from LOG_INFO to LOG_NOTICE.
		Patch from John Beck of Sun Microsystems.
	Use location information for submit.cf from NetInfo
		(/locations/sendmail/submit.cf) if available.
	Re-enable ForkEachJob which was lost in 8.12.0.  Problem noted by
		Neil Rickert of Northern Illinois University.
	Make behavior of /canon in debug mode consistent with usage in
		rulesets.  Patch from Shigeno Kazutaka of IIJ.
	Fix a potential memory leak in envelope splitting.  Problem noted
		by John Majikes of IBM.
	Do not try to share an mailbox database LDAP connection across
		different processes.  Problem noted by Randy Kunkee.
	Fix logging for undelivered recipients when the SMTP connection
		times out during message collection.  Problem noted by Neil
		Rickert of Northern Illinois University.
	Avoid problems with QueueSortOrder=random due to problems with
		qsort() on Solaris (and maybe some other operating systems).
		Problem noted by Stephan Schulz of Gruner+Jahr..
	If -f "" is specified, set the sender address to "<>".  Problem
		noted by Matthias Andree.
	Fix formatting problem of footnotes for plain text output on some
		versions of tmac.  Patch from Per Hedeland.
	Portability:
		Berkeley DB 4.1 support (requires at least 4.1.25).
		Some getopt(3) implementations in GNU/Linux are broken
			and pass a NULL pointer to an option which requires
			an argument, hence the builtin version of
			sendmail is used instead.  This can be overridden
			by using -DSM_CONF_GETOPT=0.  Problem noted by
			Vlado Potisk of Wigro s.r.o.
		Support for nph-1.2.0 from Mark D. Roth of the University
			of Illinois at Urbana-Champaign.
		Support for FreeBSD 5.0's MAC labeling from Robert Watson
			of the TrustedBSD Project.
		Support for reading the number of processors on an IRIX
			system from Michel Bourget of SGI.
		Support for UnixWare 7.1 based on input from Larry Rosenman.
		Interix support from Nedelcho Stanev of Atlantic Sky
			Corporation.
		Update Mac OS X/Darwin portability from Wilfredo Sanchez.
	CONFIG: Enforce tls_client restrictions even if delay_checks
		is used.  Problem noted by Malte Starostik.
	CONFIG: Deal with an empty hostname created via bogus
		DNS entries to get around access restrictions.
		Problem noted by Kai Schlichting.
	CONFIG: Use FEATURE(`msp', `[127.0.0.1]') in submit.mc by default
		to avoid problems with hostname resolution for localhost
		which on many systems does not resolve to 127.0.0.1 (or
		::1 for IPv6).  If you do not use IPv4 but only IPv6 then
		you need to change submit.mc accordingly, see the comment
		in the file itself.
	CONFIG: Set confDONT_INIT_GROUPS to True in submit.mc to avoid
		error messages from initgroups(3) on AIX 4.3 when sending
		mail to non-existing users. Problem noted by Mark Roth of
		the University of Illinois at Urbana-Champaign.
	CONFIG: Allow local_procmail to override local_lmtp settings.
	CONFIG: Always allow connections from 127.0.0.1 or IPv6:::1 to
		relay.
	CONTRIB: cidrexpand: Deal with the prefix tags that may be included
		in access_db.
	CONTRIB: New version of doublebounce.pl contributed by Leo Bicknell.
	LIBMILTER: On Solaris libmilter may get into an endless loop if
		an error in the communication from/to the MTA occurs.
		Patch from Gurusamy Sarathy of Active State.
	LIBMILTER: Ignore EINTR from sigwait(3) which may happen on Tru64.
		Patch from from Jose Marcio Martins da Cruz of Ecole
		Nationale Superieure des Mines de Paris.
	MAIL.LOCAL: Fix a truncation race condition if the close() on
		the mailbox fails.  Problem noted by Tomoko Fukuzawa of
		Sun Microsystems.
	MAIL.LOCAL: Fix a potential file descriptor leak if mkstemp(3)
		fails.  Patch from John Beck of Sun Microsystems.
	SMRSH: SECURITY: Only allow regular files or symbolic links to be
		used for a command.  Problem noted by David Endler of
		iDEFENSE, Inc.
	New Files:
		devtools/OS/Interix
		include/sm/bdb.h

8.12.6/8.12.6	2002/08/26
	Do not add the FallbackMXhost (or its MX records) to the list
		returned by the bestmx map when -z is used as option.
		Otherwise sendmail may act as an open relay if FallbackMXhost
		and FEATURE(`relay_based_on_MX') are used together.
		Problem noted by Alexander Ignatyev.
	Properly split owner- mailing list messages when SuperSafe is set
		to interactive.  Problem noted by Todd C. Miller of
		Courtesan Consulting.
	Make sure that an envelope is queued in the selected queue group
		even if some recipients are deleted or invalid.  Problem
		found by Chris Adams of HiWAAY Informations Services.
	Do not send a bounce message if a message is completely collected
		from the SMTP client.  Problem noted by Kari Hurtta of the
		Finnish Meteorological Institute.
	Provide an 'install-submit-st' target for sendmail/Makefile to
		install the MSP statistics file using the file named in the
		confMSP_STFILE devtools variable.  Requested by Jeff
		Earickson of Colby College.
	Queue up mail with a temporary error if setusercontext() fails
		during a delivery attempt.  Patch from Todd C. Miller of
		Courtesan Consulting.
	Fix handling of base64 encoded client authentication data for
		SMTP AUTH.  Patch from Elena Slobodnik of life medien GmbH.
	Set the OpenLDAP option LDAP_OPT_RESTART so the client libraries
		restart interrupted system calls.  Problem noted by Luiz
		Henrique Duma of BSIOne.
	Prevent a segmentation fault if a program passed a NULL envp using
		execve().
	Document a problem with the counting of queue runners that may
		cause delays if MaxQueueChildren is set too low. Problem
		noted by Ian Duplisse of Cable Television Laboratories, Inc.
	If discarding a message based on a recipient, don't try to look up
		the recipient in the mailbox database if F=w is set.  This
		allows users to discard bogus recipients when dealing with
		spammers without tipping them off.  Problem noted by Neil
		Rickert of Northern Illinois University.
	If applying a header check to a header with unstructured data,
		e.g., Subject:, then do not run syntax checks that are
		supposed for addresses on the header content.
	Count messages rejected/discarded via the check_data ruleset.
	Portability:
		Fix compilation on systems which do not allow simple
			copying of the variable argument va_list.  Based on
			fix from Scott Walters.
		Fix NSD map open bug.  From Michel Bourget of SGI.
		Add some additional IRIX shells to the default shell
			list.  From Michel Bourget of SGI.
		Fix compilation issues on Mac OS X 10.2 (Darwin 6.0).
			NETISO support has been dropped.
	CONFIG: There was a seemingly minor change in 8.12.4 with respect
		to handling entries of IP nets/addresses with RHS REJECT.
		These would be rejected in check_rcpt instead of only
		being activated in check_relay.  This change has been made to
		avoid potential bogus temporary rejection of relay attempts
		"450 4.7.1 Relaying temporarily denied. Cannot resolve PTR
		record for ..." if delay_checks is enabled.  However, this
		modification causes a change of behavior if an IP net/address
		is listed in the access map with REJECT and a host/domain
		name is listed with OK or RELAY, hence it has been reversed
		such that the behavior of 8.12.3 is restored.  The original
		change was made on request of Neil Rickert of Northern
		Illinois University, the side effect has been found by
		Stefaan Van Hoornick.
	CONFIG: Make sure delay_checks works even for sender addresses
		using the local hostname ($j) or domains in class {P}.
		Based on patch from Neil Rickert of Northern Illinois
		University.
	CONFIG: Fix temporary error handling for LDAP Routing lookups.
		Fix from Andrzej Filip.
	CONTRIB: New version of etrn.pl script and external man page
		(etrn.0) from John Beck of Sun Microsystems.
	LIBMILTER: Protect a free(3) operation from being called with a
		NULL pointer.  Problem noted by Andrey J. Melnikoff.
	LIBMILTER: Protect against more interrupted select() calls.  Based
		on patch from Jose Marcio Martins da Cruz of Ecole Nationale
		Superieure des Mines de Paris.
	New Files:
		contrib/etrn.0

8.12.5/8.12.5	2002/06/25
	SECURITY: The DNS map can cause a buffer overflow if the user
		specifies a dns map using TXT records in the configuration
		file and a rogue DNS server is queried.  None of the
		sendmail supplied configuration files use this option hence
		they are not vulnerable.  Problem noted independently by
		Joost Pol of PINE Internet and Anton Rang of Sun Microsystems.
	Unprintable characters in responses from DNS servers for the DNS
		map type are changed to 'X' to avoid potential problems
		with rogue DNS servers.
	Require a suboption when setting the Milter option.  Problem noted
		by Bryan Costales.
	Do not silently overwrite command line settings for
		DirectSubmissionModifiers.  Problem noted by Bryan
		Costales.
	Prevent a segmentation fault when clearing the event list by
		turning off alarms before checking if event list is
		empty.  Problem noted by Allan E Johannesen of Worcester
		Polytechnic Institute.
	Close a potential race condition in transitioning a memory buffered
		file onto disk.  From Janani Devarajan of Sun Microsystems.
	Portability:
		Include paths.h on Linux systems running glibc 2.0 or later
			to get the definition for _PATH_SENDMAIL, used by
			rmail and vacation.  Problem noted by Kevin
			A. McGrail of Peregrine Hardware.
		NOTE: Linux appears to have broken flock() again.  Unless
			the bug is fixed before sendmail 8.13 is shipped,
			8.13 will change the default locking method to
			fcntl() for Linux kernel 2.4 and later.  You may
			want to do this in 8.12 by compiling with
			-DHASFLOCK=0.  Be sure to update other sendmail
			related programs to match locking techniques.

8.12.4/8.12.4	2002/06/03
	SECURITY: Inherent limitations in the UNIX file locking model
		can leave systems open to a local denial of service
		attack.  Be sure to read the "FILE AND MAP PERMISSIONS"
		section of the top level README for more information.
		Problem noted by lumpy.
	Use TempFileMode (defaults to 0600) for the permissions of PidFile
		instead of 0644.
	Change the default file permissions for new alias database files
		from 0644 to 0640.  This can be overridden at compile time
		by setting the DBMMODE macro.
	Fix a potential core dump problem if the environment variable
		NAME is set.  Problem noted by Beth A. Chaney of
		Purdue University.
	Expand macros before passing them to libmilter.  Problem noted
		by Jose Marcio Martins da Cruz of Ecole Nationale
		Superieure des Mines de Paris.
	Rewind the df (message body) before truncating it when libmilter
		replaces the body of a message.  Problem noted by Gisle Aas
		of Active State.
	Change SMTP reply code for AUTH failure from 500 to 535 and the
		initial zero-length response to "=" per RFC 2554.  Patches
		from Kenneth Murchison of Oceana Matrix Ltd.
	Do not try to fix broken message/rfc822 MIME attachments by
		inserting a MIME-Version: header when MaxMimeHeaderLength
		is set and no 8 to 7 bit conversion is needed.  Based on
		patch from Rehor Petr of ICZ (Czech Republic).
	Do not log "did not issue MAIL/EXPN/VRFY/ETRN" if the connection
		is rejected anyway.  Noted by Chris Loelke.
	Mention the submission mail queue in the mailq man page.  Requested
		by Bill Fenner of AT&T.
	Set ${msg_size} macro when reading a message from the command line
		or the queue.
	Detach from shared memory before dropping privileges back to
		user who started sendmail.
	If AllowBogusHELO is set to false (default) then also complain if
		the argument to HELO/EHLO contains white space.  Suggested
		by Seva Gluschenko of Cronyx Plus.
	Allow symbolicly linked forward files in writable directory paths
		if both ForwardFileInUnsafeDirPath and
		LinkedForwardFileInWritableDir DontBlameSendmail options
		are set.  Problem noted by Werner Spirk of
		Leibniz-Rechenzentrum Munich.
	Portability:
		Operating systems that lack the ftruncate() call will not
			be able to use Milter's body replacement feature.
			This only affects Altos, Maxion, and MPE/iX.
		Digital UNIX 5.0 has changed flock() semantics to be
			non-compliant.  Problem noted by Martin Mokrejs of
			Charles University in Prague.
		The sparc64 port of FreeBSD 5.0 now supports shared
			memory.
	CONFIG: FEATURE(`preserve_luser_host') needs the macro map.
		Problem noted by Andrzej Filip.
	CONFIG: Using 'local:' as a mailertable value with
		FEATURE(`preserve_luser_host') and LUSER_RELAY caused mail
		to be misaddressed.  Problem noted by Andrzej Filip.
	CONFIG: Provide a workaround for DNS based rejection lists that
		fail for AAAA queries.  Problem noted by Chris Boyd.
	CONFIG: Accept the machine's hostname as resolvable when checking
		the sender address.  This allows locally submitted mail to
		be accepted if the machine isn't connected to a nameserver
		and doesn't have an /etc/hosts entry for itself.  Problem
		noted by Robert Watson of the TrustedBSD Project.
	CONFIG: Use deferred expansion for checking the ${deliveryMode}
		macro in case the SMTP VERB command is used.  Problem
		noted by Bryan Costales.
	CONFIG: Avoid a duplicate '@domain' virtusertable lookup if no
		matches are found.  Fix from Andrzej Filip.
	CONFIG: Fix wording in default dnsbl rejection message.  Suggested
		by Lou Katz of Metron Computerware, Ltd.
	CONFIG: Add mailer cyrusv2 for Cyrus V2.  Contributed by
		Kenneth Murchison of Oceana Matrix Ltd.
	CONTRIB: Fix wording in default dnsblaccess rejection message to
		match dnsbl change.
	DEVTOOLS: Add new option for access mode of statistics file,
		confSTMODE, which specifies the permissions when initially
		installing the sendmail statistics file.
	LIBMILTER: Mark the listening socket as close-on-exec in case
		a user's filter starts other applications.
	LIBSM: Allow the MBDB initialize, lookup, and/or terminate
		functions in SmMbdbTypes to be set to NULL.
	MAKEMAP: Change the default file permissions for new databases from
		0644 to 0640.  This can be overridden at compile time
		by setting the DBMMODE macro.
	SMRSH: Fix man page bug: replace SMRSH_CMDBIN with SMRSH_CMDDIR.
		Problem noted by Dave Alden of Ohio State University.
	VACATION: When listing the vacation database (-l), don't show
		bogus timestamps for excluded (-x) addresses.  Problem
		noted by Bryan Costales.
	New Files:
		cf/mailer/cyrusv2.m4

8.12.3/8.12.3	2002/04/05
	NOTICE: In general queue files should not be moved if queue groups
		are used.  In previous versions this could cause mail
		not to be delivered if a queue file is repeatedly moved
		by an external process whenever sendmail moved it back
		into the right place.  Some precautions have been taken
		to avoid moving queue files if not really necessary.
		sendmail may use links to refer to queue files and it
		may store the path of data files in queue files.  Hence
		queue files should not be moved unless those internals
		are understood and the integrity of the files is not
		compromised.  Problem noted by Anne Bennett of Concordia
		University.
	If an error mail is created, and the mail is split across different
		queue directories, and SuperSafe is off, then write the mail
		to disk before splitting it, otherwise an assertion is
		triggered.  Problem tracked down by Henning Schmiedehausen
		of INTERMETA.
	Fix possible race condition that could cause sendmail to forget
		running queues.  Problem noted by Jeff Wasilko of smoe.org.
	Handle bogus qf files better without triggering assertions.
		Problem noted by Guy Feltin.
	Protect against interrupted select() call when enforcing Milter
		read and write timeouts.  Patch from Gurusamy Sarathy of
		ActiveState.
	Matching queue IDs with -qI should be case sensitive.  Problem
		noted by Anne Bennett of Concordia University.
	If privileges have been dropped, don't try to change group ID to
		the RunAsUser group.  Problem noted by Neil Rickert of
		Northern Illinois University.
	Fix SafeFileEnvironment path munging when the specified path
		contains a trailing slash.  Based on patch from Dirk Meyer
		of Dinoex.
	Do not limit sendmail command line length to SM_ARG_MAX (usually
		4096).  Problem noted by Allan E Johannesen of Worcester
		Polytechnic Institute.
	Clear full name of sender for each new envelope to avoid bogus data
		if several mails are sent in one session and some of them
		do not have a From: header.  Problem noted by Bas Haakman.
	Change timeout check such that cached information about a connection
		will be immediately invalid if ConnectionCacheTimeout is zero.
		Based on patch from David Burns of Portland State University.
	Properly count message size for mailstats during mail collection.
		Problem noted by Werner Wiethege.
	Log complete response from LMTP delivery agent on failure.  Based on
		patch from Motonori Nakamura of Kyoto University.
	Provide workaround for getopt() implementations that do not catch
		missing arguments.
	Fix the message size calculation if the message body is replaced by
		a milter filter and buffered file I/O is being used.
		Problem noted by Sergey Akhapkin of Dr.Web.
	Do not honor SIGUSR1 requests if running with extra privileges.
		Problem noted by Werner Wiethege.
	Prevent a file descriptor leak on mail delivery if the initial
		connect fails and DialDelay is set.  Patch from Servaas
		Vandenberghe of Katholieke Universiteit Leuven.
	Properly deal with a case where sendmail is called by root running
		a set-user-ID (non-root) program.  Problem noted by Jon
		Lusky of ISS Atlanta.
	Avoid leaving behind stray transcript (xf) files if multiple queue
		directories are used and mail is sent to a mailing list
		which has an owner- alias.  Problem noted by Anne Bennett
		of Concordia University.
	Fix class map parsing code if optional key is specified.  Problem
		found by Mario Nigrovic.
	The SMTP daemon no longer tries to fix up improperly dot-stuffed
		incoming messages.  A leading dot is always stripped by the
		SMTP receiver regardless of whether or not it is followed by
		another dot.  Problem noted by Jordan Ritter of darkridge.com.
	Fix corruption when doing automatic MIME 7-bit quoted-printable or
		base64 encoding to 8-bit text.  Problem noted by Mark
		Elvers.
	Correct the statistics gathered for total number of connections.
		Instead of being the exact same number as the total number
		of messages (T line in mailstats) it now represents the
		total number of TCP connections.
	Be more explicit about syntax errors in addresses, especially
		non-ASCII characters, and properly create DSNs if necessary.
		Problem noted by Leena Heino of the University of Tampere.
	Prevent small timeouts from being lost on slow machines if itimers
		are used.  Problem noted by Suresh Ramasubramanian.
	Prevent a race condition on child cleanup for delivery to files.
		Problem noted by Fletcher Mattox of the University of
		Texas.
	Change the SMTP error code for temporary map failures from 421
		to 451.
	Do not assume that realloc(NULL, size) works on all OS (this was
		only done in one place: queue group creation).  Based on
		patch by Bryan Costales.
	Initialize Timeout.iconnect in the code to prevent randomly short
		timeouts.  Problem noted by Bradley Watts of AT&T Canada.
	Do not try to send a second SMTP QUIT command if the remote
		responds to a MAIL command with a 421 reply or on I/O
		errors.  By doing so, the host was marked as having a
		temporary problem and other mail destined for that host was
		queued for the next queue run.  Problem noted by Fletcher
		Mattox of the University of Texas, Allan E Johannesen of
		Worcester Polytechnic Institute, Larry Greenfield of CMU,
		and Neil Rickert of Northern Illinois University.
	Ignore error replies from the SMTP QUIT command (including servers
		which drop the connection instead of responding to the
		command).
	Portability:
		Check LDAP_API_VERSION to determine if ldap_memfree() is
			available.
		Define HPUX10 when building on HP-UX 10.X.  That platform
			now gets the proper _PATH_SENDMAIL and SMRSH_CMDDIR
			settings.  Patch from Elias Halldor Agustsson of
			Skyrr.
		Fix dependency building on Mac OS X and Darwin.  Problem
			noted by John Beck.
		Preliminary support for the sparc64 port of FreeBSD 5.0.
		Add /sbin/sh as an acceptable user shell on HP-UX.  From
			Rajesh Somasund of Hewlett-Packard.
	CONFIG: Add FEATURE(`authinfo') to allow a separate database for
		SMTP AUTH information.  This feature was actually added in
		8.12.0 but a release note was not included.
	CONFIG: Do not bounce mail if FEATURE(`ldap_routing')'s bounce
		parameter is set and the LDAP lookup returns a temporary
		error.
	CONFIG: Honor FEATURE(`relay_hosts_only') when using
		FEATURE(`relay_mail_from', `domain').  Problem noted by
		Krzysztof Oledzki.
	CONFIG: FEATURE(`msp') now disables any type of alias
		initialization as aliases are not needed for the MSP.
	CONFIG: Allow users to override RELAY_MAILER_ARGS when FEATURE(`msp')
		is in use.  Patch from Andrzej Filip.
	CONFIG: FEATURE(`msp') uses `[localhost]' as default instead of
		`localhost' and turns on MX lookups for the SMTP mailers.
		This will only have an effect if a parameter is specified,
		i.e., an MX lookup will be performed on the hostname unless
		it is embedded in square brackets.  Problem noted by
		Theo Van Dinter of Collective Technologies.
	CONFIG: Set confTIME_ZONE to USE_TZ in submit.mc (TimeZoneSpec= in
		submit.cf) to use $TZ for time stamps.  This is a compromise
		to allow for the proper time zone on systems where the
		default results in misleading time stamps. That is, syslog
		time stamps and Date headers on submitted mail will use the
		user's $TZ setting.  Problem noted by Mark Roth of the
		University of Illinois at Urbana-Champaign, solution proposed
		by Neil Rickert of Northern Illinois University.
	CONFIG: Mac OS X (Darwin) ships with mail.local as non-set-user-ID
		binary.  Adjust local mailer flags accordingly.  Problem
		noted by John Beck.
	CONTRIB: Add a warning to qtool.pl to not move queue files around
		if queue groups are used.
	CONTRIB: buildvirtuser: Add -f option to force rebuild.
	CONTRIB: smcontrol.pl: Add -f option to specify control socket.
	CONTRIB: smcontrol.pl: Add support for 'memdump' command.
		Suggested by Bryan Costales.
	DEVTOOLS: Add dependency generation for test programs.
	LIBMILTER: Remove conversion of port number for the socket
		structure that is passed to xxfi_connect().  Notice:
		this fix requires that sendmail and libmilter both have
		this change; mixing versions may lead to wrong port
		values depending on the endianness of the involved systems.
		Problem noted by Gisle Aas of ActiveState.
	LIBMILTER: If smfi_setreply() sets a custom reply code of '4XX' but
		SMFI_REJECT is returned, ignore the custom reply.  Do the
		same if '5XX' is used and SMFI_TEMPFAIL is returned.
	LIBMILTER: Install include files in ${INCLUDEDIR}/libmilter/ as
		required by mfapi.h.  Problem noted by Jose Marcio Martins
		da Cruz of Ecole Nationale Superieure des Mines de Paris.
	LIBSM: Add SM_CONF_LDAP_MEMFREE as a configuration define.  Set
		this to 1 if your LDAP client libraries include
		ldap_memfree().
	LIBSMDB: Avoid a file creation race condition for Berkeley DB 1.X
		and NDBM on systems with the O_EXLOCK open(2) flag.
	SMRSH: Fix compilation problem on some operating systems.  Problem
		noted by Christian Krackowizer of schuler technodat GmbH.
	VACATION: Allow root to operate on user vacation databases.  Based
		on patch from Greg Couch of the University of California,
		San Francisco.
	VACATION: Don't ignore -C option.  Based on patch by Bryan Costales.
	VACATION: Clarify option usage in the man page.  Problem noted by
		Joe Barbish.
	New Files:
		libmilter/docs/smfi_setbacklog.html

8.12.2/8.12.2	2002/01/13
	Don't complain too much if stdin, stdout, or stderr are missing
		at startup, only log an error message.
	Fix potential problem if an unknown operation mode (character
		following -b) has been specified.
	Prevent purgestat from looping even if someone changes the
		permissions or owner of hoststatus files.  Problem noted
		by Kari Hurtta of the Finnish Meteorological Institute.
	Properly record dropped connections in persistent host status.
		Problem noted by Ulrich Windl of the Universitat
		Regensburg.
	Remove newlines from recipients read via sendmail -t to prevent
		SMTP protocol errors when sending the RCPT command.
		Problem noted by William D. Colburn of the New Mexico
		Institute of Mining and Technology.
	Only log milter body replacements once instead of for each body
		chunk sent by a filter.  Problem noted by Kari Hurtta of
		the Finnish Meteorological Institute.
	In 8.12.0 and 8.12.1, the headers were mistakenly not included in
		the message size calculation.  Problem noted by Kari Hurtta
		of the Finnish Meteorological Institute.
	Since 8.12 no longer forks at the SMTP MAIL command, the daemon
		needs to collect children status to avoid zombie processes.
		Problem noted by Chris Adams of HiWAAY Informations Services.
	Shut down "nullserver" and ETRN-only connections after 25 bad
		commands are issued.  This makes it consistent with normal
		SMTP connections.
	Avoid duplicate logging of milter rejections.  Problem noted by
		William D. Colburn of the New Mexico Institute of Mining
		and Technology.
	Error and delay DSNs were being sent to postmaster instead of the
		message sender if the sender had used a deprecated RFC822
		source route.  Problem noted by Kari Hurtta of the Finnish
		Meteorological Institute.
	Fix FallbackMXhost behavior for temporary errors during address
		parsing.  Problem noted by Jorg Bielak from Coastal Web
		Online.
	For systems on which stat(2) does not return a value for st_blksize
		that is the "optimal blocksize for I/O" three new compile
		time flags are available: SM_IO_MAX_BUF_FILE, SM_IO_MIN_BUF,
		and SM_IO_MAX_BUF, which define an upper limit for
		regular files, and a lower and upper limit for other file
		types, respectively.
	Fix a potential deadlock if two events are supposed to occur at
		exactly the same time.  Problem noted by Valdis Kletnieks
		of Virginia Tech.
	Perform envelope splitting for aliases listed directly in the
		alias file, not just for include/.forward files.
		Problem noted by John Beck of Sun Microsystems.
	Allow selection of queue group for mailq using -qGgroup.
		Based on patch by John Beck of Sun Microsystems.
	Make sure cached LDAP connections used my multiple maps in the same
		process are closed.  Patch from Taso N. Devetzis.
	If running as root, allow reading of class files in protected
		directories.  Patch from Alexander Talos of the University
		of Vienna.
	Correct a few LDAP related memory leaks.  Patch from David Powell
		of Sun Microsystems.
	Allow specification of an empty realm via the authinfo ruleset.
		This is necessary to interoperate as an SMTP AUTH client
		with servers that do not support realms when using
		CRAM-MD5.  Problem noted by Bjoern Voigt of TU Berlin.
	Avoid a potential information leak if AUTH PLAIN is used and the
		server gets stuck while processing that command.  Problem
		noted by Chris Adams from HiWAAY Informations Services.
	In addition to printing errors when parsing recipients during
		command line invocations log them to make it simpler
		to understand possible DSNs to postmaster.
	Do not use FallbackMXhost on mailers which have the F=0 flag set.
	Allow local mailers (F=l) to specify a host for TCP connections
		instead of forcing localhost.
	Obey ${DESTDIR} for installation of the client mail queue and
		submit.cf.  Patch from Peter 'Luna' Runestig.
	Re-enable support for -M option which was broken in 8.12.1.  Problem
		noted by Neil Rickert of Northern Illinois University.
	If a remote server violates the SMTP standard by unexpectedly
		dropping the connection during an SMTP transaction, stop
		sending commands.  This prevents bogus "Bad file number"
		recipient status.  Problem noted by Allan E Johannesen of
		Worcester Polytechnic Institute.
	Do not use a size estimate of 100 for postmaster bounces, it's
		almost always too small; do not guess the size at all.
	New VENDOR_DEC for Compaq/DEC.  Requested by James Seagraves of
		Compaq Computer Corp.
	Fix DaemonPortOptions IPv6 address parsing such that ::1 works
		properly.  Problem noted by Valdis Kletnieks of Virginia
		Tech.
	Portability:
		Fix IPv6 network interface probing on HP-UX 11.X.  Based on
			patch provided by HP.
		Mac OS X (aka Darwin) has a broken setreuid() call, but a
			working seteuid() call.  From Daniel J. Luke.
		Use proper type for a 32-bit integer on SINIX.  From Ganu
			Sachin of Siemens.
		Set SM_IO_MIN_BUF (4K) and SM_IO_MAX_BUF (8K) for HP-UX.
		Reduce optimization from +O3 to +O2 on HP-UX 11.  This
			fixes a problem that caused additional bogus
			characters to be written to the qf file.  Problem
			noted by Tapani Tarvainen.
		Set LDA_USE_LOCKF by default for UnixWare.  Problem noted
			by Boyd Lynn Gerber.
		Add support for HP MPE/iX.  See sendmail/README for port
			information.  From Mark Bixby of Hewlett-Packard.
		New portability defines HASNICE, HASRRESVPORT, USE_ENVIRON,
			USE_DOUBLE_FORK, and NEEDLINK.  See sendmail/README
			for more information.  From Mark Bixby of
			Hewlett-Packard.
		If an OS doesn't have a method of finding free disk space
			(SFS_NONE), lie and say there is plenty of space.
			From Mark Bixby of Hewlett-Packard.
		Add support for AIX 5.1.  From Valdis Kletnieks of
			Virginia Tech.
		Fix man page location for NeXTSTEP.  From Hisanori Gogota
			of the NTT/InterCommunication Center.
		Do not assume that strerror() always returns a string.
			Problem noted by John Beck of Sun Microsystems.
	CONFIG: Add OSTYPE(freebsd5) for FreeBSD 5.X, which has removed
		UUCP from the base operating system.  From Mark Murray of
		FreeBSD Services, Ltd.
	CONFIG: Add OSTYPE(mpeix) and a generic .mc file for HP MPE/iX
		systems.  From Mark Bixby of Hewlett-Packard.
	CONFIG: Add support for selecting a queue group for all mailers.
		Based on proposal by Stephen L. Ulmer of the University of
		Florida.
	CONFIG: Fix error reporting for compat_check.m4.  Problem noted by
		Altin Waldmann.
	CONFIG: Do not override user selections for confRUN_AS_USER and
		confTRUSTED_USER in FEATURE(msp).  From Mark Bixby of
		Hewlett-Packard.
	LIBMILTER: Fix bug that prevented the removal of a socket after
		libmilter terminated.  Problem reported by Andrey V. Pevnev
		of MSFU.
	LIBMILTER: Fix configuration error that required libsm for linking.
		Problem noted by Kari Hurtta of the Finnish Meteorological
		Institute.
	LIBMILTER: Portability fix for OpenUNIX.  Patch from Larry Rosenman.
	LIBMILTER: Fix a theoretical memory leak and a possible attempt
		to free memory twice.
	LIBSM: Fix a potential segmentation violation in the I/O library.
		Problem found and analyzed by John Beck and Tim Haley
		of Sun Microsystems.
	LIBSM: Do not clear the LDAP configuration information when
		terminating the mailbox database connection in the LDAP
		example code.  Problem noted by Nikos Voutsinas of the
		University of Athens.
	New Files:
		cf/cf/generic-mpeix.cf
		cf/cf/generic-mpeix.mc
		cf/ostype/freebsd5.m4
		cf/ostype/mpeix.m4
		devtools/OS/AIX.5.1
		devtools/OS/MPE-iX
		include/sm/os/sm_os_mpeix.h
		libsm/mpeix.c

8.12.1/8.12.1	2001/10/01
	SECURITY: Check whether dropping group privileges actually succeeded
		to avoid possible compromises of the mail system by
		supplying bogus data.  Add configuration options for
		different set*gid() calls to reset saved gid.  Problem
		found by Michal Zalewski.
	PRIVACY: Prevent information leakage when sendmail has extra
		privileges by disabling debugging (command line -d flag)
		during queue runs and disabling ETRN when sendmail -bs is
		used.  Suggested by Michal Zalewski.
	Avoid memory corruption problems resulting from bogus .cf files.
		Problem found by Michal Zalewski.
	Set the ${server_addr} macro to name of mailer when doing LMTP
		delivery.  LMTP systems may offer SMTP Authentication or
		STARTTLS causing sendmail to use this macro in rulesets.
	If debugging is turned on (-d0.10) print not just the default
		values for configuration file and pid file but also the
		selected values.  Problem noted by Brad Chapman.
	Continue dealing with broken nameservers by ignoring SERVFAIL
		errors returned on T_AAAA (IPv6) lookups at delivery time
		if ResolverOptions=WorkAroundBrokenAAAA is set.  Previously
		this only applied to hostname canonification.  Problem
		noted by Bill Fenner of AT&T Research.
	Ignore comments in NIS host records when trying to find the
		canonical name for a host.
	When sendmail has extra privileges, limit mail submission command
		line flags (i.e., -G, -h, -F, etc.)  to mail submission
		operating modes (i.e., -bm, -bs, -bv, etc.).  Idea based on
		suggestion from Michal Zalewski.
	Portability:
		AIX: Use `oslevel` if available to determine OS version.
			`uname` does not given complete information.
			Problem noted by Keith Neufeld of the Cessna
			Aircraft Company.
		OpenUNIX: Use lockf() for LDA delivery (affects mail.local).
			Problem noticed by Boyd Lynn Gerber of ZENEX.
		Avoid compiler warnings by not using pointers to pass
			integers.  Problem noted by Todd C. Miller of
			Courtesan Consulting.
	CONFIG: Add restrictqrun to PrivacyOptions for the MSP to minimize
		problems with potential misconfigurations.
	CONFIG: Fix comment showing default value of MaxHopCount.  Problem
		noted by Greg Robinson of the Defence Science and
		Technology Organisation of Australia.
	CONFIG: dnsbl: If an argument specifies an error message in case
		of temporary lookup failures for DNS based blacklists
		then use it.
	LIBMILTER: Install mfdef.h, required by mfapi.h.  Problem noted by
		Richard A. Nelson of Debian.
	LIBMILTER: Add __P definition for OS that lack it.  Problem noted
		by Chris Adams from HiWAAY Informations Services.
	LIBSMDB: Fix a lock race condition that affects makemap, praliases,
		and vacation.
	MAKEMAP: Avoid going beyond the end of an input line if it does
		not contain a value for a key.  Based on patch from
		Mark Bixby from Hewlett-Packard.
	New Files:
		test/Build
		test/Makefile
		test/Makefile.m4
		test/README
		test/t_dropgid.c
		test/t_setgid.c
	Deleted Files:
		include/sm/stdio.h
		include/sm/sysstat.h

8.12.0/8.12.0	2001/09/08
	*NOTICE*: The default installation of sendmail does not use
		set-user-ID root anymore.  You need to create a new user and
		a new group before installing sendmail (both called smmsp by
		default).  The installation process tries to install
		/etc/mail/submit.cf and creates /var/spool/clientmqueue by
		default.  Please see sendmail/SECURITY for details.
	SECURITY: Check for group and world writable forward and :include:
		files.  These checks can be turned off if absolutely
		necessary using the DontBlameSendmail option and the new
		flags:
			GroupWritableForwardFile
			WorldWritableForwardFile
			GroupWritableIncludeFile
			WorldWritableIncludeFile
		Problem noted by Slawek Zak of Politechnika Warszawska,
	SECURITY: Drop privileges when using address test mode.  Suggested
		by Michal Zalewski of the "Internet for Schools" project
		(IdS).
	Fixed problem of a global variable being used for a timeout jump
		point where the variable could become overused for more than
		one timeout concurrently.  This erroneous behavior resulted in
		a corrupted stack causing a core dump.  The timeout is now
		handled via libsm.  Problem noted by Michael Shapiro,
		John Beck, and Carl Smith of Sun Microsystems.
	If sendmail is set-group-ID then that group ID is used for permission
		checks (group ID of RunAsUser).  This allows use of a
		set-group-ID sendmail binary for initial message submission
		and no set-user-ID root sendmail is needed.  For details
		see sendmail/SECURITY.
	Log a warning if a non-trusted user changes the syslog label.
		Based on notice from Bryan Costales of SL3D, Inc.
	If sendmail is called for initial delivery, try to use submit.cf
		with a fallback of sendmail.cf as configuration file.  See
		sendmail/SECURITY.
	New configuration file option UseMSP to allow group writable queue
		files if the group is the same as that of a set-group-ID
		sendmail binary.  See sendmail/SECURITY.
	The .cf file is chosen based on the operation mode. For -bm (default),
		-bs, and -t it is submit.cf if it exists for all others it
		is sendmail.cf (to be backward compatible).  This selection
		can be changed by the new option -Ac or -Am (alternative .cf
		file: client or mta).  See sendmail/SECURITY.
	The SMTP server no longer forks on each MAIL command.  The ONEX
		command has been removed.
	Implement SMTP PIPELINING per RFC 2920.  It can be turned off
		at compile time or per host (ruleset).
	New option MailboxDatabase specifies the type of mailbox database
		used to look up local mail recipients; the default value
		is "pw", which means to use getpwnam().  New mailbox database
		types can be added by adding custom code to libsm/mbdb.c.
	Queue file names are now 15 characters long, rather than 14 characters
		long, to accommodate envelope splitting.  File systems with
		a 14 character file name length limit are no longer
		supported.
	Recipient list used for delivery now gets internally ordered by
		hostsignature (character string version of MX RR).  This orders
		recipients for the same MX RR's together meaning smaller
		portions of the list need to be scanned (instead of the whole
		list) each delivery() pass to determine piggybacking.  The
		significance of the change is better the larger the recipient
		list.  Hostsignature is now created during recipient list
		creation rather than just before delivery.
	Enhancements for more opportunistic piggybacking.  Previous
		piggybacking (called coincidental) extended to coattail
		piggybacking.  Rather than complete MX RR matching
		(coincidental) piggybacking is done if just the lowest value
		preference matches (coattail).
	If sendmail receives a temporary error on a RCPT TO: command, it will
		try other MX hosts if available.
	DefaultAuthInfo can contain a list of mechanisms to be used for
		outgoing (client-side) SMTP Authentication.
	New modifier 'A' for DaemonPortOptions/ClientPortOptions to disable
		AUTH (overrides 'a' modifier in DaemonPortOptions).  Based
		on patch from Lyndon Nerenberg of Messaging Direct.
	Enable AUTH mechanism EXTERNAL if STARTTLS is used.
	A new ruleset authinfo can be used to return client side
		authentication information for AUTH instead of DefaultAuthInfo.
		Therefore the DefaultAuthInfo option is deprecated and will be
		removed in future versions.
	Accept any SMTP continuation code 3xy for AUTH even though RFC 2554
		requires 334.  Mercury 1.48 is a known offender.
	Add new option AuthMaxBits to limit the overall encryption strength
		for the security layer in SMTP AUTH (SASL).  See
		doc/op/op.me for details.
	Introduce new STARTTLS related macros {cn_issuer}, {cn_subject},
		{cert_md5} which hold the CN (common name) of the CA that
		signed the presented certificate, the CN and the MD5 hash
		of the presented certificate, respectively.
	New ruleset try_tls to decide whether to try (as client) STARTTLS.
	New ruleset srv_features to enable/disable certain features in the
		server per connection.  See doc/op/op.me for details.
	New ruleset tls_rcpt to decide whether to send e-mail to a particular
		recipient; useful to decide whether a connection is secure
		enough on a per recipient basis.
	New option TLSSrvOptions to modify some aspects of the server
		for STARTTLS.
	If no certificate has been requested, the macro {verify} has the
		value "NOT".
	New M=S modifier for ClientPortOptions/DaemonPortOptions to turn off
		using/offering STARTTLS when delivering/receiving e-mail.
	Macro expand filenames/directories for certs and keys in the .cf file.
		Proposed by Neil Rickert of Northern Illinois University.
	Generate an ephemeral RSA key for a STARTTLS connection only if
		really required.  This change results in a noticeable
		performance gains on most machines.  Moreover, if shared
		memory is in use, reuse the key several times.
	Add queue groups which can be used to group queue directories with
		the same behavior together.  See doc/op/op.me for details.
	If the new option FastSplit (defaults to one) has a value greater
		than zero, it suppresses the MX lookups on addresses when they
		are initially sorted which may result in faster envelope
		splitting.  If the mail is submitted directly from the
		command line, then the value also limits the number of
		processes to deliver the envelopes; if more envelopes are
		created they are only queued up and must be taken care of
		by a queue run.
	The check for 'enough disk space' now pays attention to which file
		system each queue directory resides in.
	All queue runners can be cleanly terminated via SIGTERM to parent.
	New option QueueFileMode for the default permissions of queue files.
	Add parallel queue runner code.  Allows multiple queue runners per work
		group (one or more queues in a multi-queue environment
		collected together) to process the same work list at the
		same time.
	Option MaxQueueChildren added to limit the number of concurrently
		active queue runner processes.
	New option MaxRunnersPerQueue to specify the maximum number of queue
		runners per queue group.
	Queue member selection by substring pattern matching now allows
		the pattern to be negated.  For -qI, -qR and -qS it is
		permissible for -q!I, -q!R and -q!S to mean remove members
		of the queue that match during processing.
	New -qp[time] option is similar to -qtime, except that instead of
		periodically forking a child to process the queue, a single
		child is forked for each queue that sleeps between queue
		runs.  A SIGHUP signal can be sent to restart this
		persistent queue runner.
	The SIGHUP signal now restarts a timed queue run process (i.e., a
		sendmail process which only runs the queue at an interval:
		sendmail -q15m).
	New option NiceQueueRun	to set the priority of queue runners.
		Proposed by Thom O'Connor.
	sendmail will run the queue(s) in the background when invoked with -q
		unless the new -qf option or -v is used.
	QueueSortOrder=Random sorts the queue randomly, which is useful if
		several queue runners are started by hand to avoid contention.
	QueueSortOrder=Modification sorts the queue by the modification time
		of the qf file (older entries first).
	Support Deliver By SMTP Service Extension (RFC 2852) which allows
		a client to specify an amount of time within which an e-mail
		should be delivered.  New option DeliverByMin added to set the
		minimum amount of time or disable the extension.
	Non-printable characters (ASCII: 0-31, 127) in mailbox addresses are
		not allowed unless escaped or quoted.
	Add support for a generic DNS map.  Based on a patch contributed
		by Leif Johansson of Stockholm University, which was based on
		work by Assar Westerlund of Swedish Institute of Computer
		Science, Kista, and Johan Danielsson of Royal Institute of
		Technology, Stockholm, Sweden.
	MX records will be looked up for FallBackMXhost.  To use the old
		behavior (no MX lookups), put the name in square brackets.
		Proposed by Thom O'Connor.
	Use shared memory to store free space of filesystems that are used
		for queues, if shared memory is available and if a key is set
		via SharedMemoryKey.  This minimizes the number of system
		calls to check the available space.  See doc/op/op.me for
		details.
	If shared memory is compiled in the option -bP can be used to print
		the number of entries in the queue(s).
	Enable generic mail filter API (milter).  See libmilter/README
		and the usual documentation for details.
	Remove AutoRebuildAliases option, deprecated since 8.10.
	Remove '-U' (initial user submission) command line option as
		announced in 8.10.
	Remove support for non-standard SMTP command XUSR.  Use an MSA instead.
	New macro {addr_type} which contains whether the current address is
		an envelope sender or recipient address.  Suggested by
		Neil Rickert of Northern Illinois University.
	Two new options for host maps: -d (retransmission timeout),
		-r (number of retries).
	New option for LDAP maps: the -V<sep> allows you to specify a
		separator such that a lookup can return both an attribute
		and value separated by the given separator.
	Add new operators '%', '|', '&' (modulo, binary or, binary and)
		to map class arith.
	If DoubleBounceAddress expands to an empty string, ``double bounces''
		(errors that occur when sending an error message) are dropped.
	New DontBlameSendmail options GroupReadableSASLDBFile and
		GroupWritableSASLDBFile to relax requirements for sasldb files.
	New DontBlameSendmail options GroupReadableKeyFile to relax
		requirements for files containing secret keys.  This is
		necessary for the MSP if client authentification is used.
	Properly handle quoted filenames for class files (to allow for
		filenames with spaces).
	Honor the resolver option RES_NOALIASES when canonifying hostnames.
	Add macros to avoid the reuse of {if_addr} etc:
		{if_name_out}	hostname of interface of outgoing connection.
		{if_addr_out}	address of interface of outgoing connection.
		{if_family_out}	family of interface of outgoing connection.
		The latter two are only set if the interface does not belong
		to the loopback net.
	Add macro {nrcpts} which holds the number of (validated) recipients.
	DialDelay option applies only to mailers with flag 'Z'.  Patch from
		Juergen Georgi of RUS University of Stuttgart.
	New Timeout.lhlo,auth,starttls options to limit the time waiting for
		an answer to the LMTP LHLO, SMTP AUTH or STARTTLS command.
	New Timeout.aconnect option to limit the overall waiting time for
		all connections for a single delivery attempt to succeed.
	Limit the rate recipients in the SMTP envelope are accepted once
		a threshold number of recipients has been rejected (option
		BadRcptThrottle).  From Gregory A Lundberg of the WU-FTPD
		Development Group.
	New option DelayLA to delay connections if the load averages
		exceeds the specified value.  The default of 0 does not
		change the previous behavior.  A value greater than 0
		will cause sendmail to sleep for one second on most
		SMTP commands and before accepting connections if that
		load average is exceeded.
	Use a dynamic (instead of fixed-size) buffer for the list of
		recipients that are sent during a connection to a mailer.
		This also introduces a new mailer field 'r' which defines
		the maximum number of recipients (defaults to 100).
		Based on patch by Motonori Nakamura of Kyoto University.
	Add new F=1 mailer flag to disable sending of null characters ('\0').
	Add new F=2 mailer flag to disable use of ESMTP, using SMTP instead.
	The deprecated [TCP] builtin mailer pathname (P=) is gone.  Use [IPC]
		instead.
	IPC is no longer available as first mailer argument (A=) for [IPC]
		builtin mailer pathnames.  Use TCP instead.
	PH map code updated to use the new libphclient API instead of the
		old libqiapi library.  Contributed by Mark Roth of the
		University of Illinois at Urbana-Champaign.
	New option DirectSubmissionModifiers to define {daemon_flags}
		for direct (command line) submissions.
	New M=O modifier for DaemonPortOptions to ignore the socket in
		case of failures.  Based on patch by Jun-ichiro itojun
		Hagino of the KAME Project.
	Add Disposition-Notification-To: (RFC 2298) to the list of headers
		whose content is rewritten similar to Reply-To:.
		Proposed by Andrzej Filip.
	Use STARTTLS/AUTH=server/client for logging incoming/outgoing
		STARTTLS/AUTH connections; log incoming connections at level
		9 or higher.  Use AUTH/STARTTLS instead of SASL/TLS for SMTP
		AUTH/STARTTLS related logfile entries.
	Convert unprintable characters (and backslash) into octal or C format
		before logging.
	Log recipients if no message is transferred but QUIT/RSET is given
		(at LogLevel 9/10 or higher).
	Log discarded recipients at LogLevel 10 or higher.
	Do not log "did not issue MAIL/EXPN/VRFY/ETRN" for connections
		in which most commands are rejected due to check_relay or
		TCP Wrappers if the host tries one of those commands anyway.
	Change logging format for cloned envelopes to be similar to that for
		DSNs ("old id: new id: clone").  Suggested by Ulrich Windl
		of the Universitat Regensburg.
	Added libsm, a C library of general purpose abstractions including
		assertions, tracing and debugging with named debug categories,
		exception handling, malloc debugging, resource pools,
		portability abstractions, and an extensible buffered I/O
		package.  It will at some point replace libsmutil.
		See libsm/index.html for details.
	Fixed most memory leaks in sendmail which were previously taken
		care of by fork() and exit().
	Use new sm_io*() functions in place of stdio calls.  Allows for
		more consistent portablity amongst different platforms
		new and old (from new libsm).
	Common I/O pkg means just one buffering method needed instead of two
		('bf_portable' and 'bf_torek' now just 'bf').
	Sfio no longer needed as SASL/TLS code uses sm_io*() API's.
	New possible value 'interactive' for SuperSafe which can be used
		together with DeliveryMode=interactive is to avoid some disk
		synchronizations calls.
	Add per-recipient status information to mailq -v output.
	T_ANY queries are no longer used by sendmail.
	When compiling with "gcc -O -Wall" specify "-DSM_OMIT_BOGUS_WARNINGS"
		too (see include/sm/cdefs.h for more info).
	sendmail -d now has general support for named debug categories.
		See libsm/debug.html and section 3.4 of doc/op/op.me
		for details.
	Eliminate the "postmaster warning" DSNs on address parsing errors
		such as unbalanced angle brackets or parentheses.  The DSNs
		generated by this condition were illegal (not RFC conform).
		Problem noted by Ulrich Windl of the Universitaet Regensburg.
	Do not issue a DSN if the ruleset localaddr resolves to the $#error
		mailer and the recipient has hence been rejected during the
		SMTP dialogue.  Problem reported by Larry Greenfield of CMU.
	Deal with a case of multiple deliveries on misconfigured systems
		that do not have postmaster defined.  If an email was sent
		from an address to which a DSN cannot be returned and
		in which at least one recipient address is non-deliverable,
		then that email had been delivered in each queue run.
		Problem reported by Matteo HCE Valsasna of Universita
		degli Studi dell'Insubria.
	The compilation options SMTP, DAEMON, and QUEUE have been removed,
		i.e., the corresponding code is always compiled in now.
	Log the command line in daemon/queue-run mode at LogLevel 10 and
		higher.  Suggested by Robert Harker of Harker Systems.
	New ResolverOptions setting: WorkAroundBrokenAAAA.  When
		attempting to canonify a hostname, some broken nameservers
		will return SERVFAIL (a temporary failure) on T_AAAA (IPv6)
		lookups.  If you want to excuse this behavior, use this new
		flag.  Suggested by Chris Foote of SE Network Access and
		Mark Roth of the University of Illinois at
		Urbana-Champaign.
	Free the memory allocated by getipnodeby{addr,name}().  Problem
		noted by Joy Latten of IBM.
	ConnectionRateThrottle limits the number of connections per second
		to each daemon individually, not the overall number of
		connections.
	Specifying only "ldap:" as an AliasFile specification will force
		sendmail to use a default alias schema as outlined in the
		``USING LDAP FOR ALIASES, MAPS, and CLASSES'' section of
		cf/README.
	Add a new syntax for the 'F' (file class) sendmail.cf command.  If
		the first character after the class name is not a '/' or a
		'|' and it contains an '@' (e.g., F{X}key@class:spec), the
		rest of the line will be parsed as a map lookup.  This
		allows classes to be filled via a map lookup.  See op.me
		for more syntax information.  Specifically, this can be
		used for commands such as VIRTUSER_DOMAIN_FILE() to read
		the list of domains via LDAP (see the ``USING LDAP FOR
		ALIASES, MAPS, and CLASSES'' section of cf/README for an
		example).
	The new macro ${sendmailMTACluster} determines the LDAP cluster for
		the default schema used in the above two items.
	Unless DontBlameSendmail=RunProgramInUnsafeDirPath is set, log a
		warning if a program being run from a mailer or file class
		(e.g., F|/path/to/prog) is in an unsafe directory path.
	Unless DontBlameSendmail=RunWritableProgram is set, log a warning
		if a program being run from a mailer or file class
		(e.g., F|/path/to/prog) is group or world writable.
	Loopback interfaces (e.g., "lo0") are now probed for class {w}
		hostnames.  Setting DontProbeInterfaces to "loopback"
		(without quotes) will disable this and return to the
		pre-8.12 behavior of only probing non-loopback interfaces.
		Suggested by Bryan Stansell of GNAC.
	In accordance with RFC 2821 section 4.1.4, accept multiple
		HELO/EHLO commands.
	Multiple ClientPortOptions settings are now allowed, one for each
		possible protocol family which may be used for outgoing
		connections.  Restrictions placed on one family only affect
		outgoing connections on that particular family.  Because of
		this change, the ${client_flags} macro is not set until the
		connection is established.  Based on patch from Motonori
		Nakamura of Kyoto University.
	PrivacyOptions=restrictexpand instructs sendmail to drop privileges
		when the -bv option is given by users who are neither root
		nor the TrustedUser so users can not read private aliases,
		forwards, or :include: files.  It also will override the -v
		(verbose) command line option.
	If the M=b modifier is set in DaemonPortOptions and the interface
		address can't be used for the outgoing connection, fall
		back to the settings in ClientPortOptions (if set).
		Problem noted by John Beck of Sun Microsystems.
	New named config file rule check_data for DATA command (input:
		number of recipients).  Based on patch from Mark Roth of
		the University of Illinois at Urbana-Champaign.
	Add support for ETRN queue selection per RFC 1985.  The queue group
		can be specified using the '#' option character.  For
		example, 'ETRN #queuegroup'.
	If an LDAP server times out or becomes unavailable, close the
		current connection and reopen to get to one of the fallback
		servers.  Patch from Paul Hilchey of the University of
		British Columbia.
	Make default error number on $#error messages 550 instead of 501
		because 501 is not allowed on all commands.
	The .cf file option UnsafeGroupWrites is deprecated, it should be
		replaced with the settings GroupWritableForwardFileSafe
		and GroupWritableIncludeFileSafe in DontBlameSendmail
		if required.
	The deprecated ldapx map class has been removed.  Use the ldap map
		class instead.
	Any IPv6 addresses used in configuration should be prefixed by the
		"IPv6:" tag to identify the address properly.  For example,
		if you want to add the IPv6 address [2002:c0a8:51d2::23f4] to
		class {w}, you would need to add [IPv6:2002:c0a8:51d2::23f4].
	Change the $&{opMode} macro if the operation mode changes while the
		MTA is running.  For example, during a queue run.
	Add "use_inet6" as a new ResolverOptions flag to control the
		RES_USE_INET6 resolver option.  Based on patch from Rick
		Nelson of IBM.
	The maximum number of commands before the MTA slows down when too
		many "light weight" commands have been received are now
		configurable during compile time.  The current values and
		their defaults are:
		    MAXBADCOMMANDS	25	unknown commands
		    MAXNOOPCOMMANDS	20	NOOP, VERB, ONEX, XUSR
		    MAXHELOCOMMANDS	3	HELO, EHLO
		    MAXVRFYCOMMANDS	6	VRFY, EXPN
		    MAXETRNCOMMANDS	8	ETRN
		Setting a value to 0 disables the check.  Patch from Bryan
		Costales of SL3D, Inc.
	The header syntax H?${MyMacro}?X-My-Header: now not only checks if
		${MyMacro} is defined but also that it is not empty.
	Properly quote usernames with special characters if they are used
		in headers.  Problem noted by Kari Hurtta of the Finnish
		Meteorological Institute.
	Be sure to include the proper Final-Recipient: DSN header in bounce
		messages for messages for mailing list expanded addresses
		which are not delivered on the initial attempt.
	Do not treat errors as sticky when doing delivery via LMTP after
		the final dot has been sent to avoid affecting future
		deliveries.  Problem reported by Larry Greenfield of CMU.
	New compile time flag REQUIRES_DIR_FSYNC which turns on support for
		file systems that require to call fsync() for a directory
		if the meta-data in it has been changed.  This should be
		set at least for ReiserFS; it is enabled by default for Linux.
		See sendmail/README for further information.
	Avoid file locking deadlock when updating the statistics file if
		sendmail is signaled to terminate.  Problem noted by
		Christophe Wolfhugel of France Telecom.
	Set the $c macro (hop count) as it is being set instead of when the
		envelope is initialized.  Problem noted by Kari Hurtta of
		the Finnish Meteorological Institute.
	Properly count recipients for DeliveryMode defer and queue.  Fix
		from Peter A. Friend of EarthLink.
	Treat invalid hesiod lookups as permanent errors instead of
		temporary errors.  Problem noted by Russell McOrmond of
		flora.ca.
	Portability:
		Remove support for AIX 2, which supports only 14 character
			filenames and is outdated anyway.  Suggested by
			Valdis Kletnieks of Virginia Tech.
		Change several settings for Irix 6: remove confSBINDIR,
			i.e., use default /usr/sbin, change owner/group
			of man pages and user-executable to root/sys, set
			optimization limit to 0 (unlimited).  Based on patch
			from Ayamura Kikuchi, M.D, and proposal from Kari
			Hurtta of the Finnish Meteorological Institute.
		Do not assume LDAP support is installed by default under
			Solaris 8 and later.
		Add support for OpenUNIX.
	CONFIG: Increment version number of config file to 10.
	CONFIG: Add an install target and a README file in cf/cf.
	CONFIG: Don't accept addresses of the form a@b@, a@b@c, a@[b]c, etc.
	CONFIG: Reject empty recipient addresses (in check_rcpt).
	CONFIG: The access map uses an option of -T<TMPF> to deal with
		temporary lookup failures.
	CONFIG: New value for access map: SKIP, which causes the default
		action to be taken by aborting the search for domain names
		or IP nets.
	CONFIG: check_rcpt can deal with TEMPFAIL for either recipient or
		relay address as long as the other part allows the email
		to get through.
	CONFIG: Entries for virtusertable can make use of a third parameter
		"%3" which contains "+detail" of a wildcard match, i.e., an
		entry like user+*@domain.  This allows handling of details by
		using %1%3 as the RHS.  Additionally, a "+" wildcard has been
		introduced to match only non-empty details of addresses.
	CONFIG: Numbers for rulesets used by MAILERs have been removed
		and hence there is no required order within the MAILER
		section anymore except for MAILER(`uucp') which must come
		after MAILER(`smtp') if uucp-dom and uucp-uudom are used.
	CONFIG: Hosts listed in the generics domain class {G}
		(GENERICS_DOMAIN() and GENERICS_DOMAIN_FILE()) are treated
		as canonical.  Suggested by Per Hedeland of Ericsson.
	CONFIG: If FEATURE(`delay_checks') is used, make sure that a lookup
		in the access map which returns OK or RELAY actually
		terminates check_* ruleset checking.
	CONFIG: New tag TLS_Rcpt: for access map to be used by ruleset
		tls_rcpt, see cf/README for details.
	CONFIG: Change format of Received: header line which reveals whether
		STARTTLS has been used to "(version=${tls_version}
		cipher=${cipher} bits=${cipher_bits} verify=${verify})".
	CONFIG: Use "Spam:" as tag for lookups for FEATURE(`delay_checks')
		options friends/haters instead of "To:" and enable
		specification of whole domains instead of just users.
		Notice: this change is not backward compatible.
		Suggested by Chris Adams from HiWAAY Informations Services.
	CONFIG: Allow for local extensions for most new rulesets, see
		cf/README for details.
	CONFIG: New FEATURE(`lookupdotdomain') to lookup also .domain in
		the access map.  Proposed by Randall Winchester of the
		University of Maryland.
	CONFIG: New FEATURE(`local_no_masquerade') to avoid masquerading for
		the local mailer.  Proposed by Ingo Brueckl of Wupper Online.
	CONFIG: confRELAY_MSG/confREJECT_MSG can override the default
		messages for an unauthorized relaying attempt/for access
		map entries with RHS REJECT, respectively.
	CONFIG: FEATURE(`always_add_domain') takes an optional argument
		to specify another domain to be added instead of the local one.
		Suggested by Richard H. Gumpertz of Computer Problem
		Solving.
	CONFIG: confAUTH_OPTIONS allows setting of Cyrus-SASL specific
		options, see doc/op/op.me for details.
	CONFIG: confAUTH_MAX_BITS sets the maximum encryption strength for
		the security layer in SMTP AUTH (SASL).
	CONFIG: If Local_localaddr resolves to $#ok, localaddr is terminated
		immediately.
	CONFIG: FEATURE(`enhdnsbl') is an enhanced version of dnsbl which
		allows checking of the return values of the DNS lookups.
		See cf/README for details.
	CONFIG: FEATURE(`dnsbl') allows now to specify the behavior for
		temporary lookup failures.
	CONFIG: New option confDELIVER_BY_MIN to specify minimum time for
		Deliver By (RFC 2852) or to turn off the extension.
	CONFIG: New option confSHARED_MEMORY_KEY to set the key for shared
		memory use.
	CONFIG: New FEATURE(`compat_check') to look up a key consisting
		of the sender and the recipient address delimited by the
		string "<@>", e.g., sender@sdomain<@>recipient@rdomain,
		in the access map.  Based on code contributed by Mathias
		Koerber of Singapore Telecommunications Ltd.
	CONFIG: Add EXPOSED_USER_FILE() command to allow an exposed user
		file.  Suggested by John Beck of Sun Microsystems.
	CONFIG: Don't use MAILER-DAEMON for error messages delivered
		via LMTP.  Problem reported by Larry Greenfield of CMU.
	CONFIG: New FEATURE(`preserve_luser_host') to preserve the name of
		the recipient host if LUSER_RELAY is used.
	CONFIG: New FEATURE(`preserve_local_plus_detail') to preserve the
		+detail portion of the address when passing address to
		local delivery agent.  Disables alias and .forward +detail
		stripping.  Only use if LDA supports this.
	CONFIG: Removed deprecated FEATURE(`rbl').
	CONFIG: Add LDAPROUTE_EQUIVALENT() and LDAPROUTE_EQUIVALENT_FILE()
		which allow you to specify 'equivalent' hosts for LDAP
		Routing lookups.  Equivalent hostnames are replaced by the
		masquerade domain name for lookups.  See cf/README for
		additional details.
	CONFIG: Add a fourth argument to FEATURE(`ldap_routing') which
		instructs the rulesets on what to do if the address being
		looked up has +detail information.  See cf/README for more
		information.
	CONFIG: When chosing a new destination via LDAP Routing, also look
		up the new routing address/host in the mailertable.  Based
		on patch from Don Badrak of the United States Census Bureau.
	CONFIG: Do not reject the SMTP Mail from: command if LDAP Routing
		is in use and the bounce option is enabled.  Only reject
		recipients as user unknown.
	CONFIG: Provide LDAP support for the remaining database map
		features.  See the ``USING LDAP FOR ALIASES AND MAPS''
		section of cf/README for more information.
	CONFIG: Add confLDAP_CLUSTER which defines the ${sendmailMTACluster}
		macro used for LDAP searches as described above in ``USING
		LDAP FOR ALIASES, MAPS, AND CLASSES''.
	CONFIG: confCLIENT_OPTIONS has been replaced by CLIENT_OPTIONS(),
		which takes the options as argument and can be used
		multiple times; see cf/README for details.
	CONFIG: Add configuration macros for new options:
		confBAD_RCPT_THROTTLE		BadRcptThrottle
		confDIRECT_SUBMISSION_MODIFIERS	DirectSubmissionModifiers
		confMAILBOX_DATABASE		MailboxDatabase
		confMAX_QUEUE_CHILDREN		MaxQueueChildren
		confMAX_RUNNERS_PER_QUEUE	MaxRunnersPerQueue
		confNICE_QUEUE_RUN		NiceQueueRun
		confQUEUE_FILE_MODE		QueueFileMode
		confFAST_SPLIT			FastSplit
		confTLS_SRV_OPTIONS		TLSSrvOptions
		See above (and related documentation) for further information.
	CONFIG: Add configuration variables for new timeout options:
		confTO_ACONNECT		Timeout.aconnect
		confTO_AUTH		Timeout.auth
		confTO_LHLO		Timeout.lhlo
		confTO_STARTTLS		Timeout.starttls
	CONFIG: Add configuration macros for mail filter API:
		confINPUT_MAIL_FILTERS		InputMailFilters
		confMILTER_LOG_LEVEL		Milter.LogLevel
		confMILTER_MACROS_CONNECT	Milter.macros.connect
		confMILTER_MACROS_HELO		Milter.macros.helo
		confMILTER_MACROS_ENVFROM	Milter.macros.envfrom
		confMILTER_MACROS_ENVRCPT	Milter.macros.envrcpt
		Mail filters can be defined via INPUT_MAIL_FILTER() and
		MAIL_FILTER().  See libmilter/README, cf/README, and
		doc/op/op.me for details.
	CONFIG: Add support for accepting temporarily unresolvable domains.
		See cf/README for details.  Based on patch by Motonori
		Nakamura of Kyoto University.
	CONFIG: confDEQUOTE_OPTS can be used to specify options for the
		dequote map.
	CONFIG: New macro QUEUE_GROUP() to define queue groups.
	CONFIG: New FEATURE(`queuegroup') to select a queue group based
		on the full e-mail address or the domain of the recipient.
	CONFIG: Any IPv6 addresses used in configuration should be prefixed
		by the "IPv6:" tag to identify the address properly.  For
		example, if you want to use the IPv6 address
		2002:c0a8:51d2::23f4 in the access database, you would need
		to use IPv6:2002:c0a8:51d2::23f4 on the left hand side.
		This affects the access database as well as the
		relay-domains and local-host-names files.
	CONFIG: OSTYPE(aux) has been renamed to OSTYPE(a-ux).
	CONFIG: Avoid expansion of m4 keywords in SMART_HOST.
	CONFIG: Add MASQUERADE_EXCEPTION_FILE() for reading masquerading
		exceptions from a file.  Suggested by Trey Breckenridge of
		Mississippi State University.
	CONFIG: Add LOCAL_USER_FILE() for reading local users
		(LOCAL_USER() -- $={L}) entries from a file.
	CONTRIB: dnsblaccess.m4 is a further enhanced version of enhdnsbl.m4
		which allows to lookup error codes in the access map.
		Contributed by Neil Rickert of Northern Illinois University.
	DEVTOOLS: Add new options for installation of include and library
		files: confINCGRP, confINCMODE, confINCOWN, confLIBGRP,
		confLIBMODE, confLIBOWN.
	DEVTOOLS: Add new option confDONT_INSTALL_CATMAN to turn off
		installation of the the formatted man pages on operating
		systems which don't include cat directories.
	EDITMAP: New program for editing maps as supplement to makemap.
	MAIL.LOCAL: Mail.local now uses the libsm mbdb package to look up
		local mail recipients.  New option -D mbdb specifies the
		mailbox database type.
	MAIL.LOCAL: New option "-h filename" which instructs mail.local to
		deliver the mail to the named file in the user's home
		directory instead of the system mail spool area.  Based on
		patch from Doug Hardie of the Los Angeles Free-Net.
	MAILSTATS: New command line option -P which acts the same as -p but
		doesn't truncate the statistics file.
	MAKEMAP: Add new option -t to specify a different delimiter
		instead of white space.
	RMAIL: Invoke sendmail with '-G' to indicate this is a gateway
		submission.  Problem noted by Kari Hurtta of the Finnish
		Meteorological Institute.
	SMRSH: Use the vendor supplied directory on FreeBSD 3.3 and later.
	VACATION: Change Auto-Submitted: header value from auto-generated to
		auto-replied.  From Kenneth Murchison of Oceana Matrix Ltd.
	VACATION: New option -d to send error/debug messages to stdout
		instead of syslog.
	VACATION: New option -U which prevents the attempt to lookup login
		in the password file.  The -f and -m options must be used
		to specify the database and message file since there is no
		home directory for the default settings for these options.
	VACATION: Vacation now uses the libsm mbdb package to look up
		local mail recipients; it reads the MailboxDatabase option
		from the sendmail.cf file.  New option -C cffile which
		specifies the path of the sendmail.cf file.
	New Directories:
		libmilter/docs
	New Files:
		cf/cf/README
		cf/cf/submit.cf
		cf/cf/submit.mc
		cf/feature/authinfo.m4
		cf/feature/compat_check.m4
		cf/feature/enhdnsbl.m4
		cf/feature/msp.m4
		cf/feature/local_no_masquerade.m4
		cf/feature/lookupdotdomain.m4
		cf/feature/preserve_luser_host.m4
		cf/feature/preserve_local_plus_detail.m4
		cf/feature/queuegroup.m4
		cf/sendmail.schema
		contrib/dnsblaccess.m4
		devtools/M4/UNIX/sm-test.m4
		devtools/OS/OpenUNIX.5.i386
		editmap/*
		include/sm/*
		libsm/*
		libsmutil/cf.c
		libsmutil/err.c
		sendmail/SECURITY
		sendmail/TUNING
		sendmail/bf.c
		sendmail/bf.h
		sendmail/sasl.c
		sendmail/sm_resolve.c
		sendmail/sm_resolve.h
		sendmail/tls.c
	Deleted Files:
		cf/feature/rbl.m4
		cf/ostype/aix2.m4
		devtools/OS/AIX.2
		include/sendmail/cdefs.h
		include/sendmail/errstring.h
		include/sendmail/useful.h
		libsmutil/errstring.c
		sendmail/bf_portable.c
		sendmail/bf_portable.h
		sendmail/bf_torek.c
		sendmail/bf_torek.h
		sendmail/clock.c
	Renamed Files:
		cf/cf/generic-solaris2.mc => cf/cf/generic-solaris.mc
		cf/cf/generic-solaris2.cf => cf/cf/generic-solaris.cf
		cf/ostype/aux.m4 => cf/ostype/a-ux.m4

8.11.7/8.11.7	2003/03/29
	SECURITY: Fix a remote buffer overflow in header parsing by
		dropping sender and recipient header comments if the
		comments are too long.  Problem noted by Mark Dowd
		of ISS X-Force.
	SECURITY: Fix a buffer overflow in address parsing due to
		a char to int conversion problem which is potentially
		remotely exploitable.  Problem found by Michal Zalewski.
		Note: an MTA that is not patched might be vulnerable to
		data that it receives from untrusted sources, which
		includes DNS.
	To provide partial protection to internal, unpatched sendmail MTAs,
		8.11.7 changes by default (char)0xff to (char)0x7f in
		headers etc.  To turn off this conversion compile with
		-DALLOW_255 or use the command line option -d82.101.
	To provide partial protection for internal, unpatched MTAs that may be
		performing 7->8 or 8->7 bit MIME conversions, the default
		for MaxMimeHeaderLength has been changed to 2048/1024.
		Note: this does have a performance impact, and it only
		protects against frontal attacks from the outside.
		To disable the checks and return to pre-8.11.7 defaults,
		set MaxMimeHeaderLength to 0/0.
	Properly clean up macros to avoid persistence of session data
		across various connections.  This could cause session
		oriented restrictions, e.g., STARTTLS requirements,
		to erroneously allow a connection.  Problem noted
		by Tim Maletic of Priority Health.
	Ignore comments in NIS host records when trying to find the
		canonical name for a host.
	Fix a memory leak when closing Hesiod maps.
	Set ${msg_size} macro when reading a message from the command line
		or the queue.
	Prevent a segmentation fault when clearing the event list by
		turning off alarms before checking if event list is
		empty.  Problem noted by Allan E Johannesen of Worcester
		Polytechnic Institute.
	Fix a potential core dump problem if the environment variable
		NAME is set.  Problem noted by Beth A. Chaney of
		Purdue University.
	Prevent a race condition on child cleanup for delivery to files.
		Problem noted by Fletcher Mattox of the University of
		Texas.
	CONFIG: Do not bounce mail if FEATURE(`ldap_routing')'s bounce
		parameter is set and the LDAP lookup returns a temporary
		error.
	CONFIG: Fix a syntax error in the try_tls ruleset if
		FEATURE(`access_db') is not enabled.
	LIBSMDB: Fix a lock race condition that affects makemap, praliases,
		and vacation.
	LIBSMDB: Avoid a file creation race condition for Berkeley DB 1.X
		and NDBM on systems with the O_EXLOCK open(2) flag.
	MAKEMAP: Avoid going beyond the end of an input line if it does
		not contain a value for a key.  Based on patch from
		Mark Bixby from Hewlett-Packard.
	MAIL.LOCAL: Fix a truncation race condition if the close() on
		the mailbox fails.  Problem noted by Tomoko Fukuzawa of
		Sun Microsystems.
	SMRSH: SECURITY: Only allow regular files or symbolic links to be
		used for a command.  Problem noted by David Endler of
		iDEFENSE, Inc.

8.11.6/8.11.6	2001/08/20
	SECURITY: Fix a possible memory access violation when specifying
		out-of-bounds debug parameters.  Problem detected by
		Cade Cairns of SecurityFocus.
	Avoid leaking recipient information in unrelated DSNs.  This could
		happen if a connection is aborted, several mails had been
		scheduled for delivery via that connection, and the timeout
		is reached such that several DSNs are sent next.  Problem
		noted by Dileepan Moorkanat of Hewlett-Packard.
	Fix a possible segmentation violation when specifying too many
		wildcard operators in a rule.  Problem detected by
		Werner Wiethege.
	Avoid a segmentation fault on non-matching Hesiod lookups.  Problem
		noted by Russell McOrmond of flora.ca

8.11.5/8.11.5	2001/07/31
	Fix a possible race condition when sending a HUP signal to restart
		the daemon.  This could terminate the current process without
		starting a new daemon.  Problem reported by Wolfgang Breyha
		of SE Netway Communications.
	Only apply MaxHeadersLength when receiving a message via SMTP or
		the command line.  Problem noted by Andrey J. Melnikoff.
	When finding the system's local hostname on an IPv6-enabled system
		which doesn't have any IPv6 interface addresses, fall back
		to looking up only IPv4 addresses.  Problem noted by Tim
		Bosserman of EarthLink.
	When commands were being rejected due to check_relay or TCP
		Wrappers, the ETRN command was not giving a response.
	Incoming IPv4 connections on a Family=inet6 daemon (using
		IPv4-mapped addresses) were incorrectly labeled as "may be
		forged".  Problem noted by Per Steinar Iversen of Oslo
		University College.
	Shutdown address test mode cleanly on SIGTERM.  Problem noted by
		Greg King of the OAO Corporation.
	Restore the original real uid (changed in main() to prevent
		out of band signals) before invoking a delivery agent.
		Some delivery agents use this for the "From " envelope
		"header".  Problem noted by Leslie Carroll of the
		University at Albany.
	Mark closed file descriptors properly to avoid reuse. Problem
		noted by Jeff Bronson of J.D. Bronson, Inc.
	Setting Timeout options on the command line will also override
		their sub-suboptions in the .cf file, e.g., -O
		Timeout.queuereturn=2d will set all queuereturn timeouts
		to 2 days.  Problem noted by Roger B.A. Klorese.
	Portability:
		BSD/OS has a broken setreuid() implementation.  Problem
			noted by Vernon Schryver of Rhyolite Software.
		BSD/OS has /dev/urandom(4) (as of version 4.1/199910 ?).
			Noted by Vernon Schryver of Rhyolite Software.
		BSD/OS has fchown(2).  Noted by Dave Yadallee of Netline
			2000 Internet Solutions Inc.
		Solaris 2.X and later have strerror(3).  From Sebastian
			Hagedorn of Cologne University.
	CONFIG: Fix parsing for IPv6 domain literals in addresses
		(user@[IPv6:address]).  Problem noted by Liyuan Zhou.

8.11.4/8.11.4	2001/05/28
	Clean up signal handling routines to reduce the chances of heap
		corruption and other potential race conditions.
		Terminating and restarting the daemon may not be
		instantaneous due to this change.  Also, non-root users can
		no longer send out-of-band signals.  Problem reported by
		Michal Zalewski of BindView.
	If LogLevel is greater than 9 and SASL fails to negotiate an
		encryption layer, avoid core dump logging the encryption
		strength.  Problem noted by Miroslav Zubcic of Crol.
	If a server offers "AUTH=" and "AUTH " and the list of mechanisms is
		different in those two lines, sendmail might not have
		recognized (and used) all of the offered mechanisms.
	Fix an IP address lookup problem on Solaris 2.0 - 2.3.  Patch
		from Kenji Miyake.
	This time, really don't use the .. directory when expanding
		QueueDirectory wildcards.
	If a process is interrupted while closing a map, don't try to close
		the same map again while exiting.
	Allow local mailers (F=l) to contact remote hosts (e.g., via
		LMTP).  Problem noted by Norbert Klasen of the University
		of Tuebingen.
	If Timeout.QueueReturn was set to a value less the time it took
		to write a new queue file (e.g., 0 seconds), the bounce
		message would be lost.  Problem noted by Lorraine L Goff of
		Oklahoma State University.
	Pass map argument vector into map rewriting engine for the regex
		and prog map types.  Problem noted by Stephen Gildea of
		InTouch Systems, Inc.
	When closing an LDAP map due to a temporary error, close all of the
		other LDAP maps which share the original map's connection
		to the LDAP server.  Patch from Victor Duchovni of
		Morgan Stanley.
	To detect changes of NDBM aliases files check the timestamp of the
		.pag file instead of the .dir file.  Problem noted by Neil
		Rickert of Northern Illinois University.
	Don't treat temporary hesiod lookup failures as permanent.  Patch
		from Werner Wiethege.
	If ClientPortOptions is set, make sure to create the outgoing socket
		with the family set in that option.  Patch from Sean Farley.
	Avoid a segmentation fault trying to dereference a NULL pointer
		when logging a MaxHopCount exceeded error with an empty
		recipient list.  Problem noted by Chris Adams of HiWAAY
		Internet Services.
	Fix DSN for "Too many hops" bounces.  Problem noticed by Ulrich
		Windl of the Universitaet Regensburg.
	Fix DSN for "mail loops back to me" bounces.  Problem noticed by
		Kari Hurtta of the Finnish Meteorological Institute.
	Portability:
		OpenBSD has a broken setreuid() implementation.
	CONFIG: Undo change from 8.11.1: change 501 SMTP reply code back
		to 553 since it is allowed by DRUMS.
	CONFIG: Add OSTYPE(freebsd4) for FreeBSD 4.X.
	DEVTOOLS: install.sh did not properly handle paths in the source
		file name argument.  Noted by Kari Hurtta of the Finnish
		Meteorological Institute.
	DEVTOOLS: Add FAST_PID_RECYCLE to compile time options for OpenBSD
		since it generates random process ids.
	PRALIASES: Add back adaptive algorithm to deal with different endings
		of entries in the database (with/without trailing '\0').
		Patch from John Beck of Sun Microsystems.
	New Files:
		cf/ostype/freebsd4.m4

8.11.3/8.11.3	2001/02/27
	Prevent a segmentation fault when a bogus value was used in the
		LDAPDefaultSpec option's -r, -s, or -M flags and if a bogus
		option was used.  Problem noted by Allan E Johannesen of
		Worcester Polytechnic Institute.
	Prevent "token too long" message by shortening {currHeader} which
		could be too long if the last copied character was a quote.
		Problem detected by Jan Krueger of digitalanswers
		communications consulting gmbh.
	Additional IPv6 check for unspecified addresses.  Patch from
		Jun-ichiro itojun Hagino of the KAME Project.
	Do not ignore the ClientPortOptions setting if DaemonPortOptions
		Modifier=b (bind to same interface) is set and the
		connection came in from the command line.
	Do not bind to the loopback address if DaemonPortOptions
		Modifier=b (bind to same interface) is set.  Patch from
		John Beck of Sun Microsystems.
	Properly deal with open failures on non-optional maps used in
		check_* rulesets by returning a temporary failure.
	Buffered file I/O files were not being properly fsync'ed to disk
		when they were committed.
	Properly encode '=' for the AUTH= parameter of the MAIL command.
		Problem noted by Hadmut Danisch.
	Under certain circumstances the macro {server_name} could be set
		to the wrong hostname (of a previous connection), which may
		cause some rulesets to return wrong results.  This would
		usually cause mail to be queued up and delivered later on.
	Ignore F=z (LMTP) mailer flag if $u is given in the mailer A=
		equate.  Problem noted by Motonori Nakamura of Kyoto
		University.
	Work around broken accept() implementations which only partially
		fill in the peer address if the socket is closed before
		accept() completes.
	Return an SMTP "421" temporary failure if the data file can't be
		opened where the "354" reply would normally be given.
	Prevent a CPU loop in trying to expand a macro which doesn't exist
		in a queue run.  Problem noted by Gordon Lack of Glaxo
		Wellcome.
	If delivering via a program and that program exits with EX_TEMPFAIL,
		note that fact for the mailq display instead of just showing
		"Deferred".  Problem noted by Motonori Nakamura of Kyoto
		University.
	If doing canonification via /etc/hosts, try both the fully
		qualified hostname as well as the first portion of the
		hostname.  Problem noted by David Bremner of the
		University of New Brunswick.
	Portability:
		Fix a compilation problem for mail.local and rmail if SFIO
			is in use.  Problem noted by Auteria Wally
			Winzer Jr. of Champion Nutrition.
		IPv6 changes for platforms using KAME.  Patch from
			Jun-ichiro itojun Hagino of the KAME Project.
		OpenBSD 2.7 and higher has srandomdev(3).  OpenBSD 2.8 and
			higher has BSDI-style login classes.  Patch from
			Todd C.  Miller of Courtesan Consulting.
		Unixware 7.1.1 doesn't allow h_errno to be set directly if
			sendmail is being compiled with -kthread.  Problem
			noted by Orion Poplawski of CQG, Inc.
	CONTRIB: buildvirtuser: Substitute current domain for $DOMAIN and
		current left hand side for $LHS in virtuser files.
	DEVTOOLS: Do not pass make targets to recursive Build invocations.
		Problem noted by Jeff Bronson of J.D. Bronson, Inc.
	MAIL.LOCAL: In LMTP mode, do not return errors regarding problems
		storing the temporary message file until after the remote
		side has sent the final DATA termination dot.  Problem
		noted by Allan E Johannesen of Worcester Polytechnic
		Institute.
	MAIL.LOCAL: If LMTP mode is set, give a temporary error if users
		are also specified on the command line.  Patch from
		Motonori Nakamura of Kyoto University.
	PRALIASES: Skip over AliasFile specifications which aren't based on
		database files (i.e., only show dbm, hash, and btree).
	Renamed Files:
		devtools/OS/OSF1.V5.0 => devtools/OS/OSF1.V5.x

8.11.2/8.11.2	2000/12/29
	Prevent a segmentation fault when trying to set a class in
		address test mode due to a negative array index.  Audit
		other array indexing.  This bug is not believed to be
		exploitable.  Noted by Michal Zalewski of the "Internet for
		Schools" project (IdS).
	Add an FFR (for future release) to drop privileges when using
		address test mode.  This will be turned on in 8.12. It can
		be enabled by compiling with:
		APPENDDEF(`conf_sendmail_ENVDEF', `-D_FFR_TESTMODE_DROP_PRIVS')
		in your devtools/Site/site.config.m4 file.  Suggested by
		Michal Zalewski of the "Internet for Schools" project (IdS).
	Fix potential problem with Cyrus-SASL security layer which may have
		caused I/O errors, especially for mechanism DIGEST-MD5.
	When QueueSortOrder was set to host, sendmail might not read
		enough of the queue file to determine the host, making the
		sort sub-optimal.  Problem noted by Jeff Earickson of
		Colby College.
	Don't issue DSNs for addresses which use the NOTIFY parameter (per
		RFC 1891) but don't have FAILURE as value.
	Initialize Cyrus-SASL library before the SMTP daemon is started.
		This implies that every change to SASL related files requires
		a restart of the daemon, e.g., Sendmail.conf, new SASL
		mechanisms (in form of shared libraries).
	Properly set the STARTTLS related macros during a queue run for
		a cached connection.  Bug reported by Michael Kellen of
		NxNetworks, Inc.
	Log the server name in relay= for ruleset tls_server instead of the
		client name.
	Include original length of bad field/header when reporting
		MaxMimeHeaderLength problems.  Requested by Ulrich Windl of
		the Universitat Regensburg.
	Fix delivery to set-user-ID files that are expanded from aliases in
		DeliveryMode queue.  Problem noted by Ric Anderson of the
		University of Arizona.
	Fix LDAP map -m (match only) flag.  Problem noted by Jeff Giuliano
		of Collective Technologies.
	Avoid using a negative argument for sleep() calls when delaying answers
		to EXPN/VRFY commands on systems which respond very slowly.
		Problem noted by Mikolaj J. Habryn of Optus Internet
		Engineering.
	Make sure the F=u flag is set in the default prog mailer
		definition.  Problem noted by Kari Hurtta of the Finnish
		Meteorological Institute.
	Fix IPv6 check for unspecified addresses.  Patch from
		Jun-ichiro itojun Hagino of the KAME Project.
	Fix return values for IRIX nsd map.  From Kari Hurtta of the Finnish
		Meteorological Institute.
	Fix parsing of DaemonPortOptions and ClientPortOptions.  Read all
		of the parameters to find Family= setting before trying to
		interpret Addr= and Port=.  Problem noted by Valdis
		Kletnieks of Virginia Tech.
	When delivering to a file directly from an alias, do not call
		initgroups(); instead use the DefaultUser group information.
		Problem noted by Marc Schaefer of ALPHANET NF.
	RunAsUser now overrides the ownership of the control socket, if
		created.  Otherwise, sendmail can not remove it upon
		close.  Problem noted by Werner Wiethege.
	Fix ConnectionRateThrottle counting as the option is the number of
		overall connections, not the number of connections per
		socket.  A future version may change this to per socket
		counting.
	Portability:
		Clean up libsmdb so it functions properly on platforms
			where sizeof(u_int32_t) != sizeof(size_t).  Problem
			noted by Rein Tollevik of Basefarm AS.
		Fix man page formatting for compatibility with Solaris'
			whatis.  From Stephen Gildea of InTouch Systems, Inc.
		UnixWare 7 includes snprintf() support.  From Larry
			Rosenman.
		IPv6 changes for platforms using KAME.  Patch from
			Jun-ichiro itojun Hagino of the KAME Project.
		Avoid a typedef compile conflict with Berkeley DB 3.X and
			Solaris 2.5 or earlier.  Problem noted by Bob Hughes
			of Pacific Access.
		Add preliminary support for AIX 5.  Contributed by
			Valdis Kletnieks of Virginia Tech.
		Solaris 9 load average support from Andrew Tucker of Sun
			Microsystems.
	CONFIG: Reject addresses of the form a!b if FEATURE(`nouucp', `r')
		is used.  Problem noted by Phil Homewood of Asia Online,
		patch from Neil Rickert of Northern Illinois University.
	CONFIG: Change the default DNS based blacklist server for
		FEATURE(`dnsbl') to blackholes.mail-abuse.org.
	CONFIG: Deal correctly with the 'C' flag in {daemon_flags}, i.e.,
		implicitly assume canonical host names.
	CONFIG: Deal with "::" in IPv6 addresses for access_db.  Based on
		patch by Motonori Nakamura of Kyoto University.
	CONFIG: New OSTYPE(`aix5') contributed by Valdis Kletnieks of
		Virginia Tech.
	CONFIG: Pass the illegal header form <list:;> through untouched
		instead of making it worse.  Problem noted by Motonori
		Nakamura of Kyoto University.
	CONTRIB: Added buildvirtuser (see `perldoc contrib/buildvirtuser`).
	CONTRIB: qtool.pl: An empty queue is not an error.  Problem noted
		by Jan Krueger of digitalanswers communications consulting
		gmbh.
	CONTRIB: domainmap.m4: Handle domains with '-' in them.  From Mark
		Roth of the University of Illinois at Urbana-Champaign.
	DEVTOOLS: Change the internal devtools OS, REL, and ARCH m4
		variables into bldOS, bldREL, and bldARCH to prevent
		namespace collisions.  Problem noted by Motonori Nakamura
		of Kyoto University.
	RMAIL: Undo the 8.11.1 change to use -G when calling sendmail.  It
		causes some changes in behavior and may break rmail for
		installations where sendmail is actually a wrapper to
		another MTA.  The change will re-appear in a future
		version.
	SMRSH: Use the vendor supplied directory on HPUX 10.X, HPUX 11.X,
		and SunOS 5.8.  Requested by Jeff A. Earickson of Colby
		College and John Beck of Sun Microsystems.
	VACATION: Fix pattern matching for addresses to ignore.
	VACATION: Don't reply to addresses of the form owner-*
		or *-owner.
	New Files:
		cf/ostype/aix5.m4
		contrib/buildvirtuser
		devtools/OS/AIX.5.0

8.11.1/8.11.1	2000/09/27
	Fix SMTP EXPN command output if the address expands to a single
		name.  Fix from John Beck of Sun Microsystems.
	Don't try STARTTLS in the client if the PRNG has not been properly
		seeded.  This problem only occurs on systems without
		/dev/urandom.  Problem detected by Jan Krueger of
		digitalanswers communications consulting gmbh and
		Neil Rickert of Northern Illinois University.
	Don't use the . and .. directories when expanding QueueDirectory
		wildcards.
	Do not try to cache LDAP connections across processes as a parent
		process may close the connection before the child process
		has completed.  Problem noted by Lai Yiu Fai of the Hong
		Kong University of Science and Technology and Wolfgang
		Hottgenroth of UUNET.
	Use Timeout.fileopen to limit the amount of time spent trying to
		read the LDAP secret from a file.
	Prevent SIGTERM from removing a command line submitted item after
		the user submits the message and before the first delivery
		attempt completes.  Problem noted by Max France of AlphaNet.
		Fix from Neil Rickert of Northern Illinois University.
	Deal correctly with MaxMessageSize restriction if message size is
		greater than 2^31.  Problem noted by Tim "Darth Dice" Bosserman
		of EarthLink.
	Turn off queue checkpointing if CheckpointInterval is set to zero.
	Treat an empty home directory (from getpw*() or $HOME) as
		non-existent instead of treating it as /.  Problem noted by
		Todd C. Miller of Courtesan Consulting.
	Don't drop duplicate headers when reading a queued item.  Problem
		noted by Motonori Nakamura of Kyoto University.
	Avoid bogus error text when logging the savemail panic "cannot
		save rejected email anywhere".  Problem noted by Marc G.
		Fournier of Acadia University.
	If an LDAP search fails because the LDAP server went down, close
		the map so subsequent searches reopen the map.  If there are
		multiple LDAP servers, the down server will be skipped and
		one of the others may be able to take over.
	Set the ${load_avg} macro to the current load average, not the
		previous load average query result.
	If a non-optional map used in a check_* ruleset can't be opened,
		return a temporary failure to the remote SMTP client
		instead of ignoring the map.  Problem noted by Allan E
		Johannesen of Worcester Polytechnic Institute.
	Avoid a race condition when queuing up split envelopes by saving
		the split envelopes before the original envelope.
	Fix a bug in the PH_MAP code which caused mail to bounce instead of
		defer if the PH server could not be contacted.  From Mark
		Roth of the University of Illinois at Urbana-Champaign.
	Prevent QueueSortOrder=Filename from interfering with -qR, -qS, and
		ETRN.  Problem noted by Erik R. Leo of SoVerNet.
	Change error code for unrecognized parameters to the SMTP MAIL and
		RCPT commands from 501 to 555 per RFC 1869.  Problem
		reported to Postfix by Robert Norris of Monash University.
	Prevent overwriting the argument of -B on certain OS.  Problem
		noted by Matteo Gelosa of I.NET S.p.A.
	Use the proper routine for freeing memory with Netscape's LDAP
		client libraries.  Patch from Paul Hilchey of the
		University of British Columbia.
	Portability:
		Move the NETINET6 define to devtools/OS/SunOS.5.{8,9}
			instead of defining it in conf.h so users can
			override the setting.  Suggested by
			Henrik Nordstrom of Ericsson.
		On HP-UX 10.X and 11.X, use /usr/sbin/sendmail instead of
			/usr/lib/sendmail for rmail and vacation.  From
			Jeff A. Earickson of Colby College.
		On HP-UX 11.X, use /usr/sbin instead of /usr/libexec (which
			does not exist).  From Jeff A. Earickson of Colby
			College.
		Avoid using the UCB subsystem on NCR MP-RAS 3.x.  From
			Tom Moore of NCR.
		NeXT 3.X and 4.X installs man pages in /usr/man.  From
			Hisanori Gogota of NTT/InterCommunicationCenter.
		Solaris 8 and later include /var/run.  The default PID file
			location is now /var/run/sendmail.pid.  From John
			Beck of Sun Microsystems.
		SFIO includes snprintf() for those operating systems
			which do not.  From Todd C. Miller of Courtesan
			Consulting.
	CONFIG: Use the result of _CERT_REGEX_SUBJECT_ not {cert_subject}.
		Problem noted by Kaspar Brand of futureLab AG.
	CONFIG: Change 553 SMTP reply code to 501 to avoid problems with
		errors in the MAIL address.
	CONFIG: Fix FEATURE(nouucp) usage in example .mc files.  Problem
		noted by Ron Jarrell of Virginia Tech.
	CONFIG: Add support for Solaris 8 (and later) as OSTYPE(solaris8).
		Contributed by John Beck of Sun Microsystems.
	CONFIG: Set confFROM_HEADER such that the mail hub can possibly add
		GECOS information for an address.  This more closely
		matches pre-8.10 nullclient behavior.  From Per Hedeland of
		Ericsson.
	CONFIG: Fix MODIFY_MAILER_FLAGS(): apply the flag modifications for
		SMTP to all *smtp* mailers and those for RELAY to the relay
		mailer as described in cf/README.
	MAIL.LOCAL: Open the mailbox as the recipient not root so quotas
		are obeyed.  Problem noted by Damian Kuczynski of NIK.
	MAKEMAP: Do not change a map's owner to the TrustedUser if using
		makemap to 'unmake' the map.
	RMAIL: Avoid overflowing the list of recipients being passed to
		sendmail.
	RMAIL: Invoke sendmail with '-G' to indicate this is a gateway
		submission.  Problem noted by Kari Hurtta of the Finnish
		Meteorological Institute.
	VACATION: Read the complete message to avoid "broken pipe" signals.
	VACATION: Do not cut off vacation.msg files which have a single
		dot as the only character on the line.
	New Files:
		cf/ostype/solaris8.m4

8.11.0/8.11.0	2000/07/19
	SECURITY: If sendmail is installed as a non-root set-user-ID binary
		(not the normal case), some operating systems will still
		keep a saved-uid of the effective-uid when sendmail tries
		to drop all of its privileges.  If sendmail needs to drop
		these privileges and the operating system doesn't set the
		saved-uid as well, exit with an error.  Problem noted by
		Kari Hurtta of the Finnish Meteorological Institute.
	SECURITY: sendmail depends on snprintf() NUL terminating the string
		it populates.  It is possible that some broken
		implementations of snprintf() exist that do not do this.
		Systems in this category should compile with
		-DSNPRINTF_IS_BROKEN=1.  Use test/t_snprintf.c to test your
		system and report broken implementations to
		sendmail-bugs@sendmail.org and your OS vendor.  Problem
		noted by Slawomir Piotrowski of TELSAT GP.
	Support SMTP Service Extension for Secure SMTP (RFC 2487) (STARTTLS).
		Implementation influenced by the example programs of
		OpenSSL and the work of Lutz Jaenicke of TU Cottbus.
	Add new STARTTLS related options CACERTPath, CACERTFile,
		ClientCertFile, ClientKeyFile, DHParameters, RandFile,
		ServerCertFile, and ServerKeyFile.  These are documented in
		cf/README and doc/op/op.me.
	New STARTTLS related macros: ${cert_issuer}, ${cert_subject},
		${tls_version}, ${cipher}, ${cipher_bits}, ${verify},
		${server_name}, and ${server_addr}.  These are documented
		in cf/README and doc/op/op.me.
	Add support for the Entropy Gathering Daemon (EGD) for better
		random data.
	New DontBlameSendmail option InsufficientEntropy for systems which
		don't properly seed the PRNG for OpenSSL but want to
		try to use STARTTLS despite the security problems.
	Support the security layer in SMTP AUTH for mechanisms which
		support encryption.  Based on code contributed by Tim
		Martin of CMU.
	Add new macro ${auth_ssf} to reflect the SMTP AUTH security
		strength factor.
	LDAP's -1 (single match only) flag was not honored if the -z
		(delimiter) flag was not given.  Problem noted by ST Wong of
		the Chinese University of Hong Kong.  Fix from Mark Adamson
		of CMU.
	Add more protection from accidentally tripping OpenLDAP 1.X's
		ld_errno == LDAP_DECODING_ERROR hack on ldap_next_attribute().
		Suggested by Kurt Zeilenga of OpenLDAP.
	Fix the default family selection for DaemonPortOptions.  As
		documented, unless a family is specified in a
		DaemonPortOptions option, "inet" is the default.  It is
		also the default if no DaemonPortOptions value is set.
		Therefore, IPv6 users should configure additional sockets
		by adding DaemonPortOptions settings with Family=inet6 if
		they wish to also listen on IPv6 interfaces.  Problem noted
		by Jun-ichiro itojun Hagino of the KAME Project.
	Set ${if_family} when setting ${if_addr} and ${if_name} to reflect
		the interface information for an outgoing connection.
		Not doing so was creating a mismatch between the socket
		family and address used in subsequent connections if the
		M=b modifier was set in DaemonPortOptions.  Problem noted
		by John Beck of Sun Microsystems.
	If DaemonPortOptions modifier M=b is used, determine the socket
		family based on the IP address.  ${if_family} is no longer
		persistent (i.e., saved in qf files).  Patch from John Beck
		of Sun Microsystems.
	sendmail 8.10 and 8.11 reused the ${if_addr} and ${if_family}
		macros for both the incoming interface address/family and
		the outgoing interface address/family.  In order for M=b
		modifier in DaemonPortOptions to work properly, preserve
		the incoming information in the queue file for later
		delivery attempts.
	Use SMTP error code and enhanced status code from check_relay in
		responses to commands.  Problem noted by Jeff Wasilko of
		smoe.org.
	Add more vigilance in checking for putc() errors on output streams
		to protect from a bug in Solaris 2.6's putc().  Problem
		noted by Graeme Hewson of Oracle.
	The LDAP map -n option (return attribute names only) wasn't working.
		Problem noted by Ajay Matia.
	Under certain circumstances, an address could be listed as deferred
		but would be bounced back to the sender as failed to be
		delivered when it really should have been queued.  Problem
		noted by Allan E Johannesen of Worcester Polytechnic Institute.
	Prevent a segmentation fault in a child SMTP process from getting
		the SMTP transaction out of sync.  Problem noted by Per
		Hedeland of Ericsson.
	Turn off RES_DEBUG if SFIO is defined unless SFIO_STDIO_COMPAT
		is defined to avoid a core dump due to incompatibilities
		between sfio and stdio.  Problem noted by Neil Rickert
		of Northern Illinois University.
	Don't log useless envelope ID on initial connection log.  Problem
		noted by Kari Hurtta of the Finnish Meteorological Institute.
	Convert the free disk space shown in a control socket status query
		to kilobyte units.
	If TryNullMXList is True and there is a temporary DNS failure
		looking up the hostname, requeue the message for a later
		attempt.  Problem noted by Ari Heikkinen of Pohjois-Savo
		Polytechnic.
	Under the proper circumstances, failed connections would be recorded
		as "Bad file number" instead of "Connection failed" in the
		queue file and persistent host status.  Problem noted by
		Graeme Hewson of Oracle.
	Avoid getting into an endless loop if a non-hoststat directory exists
		within the hoststatus directory (e.g., lost+found).
		Patch from Valdis Kletnieks of Virginia Tech.
	Make sure Timeout.queuereturn=now returns a bounce message to the
		sender.  Problem noted by Per Hedeland of Ericsson.
	If a message data file can't be opened at delivery time, panic and
		abort the attempt instead of delivering a message that
		states "<<< No Message Collected >>>".
	Fixup the GID checking code from 8.10.2 as it was overly
		restrictive.  Problem noted by Mark G. Thomas of Mark
		G. Thomas Consulting.
	Preserve source port number instead of replacing it with the ident
		port number (113).
	Document the queue status characters in the mailq man page.
		Suggested by Ulrich Windl of the Universitat Regensburg.
	Process queued items in which none of the recipient addresses have
		host portions (or there are no recipients).  Problem noted
		by Valdis Kletnieks of Virginia Tech.
	If a cached LDAP connection is used for multiple maps, make sure
		only the first to open the connection is allowed to close
		it so a later map close doesn't break the connection for
		other maps.  Problem noted by Wolfgang Hottgenroth of UUNET.
	Netscape's LDAP libraries do not support Kerberos V4
		authentication.  Patch from Rainer Schoepf of the
		University of Mainz.
	Provide workaround for inconsistent handling of data passed
		via callbacks to Cyrus SASL prior to version 1.5.23.
	Mention ENHANCEDSTATUSCODES in the SMTP HELP helpfile.  Omission
		noted by Ulrich Windl of the Universitat Regensburg.
	Portability:
		Add the ability to read IPv6 interface addresses into class
			'w' under FreeBSD (and possibly others).  From Jun
			Kuriyama of IMG SRC, Inc. and the FreeBSD Project.
		Replace code for finding the number of CPUs on HPUX.
		NCRUNIX MP-RAS 3.02 SO_REUSEADDR socket option does not
			work properly causing problems if the accept()
			fails and the socket needs to be reopened.  Patch
			from Tom Moore of NCR.
		NetBSD uses a .0 extension of formatted man pages.  From
			Andrew Brown of Crossbar Security.
		Return to using the IPv6 AI_DEFAULT flag instead of AI_V4MAPPED
			for calls to getipnodebyname().  The Linux
			implementation is broken so AI_ADDRCONFIG is stripped
			under Linux.  From John Beck of Sun Microsystems and
			John Kennedy of Cal State University, Chico.
	CONFIG: Catch invalid addresses containing a ',' at the wrong place.
		Patch from Neil Rickert of Northern Illinois University.
	CONFIG: New variables for the new sendmail options:
		confCACERT_PATH			CACERTPath
		confCACERT			CACERTFile
		confCLIENT_CERT			ClientCertFile
		confCLIENT_KEY			ClientKeyFile
		confDH_PARAMETERS		DHParameters
		confRAND_FILE			RandFile
		confSERVER_CERT			ServerCertFile
		confSERVER_KEY			ServerKeyFile
	CONFIG: Provide basic rulesets for TLS policy control and add new
		tags to the access database to support these policies.  See
		cf/README for more information.
	CONFIG: Add TLS information to the Received: header.
	CONFIG: Call tls_client ruleset from check_mail in case it wasn't
		called due to a STARTTLS command.
	CONFIG: If TLS_PERM_ERR is defined, TLS related errors are permanent
		instead of temporary.
	CONFIG: FEATURE(`relay_hosts_only') didn't work in combination with
		the access map and relaying to a domain without using a To:
		tag.  Problem noted by Mark G. Thomas of Mark G. Thomas
		Consulting.
	CONFIG: Set confEBINDIR to /usr/sbin to match the devtools entry in
		OSTYPE(`linux') and OSTYPE(`mklinux').  From Tim Pierce of
		RootsWeb.com.
	CONFIG: Make sure FEATURE(`nullclient') doesn't use aliasing and
		forwarding to make it as close to the old behavior as
		possible.  Problem noted by George W. Baltz of the
		University of Maryland.
	CONFIG: Added OSTYPE(`darwin') for Mac OS X and Darwin users.  From
		Wilfredo Sanchez of Apple Computer, Inc.
	CONFIG: Changed the map names used by FEATURE(`ldap_routing') from
		ldap_mailhost and ldap_mailroutingaddress to ldapmh and
		ldapmra as underscores in map names cause problems if
		underscore is in OperatorChars.  Problem noted by Bob Zeitz
		of the University of Alberta.
	CONFIG: Apply blacklist_recipients also to hosts in class {w}.
		Patch from Michael Tratz of Esosoft Corporation.
	CONFIG: Use A=TCP ... instead of A=IPC ... in SMTP mailers.
	CONTRIB: Add link_hash.sh to create symbolic links to the hash
		of X.509 certificates.
	CONTRIB: passwd-to-alias.pl:  More protection from special characters;
		treat special shells as root aliases; skip entries where the
		GECOS full name and username match.  From Ulrich Windl of the
		Universitat Regensburg.
	CONTRIB: qtool.pl: Add missing last_modified_time method and fix a
		typo.  Patch from Graeme Hewson of Oracle.
	CONTRIB: re-mqueue.pl: Improve handling of a race between re-mqueue
		and sendmail.  Patch from Graeme Hewson of Oracle.
	CONTRIB: re-mqueue.pl: Don't exit(0) at end so can be called as
		subroutine Patch from Graeme Hewson of Oracle.
	CONTRIB: Add movemail.pl (move old mail messages between queues by
		calling re-mqueue.pl) and movemail.conf (configuration
		script for movemail.pl).  From Graeme Hewson of Oracle.
	CONTRIB: Add cidrexpand (expands CIDR blocks as a preprocessor to
		makemap).  From Derek J. Balling of Yahoo,Inc.
	DEVTOOLS: INSTALL_RAWMAN installation option mistakenly applied any
		extension modifications (e.g., MAN8EXT) to the installation
		target.  Patch from James Ralston of Carnegie Mellon
		University.
	DEVTOOLS: Add support for SunOS 5.9.
	DEVTOOLS: New option confLN contains the command used to create
		links.
	LIBSMDB: Berkeley DB 2.X and 3.X errors might be lost and not
		reported.
	MAIL.LOCAL: DG/UX portability.  Problem noted by Tim Boyer of
		Denman Tire Corporation.
	MAIL.LOCAL: Prevent a possible DoS attack when compiled with
		-DCONTENTLENGTH.  Based on patch from 3APA3A@SECURITY.NNOV.RU.
	MAILSTATS: Fix usage statement (-p and -o are optional).
	MAKEMAP: Change man page layout as workaround for problem with nroff
		and -man on Solaris 7.  Patch from Larry Williamson.
	RMAIL: AIX 4.3 has snprintf().  Problem noted by David Hayes of
		Black Diamond Equipment, Limited.
	RMAIL: Prevent a segmentation fault if the incoming message does not
		have a From line.
	VACATION: Read all of the headers before deciding whether or not
		to respond instead of stopping after finding recipient.
	Added Files:
		cf/ostype/darwin.m4
		contrib/cidrexpand
		contrib/link_hash.sh
		contrib/movemail.conf
		contrib/movemail.pl
		devtools/OS/SunOS.5.9
		test/t_snprintf.c

8.10.2/8.10.2	2000/06/07
	SECURITY: Work around broken Linux setuid() implementation.
		On Linux, a normal user process has the ability to subvert
		the setuid() call such that it is impossible for a root
		process to drop its privileges.  Problem noted by Wojciech
		Purczynski of elzabsoft.pl.
	SECURITY: Add more vigilance around set*uid(), setgid(), setgroups(),
		initgroups(), and chroot() calls.
	Added Files:
		test/t_setuid.c

8.10.1/8.10.1	2000/04/06
	SECURITY: Limit the choice of outgoing (client-side) SMTP
		Authentication mechanisms to those specified in
		AuthMechanisms to prevent information leakage.  We do not
		recommend use of PLAIN for outgoing mail as it sends the
		password in clear text to possibly untrusted servers.  See
		cf/README's DefaultAuthInfo section for additional information.
	Copy the ident argument for openlog() to avoid problems on some
		OSs.  Based on patch from Rob Bajorek from Webhelp.com.
	Avoid bogus error message when reporting an alias line as too long.
	Avoid bogus socket error message if sendmail.cf version level is
		greater than sendmail binary supported version.  Patch
		from John Beck of Sun Microsystems.
	Prevent a malformed ruleset (missing right hand side) from causing
		a segmentation fault when using address test mode.  Based on
		patch from John Beck of Sun Microsystems.
	Prevent memory leak from use of NIS maps and yp_match(3).  Problem
		noted by Gil Kloepfer of the University of Texas at Austin.
	Fix queue file permission checks to allow for TrustedUser ownership.
	Change logging of errors from the trust_auth ruleset to LogLevel 10
		or higher.
	Avoid simple password cracking attacks against SMTP AUTH by using
		exponential delay after too many tries within one connection.
	Encode an initial empty AUTH challenge as '=', not as empty string.
	Avoid segmentation fault on EX_SOFTWARE internal error logs.
		Problem noted by Allan E Johannesen of Worcester
		Polytechnic Institute.
	Ensure that a header check which resolves to $#discard actually
		discards the message.
	Emit missing value warnings for aliases with no right hand side
		when newaliases is run instead of only when delivery is
		attempted to the alias.
	Remove AuthOptions missing value warning for consistency with other
		flag options.
	Portability:
		SECURITY: Specify a run-time shared library search path for
			AIX 4.X instead of using the dangerous AIX 4.X
			linker semantics.  AIX 4.X users should consult
			sendmail/README for further information.  Problem
			noted by Valdis Kletnieks of Virginia Tech.
		Avoid use of strerror(3) call.  Problem noted by Charles
			Levert of Ecole Polytechnique de Montreal.
		DGUX requires -lsocket -lnsl and has a non-standard install
			program.  From Tim Boyer of Denman Tire Corporation.
		HPUX 11.0 has a broken res_search() function.
		Updates to devtools/OS/NeXT.3.X, NeXT.4.X, and NEXTSTEP.4.X
			from J. P. McCann of E I A.
		Digital UNIX/Compaq Tru64 5.0 now includes snprintf(3).
			Problem noted by Michael Long of Info Avenue Internet
			Services, LLC.
		Modern (post-199912) OpenBSD versions include working
			strlc{at,py}(3) functions.  From Todd C. Miller of
			Courtesan Consulting.
		SINIX doesn't have random(3).  From Gerald Rinske of
			Siemens Business Services.
	CONFIG: Change error message about unresolvable sender domain to
		include the sender address.  Proposed by Wolfgang Rupprecht
		of WSRCC.
	CONFIG: Fix usenet mailer calls.
	CONFIG: If RELAY_MAILER_FLAGS is not defined, use SMTP_MAILER_FLAGS
		to be backward compatible with 8.9.
	CONFIG: Change handling of default case @domain for virtusertable
		to allow for +*@domain to deal with +detail.
	CONTRIB: Remove converting.sun.configs -- it is obsolete.
	DEVTOOLS: confUBINMODE was being ignored.  Fix from KITAZIMA, Tuneki
		of NEC.
	DEVTOOLS: Add to NCR platform list and include the architecture
		(i486).  From Tom J. Moore of NCR.
	DEVTOOLS: SECURITY: Change method of linking with sendmail utility
		libraries to work around the AIX 4.X and SunOS 4.X linker's
		overloaded -L option.  Problem noted by Valdis Kletnieks of
		Virginia Tech.
	DEVTOOLS: configure.sh was overriding the user's choice for
		confNROFF.  Problem noted by Glenn A. Malling of Syracuse
		University.
	DEVTOOLS: New variables conf_prog_LIB_POST and confBLDVARIANT added
		for other internal projects but included in the open source
		release.
	LIBSMDB: Check for ".db" instead of simply "db" at the end of the
		map name to determine whether or not to add the extension.
		This fixes makemap when building the userdb file.  Problem
		noted by Andrew J Cole of the University of Leeds.
	LIBSMDB: Allow a database to be opened for updating and created if
		it doesn't already exist.  Problem noted by Rand Wacker of
		Sendmail.
	LIBSMDB: If type is SMDB_TYPE_DEFAULT and both NEWDB and NDBM are
		available, fall back to NDBM if NEWDB open fails.  This
		fixes praliases.  Patch	from John Beck of Sun Microsystems.
	LIBSMUTIL: safefile()'s SFF_NOTEXCL check was being misinterpreted
		as SFF_NOWRFILES.
	OP.ME: Clarify some issues regarding mailer flags.  Suggested by
		Martin Mokrejs of The Charles University and Neil Rickert of
		Northern Illinois University.
	PRALIASES: Restore 8.9.X functionality of being able to search for
		particular keys in a database by specifying the keys on the
		command line.  Man page updated accordingly.  Patch from
		John Beck of Sun Microsystems.
	VACATION: SunOS 4.X portability from Charles Levert of Ecole
		Polytechnique de Montreal.
	VACATION: Fix -t option which is ignored but available for
		compatibility with Sun's version, based on patch from
		Volker Dobler of Infratest Burke.
	Added Files:
		devtools/M4/UNIX/smlib.m4
		devtools/OS/OSF1.V5.0
	Deleted Files:
		contrib/converting.sun.configs
	Deleted Directories (already done in 8.10.0 but not listed):
		doc/intro
		doc/usenix
		doc/changes

8.10.0/8.10.0	2000/03/01
	    *************************************************************
	    * The engineering department at Sendmail, Inc. has suffered	*
	    * the tragic loss of a key member of our engineering team.	*
	    * Julie Van Bourg was the Vice President of Engineering	*
	    * at Sendmail, Inc. during the development and deployment	*
	    * of this release.  It was her vision, dedication, and	*
	    * support that has made this release a success.  Julie died	*
	    * on October 26, 1999 of cancer.  We have lost a leader, a	*
	    * coach, and a friend.					*
	    *								*
	    * This release is dedicated to her memory and to the joy,	*
	    * strength, ideals, and hope that she brought to all of us.	*
	    * Julie, we miss you!					*
	    *************************************************************
	SECURITY: The safe file checks now back track through symbolic
		links to make sure the files can't be compromised due
		to poor permissions on the parent directories of the
		symbolic link target.
	SECURITY: Only root, TrustedUser, and users in class t can rebuild
		the alias map.  Problem noted by Michal Zalewski of the
		"Internet for Schools" project (IdS).
	SECURITY: There is a potential for a denial of service attack if
		the AutoRebuildAliases option is set as a user can kill the
		sendmail process while it is rebuilding the aliases file
		(leaving it in an inconsistent state).  This option and
		its use is deprecated and will be removed from a future
		version of sendmail.
	SECURITY: Make sure all file descriptors (besides stdin, stdout, and
		stderr) are closed before restarting sendmail.  Problem noted
		by Michal Zalewski of the "Internet for Schools" project
		(IdS).
	Begin using /etc/mail/ for sendmail related files.  This affects
		a large number of files.  See cf/README for more details.
	The directory structure of the distribution has changed slightly
		for easier code sharing among the programs.
	Support SMTP AUTH (see RFC 2554).  New macros for this purpose
		are ${auth_authen}, ${auth_type}, and ${auth_author}
		which hold the client's authentication credentials,
		the mechanism used for authentication, and the
		authorization identity (i.e., the AUTH= parameter if
		supplied).  Based on code contributed by Tim Martin of CMU.
	On systems which use the Torek stdio library (all of the BSD
		distributions), use memory-buffered files to reduce
		file system overhead by not creating temporary files on
		disk.  Contributed by Exactis.com, Inc.
	New option DataFileBufferSize to control the maximum size of a
		memory-buffered data (df) file before a disk-based file is
		used.  Contributed by Exactis.com, Inc.
	New option XscriptFileBufferSize to control the maximum size of a
		memory-buffered transcript (xf) file before a disk-based
		file is used.  Contributed by Exactis.com, Inc.
	sendmail implements RFC 2476 (Message Submission), e.g., it can
		now listen on several different ports.  Use:
		O DaemonPortOptions=Name=MSA, Port=587, M=E
		to run a Message Submission Agent (MSA); this is turned
		on by default in m4-generated .cf files; it can be turned
		off with FEATURE(`no_default_msa').
	The 'XUSR' SMTP command is deprecated.  Mail user agents should
		begin using RFC 2476 Message Submission for initial user
		message submission.  XUSR may disappear from a future release.
	The new '-G' (relay (gateway) submission) command line option
		indicates that the message being submitted from the command
		line is for relaying, not initial submission.  This means
		the message will be rejected if the addresses are not fully
		qualified and no canonicalization will be done.  Future
		releases may even reject improperly formed messages.
	The '-U' (initial user submission) command line option is
		deprecated and may be removed from a future release.
		Mail user agents should begin using '-G' to indicate that
		this is a relay submission (the inverse of -U).
	The next release of sendmail will assume that any message submitted
		from the command line is an initial user submission and act
		accordingly.
	If sendmail doesn't have enough privileges to run a .forward
		program or deliver to file as the owner of that file, the
		address is marked as unsafe.  This means if RunAsUser is
		set, users won't be able to use programs or delivery to
		files in their .forward files.  Administrators can override
		this by setting the DontBlameSendmail option to the new
		setting NonRootSafeAddr.
	Allow group or world writable directories if the sticky bit is set
		on the directory and DontBlameSendmail is set to
		TrustStickyBit.  Based on patch from Chris Metcalf of
		InCert Software.
	Prevent logging of unsafe directory paths for non-existent forward
		files if the new DontWarnForwardFileInUnsafeDirPath bit is
		set in the DontBlameSendmail option.  Requested by many.
	New Timeout.control option to limit the total time spent satisfying
		a control socket request.
	New Timeout.resolver options for controlling BIND resolver
		settings:
		Timeout.resolver.retrans
			Sets the resolver's retransmission time interval (in
			seconds).  Sets both Timeout.resolver.retrans.first
			and Timeout.resolver.retrans.normal.
		Timeout.resolver.retrans.first
			Sets the resolver's retransmission time interval (in
			seconds) for the first attempt to deliver a message.
		Timeout.resolver.retrans.normal
			Sets the resolver's retransmission time interval (in
			seconds) for all resolver lookups except the first
			delivery attempt.
		Timeout.resolver.retry
			Sets the number of times to retransmit a resolver
			query.  Sets both Timeout.resolver.retry.first
			and Timeout.resolver.retry.normal.
		Timeout.resolver.retry.first
			Sets the number of times to retransmit a resolver
			query for the first attempt to deliver a message.
		Timeout.resolver.retry.normal
			Sets the number of times to retransmit a resolver
			query for all resolver lookups except the first
			delivery attempt.
		Contributed by Exactis.com, Inc.
	Support multiple queue directories.  To use multiple queues, supply
		a QueueDirectory option value ending with an asterisk.  For
		example, /var/spool/mqueue/q* will use all of the
		directories or symbolic links to directories beginning with
		'q' in /var/spool/mqueue as queue directories.  Keep in
		mind, the queue directory structure should not be changed
		while sendmail is running.  Queue runs create a separate
		process for running each queue unless the verbose flag is
		given on a non-daemon queue run.  New items are randomly
		assigned to a queue.  Contributed by Exactis.com, Inc.
	Support different directories for qf, df, and xf queue files; if
		subdirectories or symbolic links to directories of those names
		exist in the queue directories, they are used for the
		corresponding queue files.  Keep in mind, the queue
		directory structure should not be changed while sendmail is
		running.  Proposed by Mathias Koerber of Singapore
		Telecommunications Ltd.
	New queue file naming system which uses a filename guaranteed to be
		unique for 60 years.  This allows queue IDs to be assigned
		without fancy file system locking.  Queued items can be
		moved between queues easily.  Contributed by Exactis.com,
		Inc.
	Messages which are undeliverable due to temporary address failures
		(e.g., DNS failure) will now go to the FallBackMX host, if
		set.  Contributed by Exactis.com, Inc.
	New command line option '-L tag' which sets the identifier used for
		syslog.  Contributed by Exactis.com, Inc.
	QueueSortOrder=Filename will sort the queue by filename.  This
		avoids opening and reading each queue file when preparing
		to run the queue.  Contributed by Exactis.com, Inc.
	Shared memory counters and microtimers functionality has been
		donated by Exactis.com, Inc.
	The SCCS ID tags have been replaced with RCS ID tags.
	Allow trusted users (those on a T line or in $=t) to set the
		QueueDirectory (Q) option without an X-Authentication-Warning:
		being added.  Suggested by Michael K. Sanders.
	IPv6 support based on patches from John Kennedy of Cal State
		University, Chico, Motonori Nakamura of Kyoto University,
		and John Beck of Sun Microsystems.
	In low-disk space situations, where sendmail would previously refuse
		connections, still accept them, but only allow ETRN commands.
		Suggested by Mathias Koerber of Singapore Telecommunications
		Ltd.
	The [IPC] builtin mailer now allows delivery to a UNIX domain socket
		on systems which support them.  This can be used with LMTP
		local delivery agents which listen on a named socket.  An
		example mailer might be:
			Mexecmail, P=[IPC], F=lsDFMmnqSXzA5@/:|, E=\r\n,
				S=10, R=20/40, T=DNS/RFC822/X-Unix,
				A=FILE /var/run/lmtpd
		Code contributed by Lyndon Nerenberg of Messaging Direct.
	The [TCP] builtin mailer name is now deprecated.  Use [IPC]
		instead.
	The first mailer argument in the [IPC] mailer is now checked for a
		legitimate value.  Possible values are TCP (for TCP/IP
		connections), IPC (which will be deprecated in a future
		version), and FILE (for UNIX domain socket delivery).
	PrivacyOptions=goaway no longer includes the noetrn and the noreceipts
		flags.
	PrivacyOptions=nobodyreturn instructs sendmail not to include the
		body of the original message on delivery status
		notifications.
	Don't announce DSN if PrivacyOptions=noreceipts is set.  Problem noted
		by Dan Bernstein, fix from Robert Harker of Harker Systems.
	Accept the SMTP RSET command even when rejecting commands due to TCP
		Wrappers or the check_relay ruleset.  Problem noted by
		Steve Schweinhart of America Online.
	Warn if OperatorChars is set multiple times.  OperatorChars should
		not be set after rulesets are defined.  Suggested by
		Mitchell Blank Jr of Exec-PC.
	Do not report temporary failure on delivery to files.  In
		interactive delivery mode, this would result in two SMTP
		responses after the DATA command.  Problem noted by
		Nik Conwell of Boston University.
	Check file close when mailing to files.  Problem noted by Nik
		Conwell of Boston University.
	Avoid a segmentation fault when using the LDAP map.  Patch from
		Curtis W. Hillegas of Princeton University.
	Always bind to the LDAP server regardless of whether you are using
		ldap_open() or ldap_init().  Fix from Raj Kunjithapadam of
		@Home Network.
	New ruleset trust_auth to determine whether a given AUTH=
		parameter of the MAIL command should be trusted.  See SMTP
		AUTH, cf/README, and doc/op/op.ps.
	Allow new named config file rules check_vrfy, check_expn, and
		check_etrn for VRFY, EXPN, and ETRN commands, respectively,
		similar to check_rcpt etc.
	Introduce new macros ${rcpt_mailer}, ${rcpt_host}, ${rcpt_addr},
		${mail_mailer}, ${mail_host}, ${mail_addr} that hold
		the results of parsing the RCPT and MAIL arguments, i.e.
		the resolved triplet from $#mailer $@host $:addr.
		From Kari Hurtta of the Finnish Meteorological Institute.
	New macro ${client_resolve} which holds the result of the resolve
		call for ${client_name}: OK, FAIL, FORGED, TEMP.  Proposed
		by Kari Hurtta of the Finnish Meteorological Institute.
	New macros ${dsn_notify}, ${dsn_envid}, and ${dsn_ret} that hold
		the corresponding DSN parameter values.  Proposed by
		Mathias Herberts.
	New macro ${msg_size} which holds the value of the SIZE= parameter,
		i.e., usually the size of the message (in an ESMTP dialogue),
		before the message has been collected, thereafter it holds
		the message size as computed by sendmail (and can be used
		in check_compat).
	The macro ${deliveryMode} now specifies the current delivery mode
		sendmail is using instead of the value of the DeliveryMode
		option.
	New macro ${ntries} holds the number of delivery attempts.
	Drop explicit From: if same as what would be generated only if it is
		a local address.  From Motonori Nakamura of Kyoto University.
	Write pid to file also if sendmail only processes the queue.
		Proposed by Roy J. Mongiovi of Georgia Tech.
	Log "low on disk space" only when necessary.
	New macro ${load_avg} can be used to check the current load average.
		Suggested by Scott Gifford of The Internet Ramp.
	Return-Receipt-To: header implies DSN request if option RrtImpliesDsn
		is set.
	Flag -S for maps to specify the character which is substituted
		for spaces (instead of the default given by O BlankSub).
	Flag -D for maps: perform no lookup in deferred delivery mode.
		This flag is set by default for the host map.  Based on a
		proposal from Ian MacPhedran of the University of Saskatchewan.
	Open maps only on demand, not at startup.
	Log warning about unsupported IP address families.
	New option MaxHeadersLength allows to specify a maximum length
		of the sum of all headers.  This can be used to prevent
		a denial-of-service attack.
	New option MaxMimeHeaderLength which limits the size of MIME
		headers and parameters within those headers.  This option
		is intended to protect mail user agents from buffer
		overflow attacks.
	Added option MaxAliasRecursion to specify the maximum depth of
		alias recursion.
	New flag F=6 for mailers to strip headers to seven bit.
	Map type syslog to log the key via syslogd.
	Entries in the alias file can be continued by putting a backslash
		directly before the newline.
	New option DeadLetterDrop to define the location of the system-wide
		dead.letter file, formerly hardcoded to
		/usr/tmp/dead.letter.  If this option is not set (the
		default), sendmail will not attempt to save to a
		system-wide dead.letter file if it can not bounce the mail
		to the user nor postmaster.  Instead, it will rename the qf
		file as it has in the past when the dead.letter file
		could not be opened.
	New option PidFile to define the location of the pid file.  The
		value of this option is macro expanded.
	New option ProcessTitlePrefix specifies a prefix string for the
		process title shown in 'ps' listings.
	New macros for use with the PidFile and ProcessTitlePrefix options
		(along with the already existing macros):
		${daemon_info}      Daemon information, e.g.
		                    SMTP+queueing@00:30:00
		${daemon_addr}	    Daemon address, e.g., 0.0.0.0
		${daemon_family}    Daemon family, e.g., inet, inet6, etc.
		${daemon_name}      Daemon name, e.g., MSA.
		${daemon_port}	    Daemon port, e.g., 25
		${queue_interval}   Queue run interval, e.g., 00:30:00
	New macros especially for virtual hosting:
		${if_name}	hostname of interface of incoming connection.
		${if_addr}	address of interface of incoming connection.
		The latter is only set if the interface does not belong to the
		loopback net.
	If a message being accepted via a method other than SMTP and
		would be rejected by a header check, do not send the message.
		Suggested by Phil Homewood of Mincom Pty Ltd.
	Don't strip comments for header checks if $>+ is used instead of $>.
		Provide header value as quoted string in the macro
		${currHeader} (possibly truncated to MAXNAME).  Suggested by
		Jan Krueger of Unix-AG of University of Hannover.
		The length of the header value is stored in ${hdrlen}.
	H*: allows to specify a default ruleset for header checks.  This
		ruleset will only be called if the individual header does
		not have its own ruleset assigned.  Suggested by Jan
		Krueger of Unix-AG of University of Hannover.
		The name of the header field stored in ${hdr_name}.
	Comments (i.e., text within parentheses) in rulesets are not
		removed if the config file version is greater than or equal
		to 9.  For example, "R$+ ( 1 )		$@ 1" matches the
		input "token (1)" but does not match "token".
	Avoid removing the Content-Transfer-Encoding MIME header on
		MIME messages.  Problem noted by Sigurbjorn B. Larusson of
		Multimedia Consumer Services.  Fix from Per Hedeland of
		Ericsson.
	Avoid duplicate Content-Transfer-Encoding MIME header on
		messages with 8-bit text in headers.  Problem noted by
		Per Steinar Iversen of Oslo College.  Fix from Per Hedeland
		of Ericsson.
	Avoid keeping maps locked longer than necessary when re-opening a
		modified database map file.  Problem noted by Chris Adams
		of Renaissance Internet Services.
	Resolving to the $#error mailer with a temporary failure code (e.g.,
		$#error $@ tempfail $: "400 Temporary failure") will now
		queue up the message instead of bouncing it.
	Be more liberal in acceptable responses to an SMTP RSET command as
		standard does not provide any indication of what to do when
		something other than 250 is received.  Based on a patch
		from Steve Schweinhart of America Online.
	New option TrustedUser allows to specify a user who can own
		important files instead of root.  This requires HASFCHOWN.
	Fix USERDB conditional so compiling with NEWDB or HESIOD and
		setting USERDB=0 works.  Fix from Jorg Zanger of Schock.
	Fix another instance (similar to one in 8.9.3) of a network failure
		being mis-logged as "Illegal Seek" instead of whatever
		really went wrong.  From John Beck of Sun Microsystems.
	$? tests also whether the macro is non-null.
	Print an error message if a mailer definition contains an invalid
		equate name.
	New mailer equate /= to specify a directory to chroot() into before
		executing the mailer program.  Suggested by Igor Vinokurov.
	New mailer equate W= to specify the maximum time to wait for the
		mailer to return after sending all data to it.
	Only free memory from the process list when adding a new process
		into a previously filled slot.  Previously, the memory was
		freed at removal time.  Since removal can happen in a
		signal handler, this may leave the memory map in an
		inconsistent state.  Problem noted by Jeff A. Earickson and
		David Cooley of Colby College.
	When using the UserDB @hostname catch-all, do not try to lookup
		local users in the passwd file.  The UserDB code has
		already decided the message will be passed to another host
		for processing.  Fix from Tony Landells of Burdett
		Buckeridge Young Limited.
	Support LDAP authorization via either a file containing the
		password or Kerberos V4 using the new map options
		'-ddistinguished_name', '-Mmethod', and '-Pfilename'.  The
		distinguished_name is who to login as.  The method can be
		one of LDAP_AUTH_NONE, LDAP_AUTH_SIMPLE, or
		LDAP_AUTH_KRBV4.  The filename is the file containing the
		secret key for LDAP_AUTH_SIMPLE or the name of the Kerberos
		ticket file for LDAP_AUTH_KRBV4.  Patch from Booker Bense
		of Stanford University.
	The ldapx map has been renamed to ldap.  The use of ldapx is
		deprecated and will be removed in a future version.
	If the result of an LDAP search returns a multi-valued attribute
		and the map has the column delimiter set, it turns that
		response into a delimiter separated string.  The LDAP map
		will traverse multiple entries as well.  LDAP alias maps
		automatically set the column delimiter to the comma.
		Based on patch from Booker Bense of Stanford University and
		idea from Philip A. Prindeville of Mirapoint, Inc.
	Support return of multiple values for a single LDAP lookup.  The
		values to be returned should be in a comma separated string.
		For example, `-v "email,emailother"'.  Patch from
		Curtis W. Hillegas of Princeton University.
	Allow the use of LDAP for alias maps.
	If no LDAP attributes are specified in an LDAP map declaration, all
		attributes found in the match will be returned.
	Prevent commas in quoted strings in the AliasFile value from
		breaking up a single entry into multiple entries.  This is
		needed for LDAP alias file specifications to allow for
		comma separated key and value strings.
	Keep connections to LDAP server open instead of opening and closing
		for each lookup.  To reduce overhead, sendmail will cache
		connections such that multiple maps which use the same
		host, port, bind DN, and authentication will only result in
		a single connection to that host.
	Put timeout in the proper place for USE_LDAP_INIT.
	Be more careful about checking for errors and freeing memory on
		LDAP lookups.
	Use asynchronous LDAP searches to save memory and network
		resources.
	Do not copy LDAP query results if the map's match only flag is set.
	Increase portability to the Netscape LDAP libraries.
	Change the parsing of the LDAP filter specification.  '%s' is still
		replaced with the literal contents of the map lookup key --
		note that this means a lookup can be done using the LDAP
		special characters.  The new '%0' token can be used instead
		of '%s' to encode the key buffer according to RFC 2254.
		For example, if the LDAP map specification contains '-k
		"(user=%s)"' and a lookup is done on "*", this would be
		equivalent to '-k "(user=*)"' -- matching ANY record with a
		user attribute.  Instead, if the LDAP map specification
		contains '-k "(user=%0)"' and a lookup is done on "*", this
		would be equivalent to '-k "(user=\2A)"' -- matching a user
		with the name "*".
	New LDAP map flags: "-1" requires a single match to be returned, if
		more than one is returned, it is equivalent to no records
		being found; "-r never|always|search|find" sets the LDAP
		alias dereference option; "-Z size" limits the number of
		matches to return.
	New option LDAPDefaultSpec allows a default map specification for
		LDAP maps.  The value should only contain LDAP specific
		settings such as "-h host -p port -d bindDN", etc.  The
		settings will be used for all LDAP maps unless they are
		specified in the individual map specification ('K'
		command).  This option should be set before any LDAP maps
		are defined.
	Prevent an NDBM alias file opening loop when the NDBM open
		continually fails.  Fix from Roy J. Mongiovi of Georgia
		Tech.
	Reduce memory utilization for smaller symbol table entries.  In
		particular, class entries get much smaller, which can be
		important if you have large classes.
	On network-related temporary failures, record the hostname which
		gave error in the queued status message.  Requested by
		Ulrich Windl of the Universitat Regensburg.
	Add new F=% mailer flag to allow for a store and forward
		configuration.  Mailers which have this flag will not attempt
		delivery on initial receipt of a message or on queue runs
		unless the queued message is selected using one of the
		-qI/-qR/-qS queue run modifiers or an ETRN request.  Code
		provided by Philip Guenther of Gustavus Adolphus College.
	New option ControlSocketName which, when set, creates a daemon
		control socket.  This socket allows an external program to
		control and query status from the running sendmail daemon
		via a named socket, similar to the ctlinnd interface to the
		INN news server.  Access to this interface is controlled by
		the UNIX file permissions on the named socket on most UNIX
		systems (see sendmail/README for more information).  An
		example control program is provided as contrib/smcontrol.pl.
	Change the default values of QueueLA from 8 to (8 * numproc) and
		RefuseLA from 12 to (12 * numproc) where numproc is the
		number of processors online on the system (if that can be
		determined).  For single processor machines, this change
		has no effect.
	Don't return body of message to postmaster on "Too many hops" bounces.
		Based on fix from Motonori Nakamura of Kyoto University.
	Give more detailed DSN descriptions for some cases.  Patch from
		Motonori Nakamura of Kyoto University.
	Logging of alias, forward file, and UserDB expansion now happens
		at LogLevel 11 or higher instead of 10 or higher.
	Logging of an envelope's complete delivery (the "done" message) now
		happens at LogLevel 10 or higher instead of 11 or higher.
	Logging of TCP/IP or UNIX standard input connections now happens at
		LogLevel 10 or higher.  Previously, only TCP/IP connections
		were logged, and on at LogLevel 12 or higher.  Setting
		LogLevel to 10 will now assist users in tracking frequent
		connection-based denial of service attacks.
	Log basic information about authenticated connections at LogLevel
		10 or higher.
	Log SMTP Authentication mechanism and author when logging the sender
		information (from= syslog line).
	Log the DSN code for each recipient if one is available as a new
		equate (dsn=).
	Macro expand PostmasterCopy and DoubleBounceAddress options.
	New "ph" map for performing ph queries in rulesets, see
		sendmail/README for details.  Contributed by Mark Roth
		of the University of Illinois at Urbana-Champaign.
	Detect temporary lookup failures in the host map if looking up a
		bracketed IP address.  Problem noted by Kari Hurtta of the
		Finnish Meteorological Institute.
	Do not report a Remote-MTA on local deliveries.  Problem noted by
		Kari Hurtta of the Finnish Meteorological Institute.
	When a forward file points to an alias which runs a program, run
		the program as the default user and the default group, not
		the forward file user.  This change also assures the
		:include: directives in aliases are also processed using
		the default user and group.  Problem noted by Sergiu
		Popovici of DNT Romania.
	Prevent attempts to save a dead.letter file for a user with
		no home directory (/no/such/directory).  Problem noted by
		Michael Brown of Finnigan FT/MS.
	Include message delay and number of tries when logging that a
		message has been completely delivered (LogLevel of 10 or
		above).  Suggested by Nick Hilliard of Ireland Online.
	Log the sender of a message even if none of the recipients were
		accepted.  If some of the recipients were rejected, it is
		helpful to know the sender of the message.
	Check the root directory (/) when checking a path for safety.
		Problem noted by John Beck of Sun Microsystems.
	Prevent multiple responses to the DATA command if DeliveryMode is
		interactive and delivering to an alias which resolves to
		multiple files.
	Macros in the helpfile are expanded if the helpfile version is 2 or
		greater (see below); the help function doesn't print the
		version of sendmail any longer, instead it is placed in
		the helpfile ($v).  Suggested by Chuck Foster of UUNET
		PIPEX.  Additionally, comment lines (starting with #) are
		skipped and a version line (#vers) is introduced.  The
		helpfile version for 8.10.0 is 2, if no version or an older
		version is found, a warning is logged.  The '#vers'
		directive should be placed at the top of the help file.
	Use fsync() when delivering to a file to guarantee the delivery to
		disk succeeded.  Suggested by Nick Christenson.
	If delivery to a file is unsuccessful, truncate the file back to its
		length before the attempt.
	If a forward points to a filename for delivery, change to the
		user's uid before checking permissions on the file.  This
		allows delivery to files on NFS mounted directories where
		root is remapped to nobody.  Problem noted by Harald
		Daeubler of Universitaet Ulm.
	purgestat and sendmail -bH purge only expired (Timeout.hoststatus)
		host status files, not all files.
	Any macros stored in the class $={persistentMacros} will be saved
		in the queue file for the message and set when delivery
		is attempted on the queued item.  Suggested by Kyle Jones of
		Wonderworks Inc.
	Add support for storing information between rulesets using the new
		macro map class.  This can be used to store information
		between queue runs as well using $={persistentMacros}.
		Based on an idea from Jan Krueger of Unix-AG of University
		of Hannover.
	New map class arith to allow for computations in rules.  The
		operation (+, -, *, /, l (for less than), and =) is given
		as key.  The two operands are specified as arguments; the
		lookup returns the result of the computation.  For example,
		"$(arith l $@ 4 $@ 2 $)" will return "FALSE" and
		"$(arith + $@ 4 $@ 2 $)" will return "6".
	Add new syntax for header declarations which decide whether to
		include the header based on a macro rather than a mailer
		flag:
			H?${MyMacro}?X-My-Header: ${MyMacro}
		This should be used along with $={persistentMacros}.
		It can be used for adding headers to a message based on
		the results of check_* and header check rulesets.
	Allow new named config file rule check_eoh which is called after
		all of the headers have been collected.  The input to the
		ruleset the number of headers and the size of all of the
		headers in bytes separated by $|.  This ruleset along with
		the macro storage map can be used to correlate information
		gathered between headers and to check for missing headers.
		See cf/README or doc/op/op.ps for an example.
	Change the default for the MeToo option to True to correspond
		to the clarification in the DRUMS SMTP Update spec.  This
		option is deprecated and will be removed from a future
		version.
	Change the sendmail binary default for SendMimeErrors to True.
	Change the sendmail binary default for SuperSafe to True.
	Display ruleset names in debug and address test mode output
		if referencing a named ruleset.
	New mailer equate m= which will limit the number of messages
		delivered per connection on an SMTP or LMTP mailer.
	Improve QueueSortOrder=Host by reversing the hostname before
		using it to sort.  Now all the same domains are really run
		through the queue together.  If they have the same MX host,
		then they will have a much better opportunity to use the
		connection cache if available.  This should be a reasonable
		performance improvement.  Patch from Randall Winchester of
		the University of Maryland.
	If a message is rejected by a header check ruleset, log who would
		have received the message if it had not been rejected.
	New "now" value for Timeout.queuereturn to bounce entries from the
		queue immediately.  No delivery attempt is made.
	Increase sleeping time exponentially after too many "bad" commands
		up to 4 minutes delay (compare MAX{BAD,NOOP,HELO,VRFY,ETRN}-
		COMMANDS).
	New option ClientPortOptions similar to DaemonPortOptions
		but for outgoing connections.
	New suboptions for DaemonPortOptions: Name (a name used for
		error messages and logging) and Modifiers, i.e.
			a	require authentication
			b	bind to interface through which mail has
				been received
			c	perform hostname canonification
			f	require fully qualified hostname
			h	use name of interface for outgoing HELO
				command
			C	don't perform hostname canonification
			E	disallow ETRN (see RFC 2476)
	New suboption for ClientPortOptions: Modifiers, i.e.
			h	use name of interface for HELO command
	The version number for queue files (qf) has been incremented to 4.
	Log unacceptable HELO/EHLO domain name attempts if LogLevel is set
		to 10 or higher.  Suggested by Rick Troxel of the National
		Institutes of Health.
	If a mailer dies, print the status in decimal instead of octal
		format.  Suggested by Michael Shapiro of Sun Microsystems.
	Limit the length of all MX records considered for delivery to 8k.
	Move message priority from sender to recipient logging.  Suggested by
		Ulrich Windl of the Universitat Regensburg.
	Add support for Berkeley DB 3.X.
	Add fix for Berkeley DB 2.X fcntl() locking race condition.
		Requires a post-2.7.5 version of Berkeley DB.
	Support writing traffic log (sendmail -X option) to a FIFO.
		Patch submitted by Rick Heaton of Network Associates, Inc.
	Do not ignore Timeout settings in the .cf file when a Timeout
		sub-options is set on the command line.  Problem noted by
		Graeme Hewson of Oracle.
	Randomize equal preference MX records each time delivery is
		attempted via a new connection to a host instead of once per
		session.  Suggested by Scott Salvidio of Compaq.
	Implement enhanced status codes as defined by RFC 2034.
	Add [hostname] to class w for the names of all interfaces unless
		DontProbeInterfaces is set. This is useful for sending mails
		to hosts which have dynamically assigned names.
	If a message is bounced due to bad MIME conformance, avoid bouncing
		the bounce for the same reason.  If the body is not 8-bit
		clean, and EightBitMode isn't set to pass8, the body will
		not be included in the bounce.  Problem noted by Valdis
		Kletnieks of Virginia Tech.
	The timeout for sending a message via SMTP has been changed from
		'${msgsize} / 16 + (${nrcpts} * 300)' to a timeout which
		simply checks for progress on sending data every 5 minutes.
		This will detect the inability to send information quicker
		and reduce the number of processes simply waiting to
		timeout.
	Prevent a segmentation fault on systems which give a partial filled
		interface address structure when loading the system network
		interface addresses.  Fix from Reinier Bezuidenhout of
		Nanoteq.
	Add a compile-time configuration macro, MAXINTERFACES, which
		indicates the number of interfaces to read when probing
		for hostnames and IP addresses for class w ($=w).  The
		default value is 512.  Based on idea from Reinier
		Bezuidenhout of Nanoteq.
	If the RefuseLA option is set to 0, do not reject connections based
		on load average.
	Allow ruleset 0 to have a name.  Problem noted by Neil Rickert of
		Northern Illinois University.
	Expand the Return-Path: header at delivery time, after "owner-"
		envelope splitting has occurred.
	Don't try to sort the queue if there are no entries. Patch from
		Luke Mewburn from RMIT University.
	Add a "/quit" command to address test mode.
	Include the proper sender in the UNIX "From " line and Return-Path:
		header when undeliverable mail is saved to ~/dead.letter.
		Problem noted by Kari Hurtta of the Finnish Meteorological
		Institute.
	The contents of a class can now be copied to another class using
		the syntax: "C{Dest} $={Source}".  This would copy all of
		the items in class $={Source} into the class $={Dest}.
	Include original envelope's error transcript in bounces created for
		split (owner-) envelopes to see the original errors when
		the recipients were added.  Based on fix from Motonori
		Nakamura of Kyoto University.
	Show reason for permanent delivery errors directly after the
		addresses.  From Motonori Nakamura of Kyoto University.
	Prevent a segmentation fault when bouncing a split-envelope
		message.  Patch from Motonori Nakamura of Kyoto University.
	If the specification for the queue run interval (-q###) has a
		syntax error, consider the error fatal and exit.
	Pay attention to CheckpointInterval during LMTP delivery.  Problem
		noted by Motonori Nakamura of Kyoto University.
	On operating systems which have setlogin(2), use it to set the
		login name to the RunAsUserName when starting as a daemon.
		This is for delivery to programs which use getlogin().
		Based on fix from Motonori Nakamura of Kyoto University.
	Differentiate between "command not implemented" and "command
		unrecognized" in the SMTP dialogue.
	Strip returns from forward and include files.  Problem noted by
		Allan E Johannesen of Worcester Polytechnic Institute.
	Prevent a core dump when using 'sendmail -bv' on an address which
		resolves to the $#error mailer with a temporary failure.
		Based on fix from Neil Rickert of Northern Illinois
		University.
	Prevent multiple deliveries of a message with a "non-local alias"
		pointing to a local user, if canonicalization fails
		the message was requeued *and* delivered to the alias.
	If an invalid ruleset is declared, the ruleset name could be
		ignored and its rules added to S0.  Instead, ignore the
		ruleset lines as well.
	Avoid incorrect Final-Recipient, Action, and X-Actual-Recipient
		success DSN fields as well as duplicate entries for a
		single address due to S5 and UserDB processing.  Problems
		noted by Kari Hurtta of the Finnish Meteorological
		Institute.
	Turn off timeouts when exiting sendmail due to an interrupt signal
		to prevent the timeout from firing during the exit process.
		Problem noted by Michael Shapiro of Sun Microsystems.
	Do not append @MyHostName to non-RFC822 addresses output by the EXPN
		command or on Final-Recipient: and X-Actual-Recipient: DSN
		headers.  Non-RFC822 addresses include deliveries to
		programs, file, DECnet, etc.
	Fix logic for determining if a local user is using -f or -bs to
		spoof their return address.  Based on idea from Neil Rickert
		of Northern Illinois University and patch from Per Hedeland
		of Ericsson.
	Report the proper UID in the bounce message if an :include: file is
		owned by a uid that doesn't map to a username and the
		:include: file contains delivery to a file or program.
		Problem noted by John Beck of Sun Microsystems.
	Avoid the attempt of trying to send a second SMTP QUIT command if
		the remote server responds to the first QUIT with a 4xx
		response code and drops the connection.  This behavior was
		noted by Ulrich Windl of the Universitat Regensburg when
		sendmail was talking to the Mercury 1.43 MTA.
	If a hostname lookup times out and ServiceSwitchFile is set but the
		file is not present, the lookup failure would be marked as
		a permanent failure instead of a temporary failure.  Fix
		from Russell King of the ARM Linux Project.
	Handle aliases or forwards which deliver to programs using tabs
		instead of spaces between arguments.  Problem noted by Randy
		Wormser.  Fix from Neil Rickert of Northern Illinois
		University.
	Allow MaxRecipientsPerMessage option to be set on the command line
		by normal users (e.g., sendmail won't drop its root
		privileges) to allow overrides for message submission via
		'sendmail -bs'.
	Set the names for help file and statistics file to "helpfile" and
		"statistics", respectively, if no parameters are given for
		them in the .cf file.
	Avoid bogus 'errbody: I/O Error -7' log messages when sending
		success DSN messages for messages relayed to non-DSN aware
		systems.  Problem noted by Juergen Georgi of RUS University
		of Stuttgart and Kyle Tucker of Parexel International.
	Prevent +detail information from interfering with local delivery to
		multiple users in the same transaction (F=m).
	Add H_FORCE flag for the X-Authentication-Warning: header, so it
		will be added even if one already exists.  Problem noted
		by Michal Zalewski of Marchew Industries.
	Stop processing SMTP commands if the SMTP connection is dropped.
		This prevents a remote system from flooding the connection
		with commands and then disconnecting.  Previously, the
		server would process all of the buffered commands.  Problem
		noted by Michal Zalewski of Marchew Industries.
	Properly process user-supplied headers beginning with '?'.  Problem
		noted by Michal Zalewski of Marchew Industries.
	If multiple header checks resolve to the $#error mailer, use the
		last permanent (5XX) failure if any exist.  Otherwise, use
		the last temporary (4XX) failure.
	RFC 1891 requires "hexchar" in a "xtext" to be upper case.  Patch
		from Ronald F. Guilmette of Infinite Monkeys & Co.
	Timeout.ident now defaults to 5 seconds instead of 30 seconds to
		prevent the now common delays associated with mailing to a
		site which drops IDENT packets.  Suggested by many.
	Persistent host status data is not reloaded disk when current data
		is available in the in-memory cache.  Problem noted by Per
		Hedeland of Ericsson.
	mailq displays unprintable characters in addresses as their octal
		representation and a leading backslash.  This avoids problems
		with "unprintable" characters.  Problem noted by Michal
		Zalewski of the "Internet for Schools" project (IdS).
	The mail line length limit (L= equate) was adding the '!' indicator
		one character past the limit.  This would cause subsequent
		hops to break the line again.  The '!' is now placed in
		the last column of the limit if the line needs to be broken.
		Problem noted by Joe Pruett of Q7 Enterprises.  Based on fix
		from Per Hedeland of Ericsson.
	If a resolver ANY query is larger than the UDP packet size, the
		resolver will fall back to TCP.  However, some
		misconfigured firewalls black 53/TCP so the ANY lookup
		fails whereas an MX or A record might succeed.  Therefore,
		don't fail on ANY queries.
	If an SMTP recipient is rejected due to syntax errors in the
		address, do not send an empty postmaster notification DSN
		to the postmaster.  Problem noted by Neil Rickert of
		Northern Illinois University.
	Allow '_' and '.' in map names when parsing a sequence map
		specification.  Patch from William Setzer of North Carolina
		State University.
	Fix hostname in logging of read timeouts for the QUIT command on
		cached connections.  Problem noted by Neil Rickert of
		Northern Illinois University.
	Use a more descriptive entry to log "null" connections, i.e.,
		"host did not issue MAIL/EXPN/VRFY/ETRN during connection".
	Fix a file descriptor leak in ONEX mode.
	Portability:
		Reverse signal handling logic such that sigaction(2) with
			the SA_RESTART flag is the preferred method and the
			other signal methods are only tried if SA_RESTART
			is not available.  Problem noted by Allan E
			Johannesen of Worcester Polytechnic Institute.
		AIX 4.x supports the sa_len member of struct sockaddr.
			This allows network interface probing to work
			properly.  Fix from David Bronder of the
			University of Iowa.
		AIX 4.3 has snprintf() support.
		Use "PPC" as the architecture name when building under
			AIX.  This will be reflected in the obj.* directory
			name.
		Apple Darwin support based on Apple Rhapsody port.
		Fixed AIX 'make depend' method from Valdis Kletnieks of
			Virginia Tech.
		Digital UNIX has uname(2).
		GNU Hurd updates from Mark Kettenis of the University of
			Amsterdam.
		Improved HPUX 11.0 portability.
		Properly determine the number of CPUs on FreeBSD 2.X,
			FreeBSD 3.X, HP/UX 10.X and HP/UX 11.X.
		Remove special IRIX ABI cases from Build script and the OS
			files.  Use the standard 'cc' options used by SGI
			in building the operating system.  Users can
			override the defaults by setting confCC and
			confLIBSEARCHPATH appropriately.
		IRIX nsd map support from Bob Mende of SGI.
		Minor devtools fixes for IRIX from Bob Mende of SGI.
		Linux patch for IP_SRCROUTE support from Joerg Dorchain
			of MW EDV & ELECTRONIC.
		Linux now uses /usr/sbin for confEBINDIR in the build
			system.  From MATSUURA Takanori of Osaka University.
		Remove special treatment for Linux PPC in the build
			system.  From MATSUURA Takanori of Osaka University.
		Motorolla UNIX SYSTEM V/88 Release 4.0 support from
			Sergey Rusanov of the Republic of Udmurtia.
		NCR MP-RAS 3.x includes regular expression support.  From
			Tom J. Moore of NCR.
		NEC EWS-UX/V series settings for _PATH_VENDOR_CF and
			_PATH_SENDMAILPID from Oota Toshiya of
			NEC Computers Group Planning Division.
		Minor NetBSD owner/group tweaks from Ayamura Kikuchi, M.D.
		NEWS-OS 6.X listed SYSLOG_BUFSIZE as 256 in confENVDEF and
			1024 in conf.h.  Since confENVDEF would be used,
			use that value in conf.h.
		Use NeXT's NETINFO to get domain name.  From Gerd Knops of
			BITart Consulting.
		Use NeXT's NETINFO for alias and hostname resolution if
			AUTO_NETINFO_ALIASES and AUTO_NETINFO_HOSTS are
			defined.  Patch from Wilfredo Sanchez of Apple
			Computer, Inc.
		NeXT portability tweaks.  Problems reported by Dragan
			Milicic of the University of Utah and J. P. McCann
			of E I A.
		New compile flag FAST_PID_RECYCLE: set this if your system
			can reuse the same PID in the same second.
		New compile flag HASFCHOWN: set this if your OS has
			fchown(2).
		New compile flag HASRANDOM: set this to 0 if your OS does
			not have random(3).  rand() will be used instead.
		New compile flag HASSRANDOMDEV: set this if your OS has
			srandomdev(3).
		New compile flag HASSETLOGIN: set this if your OS has
			setlogin(2).
		Replace SINIX and ReliantUNIX support with version
			specific SINIX files.  From Gerald Rinske of
			Siemens Business Services.
		Use the 60-second load average instead of the 5 second load
			average on Compaq Tru64 UNIX (formerly Digital
			UNIX).  From Chris Teakle of the University of Qld.
		Use ANSI C by default for Compaq Tru64 UNIX.  Suggested by
			Randall Winchester of Swales Aerospace.
		Correct setgroups() prototype for Compaq Tru64 UNIX.
			Problem noted by Randall Winchester of Swales
			Aerospace.
		Hitachi 3050R/3050RX and 3500 Workstations running
			HI-UX/WE2 4.02, 6.10 and 7.10 from Motonori
			NAKAMURA of Kyoto University.
		New compile flag NO_GETSERVBYNAME: set this to disable
			use of getservbyname() on systems which can
			not lookup a service by name over NIS, such as
			HI-UX.  Patch from Motonori NAKAMURA of Kyoto
			University.
		Use devtools/bin/install.sh on SCO 5.x.  Problem noted
			by Sun Wenbing of the China Engineering and
			Technology Information Network.
		make depend didn't work properly on UNIXWARE 4.2.  Problem
			noted by Ariel Malik of Netology, Ltd.
		Use /usr/lbin as confEBINDIR for Compaq Tru64 (Digital UNIX).
		Set confSTDIO_TYPE to torek for BSD-OS, FreeBSD, NetBSD,
			and OpenBSD.
		A recent Compaq Ultrix 4.5 Y2K patch has broken detection
			of local_hostname_length().  See sendmail/README
			for more details.  Problem noted by Allan E
			Johannesen of Worcester Polytechnic Institute.
	CONFIG: Begin using /etc/mail/ for sendmail related files.  This
		affects a large number of files.  See cf/README for more
		details.
	CONFIG: New macro MAIL_SETTINGS_DIR contains the path (including
		trailing slash) for the mail settings directory.
	CONFIG: Increment version number of config file to 9.
	CONFIG: OSTYPE(`bsdi1.0') and OSTYPE(`bsdi2.0') have been
		deprecated and may be removed from a future release.
		BSD/OS users should begin using OSTYPE(`bsdi').
	CONFIG: OpenBSD 2.4 installs mail.local non-set-user-ID root.  This
		requires a new OSTYPE(`openbsd').  From Todd C. Miller of
		Courtesan Consulting.
	CONFIG: New OSTYPE(`hpux11') for HP/UX 11.X.
	CONFIG: A syntax error in check_mail would cause fake top-level
		domains (.BITNET, .DECNET, .FAX, .USENET, and .UUCP) to
		be improperly rejected as unresolvable.
	CONFIG: New FEATURE(`dnsbl') takes up to two arguments (name of
		DNS server, rejection message) and can be included
		multiple times.
	CONFIG: New FEATURE(`relay_mail_from') allows relaying if the
		mail sender is listed as RELAY in the access map (and tagged
		with From:).
	CONFIG: Optional tagging of LHS in the access map (Connect:,
		From:, To:) to enable finer control.
	CONFIG: New FEATURE(`ldap_routing') implements LDAP address
		routing.  See cf/README for a complete description of the
		new functionality.
	CONFIG: New variables for the new sendmail options:
		confAUTH_MECHANISMS		AuthMechanisms
		confAUTH_OPTIONS		AuthOptions
		confCLIENT_OPTIONS		ClientPortOptions
		confCONTROL_SOCKET_NAME		ControlSocketName
		confDEAD_LETTER_DROP		DeadLetterDrop
		confDEF_AUTH_INFO		DefaultAuthInfo
		confDF_BUFFER_SIZE		DataFileBufferSize
		confLDAP_DEFAULT_SPEC		LDAPDefaultSpec
		confMAX_ALIAS_RECURSION		MaxAliasRecursion
		confMAX_HEADERS_LENGTH		MaxHeadersLength
		confMAX_MIME_HEADER_LENGTH	MaxMimeHeaderLength
		confPID_FILE			PidFile
		confPROCESS_TITLE_PREFIX	ProcessTitlePrefix
		confRRT_IMPLIES_DSN		RrtImpliesDsn
		confTO_CONTROL			Timeout.control
		confTO_RESOLVER_RETRANS		Timeout.resolver.retrans
		confTO_RESOLVER_RETRANS_FIRST	Timeout.resolver.retrans.first
		confTO_RESOLVER_RETRANS_NORMAL	Timeout.resolver.retrans.normal
		confTO_RESOLVER_RETRY		Timeout.resolver.retry
		confTO_RESOLVER_RETRY_FIRST	Timeout.resolver.retry.first
		confTO_RESOLVER_RETRY_NORMAL	Timeout.resolver.retry.normal
		confTRUSTED_USER		TrustedUser
		confXF_BUFFER_SIZE		XscriptFileBufferSize
	CONFIG: confDAEMON_OPTIONS has been replaced by DAEMON_OPTIONS(),
		which takes the options as argument and can be used
		multiple times; see cf/README for details.
	CONFIG: Add a fifth mailer definition to MAILER(`smtp') called
		"dsmtp".  This mail provides on-demand delivery using the
		F=% mailer flag described above.  The "dsmtp" mailer
		definition uses the new DSMTP_MAILER_ARGS which defaults
		to "IPC $h".
	CONFIG: New variables LOCAL_MAILER_MAXMSGS, SMTP_MAILER_MAXMSGS,
		and RELAY_MAILER_MAXMSGS for setting the m= equate for the
		local, smtp, and relay mailers respectively.
	CONFIG: New variable LOCAL_MAILER_DSN_DIAGNOSTIC_CODE for setting
		the DSN Diagnostic-Code type for the local mailer.  The
		value should be changed with care.
	CONFIG: FEATURE(`local_lmtp') now sets the DSN Diagnostic-Code type
		for the local mailer to the proper value of "SMTP".
	CONFIG: All included maps are no longer optional by default; if
		there there is a problem with a map, sendmail will
		complain.
	CONFIG: Removed root from class E; use EXPOSED_USER(`root')
		to get the old behavior.  Suggested by Joe Pruett
		of Q7 Enterprises.
	CONFIG: MASQUERADE_EXCEPTION() defines hosts/subdomains which
		will not be masqueraded.  Proposed by Arne Wichmann
		of MPI Saarbruecken, Griff Miller of PGS Tensor,
		Jayme Cox of Broderbund Software Inc.
	CONFIG: A list of exceptions for FEATURE(`nocanonify') can be
		specified by CANONIFY_DOMAIN or CANONIFY_DOMAIN_FILE,
		i.e., a list of domains which are passed to $[ ... $]
		for canonification. Based on an idea from Neil Rickert
		of Northern Illinois University.
	CONFIG: If `canonify_hosts' is specified as parameter for
		FEATURE(`nocanonify') then addresses which have only
		a hostname, e.g., <user@host>, will be canonified.
	CONFIG: If FEATURE(`nocanonify') is turned on, a trailing dot is
		nevertheless added to addresses with more than one component
		in it.
	CONFIG: Canonification is no longer attempted for any host or domain
		in class 'P' ($=P).
	CONFIG: New class for matching virtusertable entries $={VirtHost} that
		can be populated by VIRTUSER_DOMAIN or VIRTUSER_DOMAIN_FILE.
		FEATURE(`virtuser_entire_domain') can be used to apply this
		class also to entire subdomains.  Hosts in this class are
		treated as canonical in SCanonify2, i.e., a trailing dot
		is added.
	CONFIG: If VIRTUSER_DOMAIN() or VIRTUSER_DOMAIN_FILE() are used,
		include $={VirtHost} in $=R (hosts allowed to relay).
	CONFIG: FEATURE(`generics_entire_domain') can be used to apply the
		genericstable also to subdomains of $=G.
	CONFIG: Pass "+detail" as %2 for virtusertable lookups.
		Patch from Noam Freedman from University of Chicago.
	CONFIG: Pass "+detail" as %1 for genericstable lookups.  Suggested
		by Raymond S Brand of rsbx.net.
	CONFIG: Allow @domain in genericstable to override masquerading.
		Suggested by Owen Duffy from Owen Duffy & Associates.
	CONFIG: LOCAL_DOMAIN() adds entries to class w.  Suggested by Steve
		Hubert of University of Washington.
	CONFIG: OSTYPE(`gnuhurd') has been replaced by OSTYPE(`gnu') as
		GNU is now the canonical system name.  From Mark
		Kettenis of the University of Amsterdam.
	CONFIG: OSTYPE(`unixware7') updates from Larry Rosenman.
	CONFIG: Do not include '=' in option expansion if there is no value
		associated with the option.  From Andrew Brown of
		Graffiti World Wide, Inc.
	CONFIG: Add MAILER(`qpage') to define a new pager mailer.  Contributed
		by Philip A. Prindeville of Enteka Enterprise Technology
		Services.
	CONFIG: MAILER(`cyrus') was not preserving case for mail folder
		names.  Problem noted by Randall Winchester of Swales
		Aerospace.
	CONFIG: RELAY_MAILER_FLAGS can be used to define additional flags
		for the relay mailer.  Suggested by Doug Hughes of Auburn
		University and Brian Candler.
	CONFIG: LOCAL_MAILER_FLAGS now includes 'P' (Add Return-Path:
		header) by default.  Suggested by Per Hedeland of Ericsson.
	CONFIG: Use SMART_HOST for bracketed addresses, e.g., user@[host].
		Suggested by Kari Hurtta of the Finnish Meteorological
		Institute.
	CONFIG: New macro MODIFY_MAILER_FLAGS to tweak *_MAILER_FLAGS;
		i.e., to set, add, or delete flags.
	CONFIG: If SMTP AUTH is used then relaying is allowed for any user
		who authenticated via a "trusted" mechanism, i.e., one that
		is defined via TRUST_AUTH_MECH(`list of mechanisms').
	CONFIG: FEATURE(`delay_checks') delays check_mail and check_relay
		after check_rcpt and allows for exceptions from the checks.
	CONFIG: Map declarations have been moved into their associated
		feature files to allow greater flexibility in use of
		sequence maps.  Suggested by Per Hedeland of Ericsson.
	CONFIG: New macro LOCAL_MAILER_EOL to override the default end of
		line string for the local mailer.  Requested by Il Oh of
		Willamette Industries, Inc.
	CONFIG: Route addresses are stripped, i.e., <@a,@b,@c:user@d> is
		converted to <user@d>
	CONFIG: Reject bogus return address of <@@hostname>, generated by
		Sun's older, broken configuration files.
	CONFIG: FEATURE(`nullclient') now provides the full rulesets of a
		normal configuration, allowing anti-spam checks to be
		performed.
	CONFIG: Don't return a permanent error (Relaying denied) if
		${client_name} can't be resolved just temporarily.
		Suggested by Kari Hurtta of the Finnish Meteorological
		Institute.
	CONFIG: Change numbered rulesets into named (which still can
		be accessed by their numbers).
	CONFIG: FEATURE(`nouucp') takes one parameter: reject or nospecial
		which describes whether to disallow "!" in the local part
		of an address.
	CONFIG: Call Local_localaddr from localaddr (S5) which can be used
		to rewrite an address from a mailer which has the F=5 flag
		set.  If the ruleset returns a mailer, the appropriate
		action is taken, otherwise the returned tokens are ignored.
	CONFIG: cf/ostype/solaris.m4 has been renamed to solaris2.pre5.m4
		and cf/ostype/solaris2.m4 is now a copy of solaris2.ml.m4.
		The latter is kept around for backward compatibility.
	CONFIG: Allow ":D.S.N:" for mailer/virtusertable "error:" entries,
		where "D.S.N" is an RFC 1893 compliant error code.
	CONFIG: Use /usr/lbin as confEBINDIR for Compaq Tru64 (Digital UNIX).
	CONFIG: Remove second space between username and date in UNIX From_
		line.  Noted by Allan E Johannesen of Worcester Polytechnic
		Institute.
	CONFIG: Make sure all of the mailers have complete T= equates.
	CONFIG: Extend FEATURE(`local_procmail') so it can now take
		arguments overriding the mailer program, arguments, and
		mailer definition flags.  This makes it possible to use
		other programs such as maildrop for local delivery.
	CONFIG: Emit warning if FEATURE(`local_lmtp') or
		FEATURE(`local_procmail') is given after MAILER(`local').
		Patch from Richard A. Nelson of IBM.
	CONFIG: Add SMTP Authentication information to Received: header
		default value (confRECEIVED_HEADER).
	CONFIG: Remove `l' flag from USENET_MAILER_FLAGS as it is not a
		local mailer.  Problem noted by Per Hedeland of Ericsson.
	CONTRIB: Added bounce-resender.pl from Brian R. Gaeke of the
		University of California at Berkeley.
	CONTRIB: Added domainmap.m4 from Mark D. Roth of the University of
		Illinois at Urbana-Champaign.
	CONTRIB: etrn.pl now recognizes bogus host names.  Patch from
		Bruce Barnett of GE's R&D Lab.
	CONTRIB: Patches for re-mqueue.pl by Graeme Hewson of Oracle
		Corporation UK.
	CONTRIB: Added qtool.pl to assist in managing the queues.
	DEVTOOLS: Prevent user environment variables from interfering with
		the Build scripts.  Problem noted by Ezequiel H. Panepucci of
		Yale University.
	DEVTOOLS: 'Build -M' will display the obj.* directory which will
		be used for building.
	DEVTOOLS: 'Build -A' will display the architecture that would be
		used for a fresh build.
	DEVTOOLS: New variable confRANLIB, set automatically by configure.sh.
	DEVTOOLS: New variable confRANLIBOPTS for the options to send to
		ranlib.
	DEVTOOLS: 'Build -O <path>' will have the object files build in
		<path>/obj.*.  Suggested by Bryan Costales of Exactis.
	DEVTOOLS: New variable confNO_MAN_BUILD which will prevent the
		building of the man pages when defined.  Suggested by Bryan
		Costales.
	DEVTOOLS: New variables confNO_HELPFILE_INSTALL and
		confNO_STATISTICS_INSTALL which will prevent the
		installation of the sendmail helpfile and statistics file
		respectively.  Suggested by Bryan Costales.
	DEVTOOLS: Recognize ReliantUNIX as SINIX.  Patch from Gerald Rinske
		of Siemens Business Services.
	DEVTOOLS: New variable confSTDIO_TYPE which defines the type of
		stdio library.  The new buffered file I/O depends on the
		Torek stdio library.  This option can be either portable or
		torek.
	DEVTOOLS: New variables confSRCADD and confSMSRCADD which
		correspond to confOBJADD and confSMOBJADD respectively.
		They should contain the C source files for the object files
		listed in confOBJADD and confSMOBJADD.  These file names
		will be passed to the 'make depend' stage of compilation.
	DEVTOOLS: New program specific variables for each of the programs
		in the sendmail distribution.  Each has the form
		`conf_prog_ENVDEF', for example, `conf_sendmail_ENVDEF'.
		The new variables are conf_prog_ENVDEF, conf_prog_LIBS,
		conf_prog_SRCADD, and conf_prog_OBJADD.
	DEVTOOLS: Build system redesign.  This should have little affect on
		building the distribution, but documentation on the changes
		are in devtools/README.
	DEVTOOLS: Don't allow 'Build -f file' if an object directory already
		exists.  Suggested by Valdis Kletnieks of Virginia Tech.
	DEVTOOLS: Rename confSRCDIR to confSMSRCDIR since it only identifies
		the path to the sendmail source directory.  confSRCDIR is a
		new variable which identifies the root of the source
		directories for all of the programs in the distribution.
	DEVTOOLS: confSRCDIR and confSMSRCDIR are now determined at Build
		time.  They can both still be overridden by setting the m4
		macro.
	DEVTOOLS: confSBINGRP now defaults to bin instead of kmem.
	DEVTOOLS: 'Build -Q prefix' uses devtools/Site/prefix.*.m4 for
		build configurations, and places objects in obj.prefix.*/.
		Complains as 'Build -f file' does for existing object
		directories.  Suggested by Tom Smith of Digital Equipment
		Corporation.
	DEVTOOLS: Setting confINSTALL_RAWMAN will install unformatted
		manual pages in the directory tree specified by
		confMANROOTMAN.
	DEVTOOLS: If formatting the manual pages fails, copy in the
		preformatted pages from the distribution.  The new variable
		confCOPY specifies the copying program.
	DEVTOOLS: Defining confFORCE_RMAIL will install rmail without
		question.  Suggested by Terry Lambert of Whistle
		Communications.
	DEVTOOLS: confSTFILE and confHFFILE can be used to change the names
		of the installed statistics and help files, respectively.
	DEVTOOLS: Remove spaces in `uname -r` output when determining
		operating system identity.  Problem noted by Erik
		Wachtenheim of Dartmouth College.
	DEVTOOLS: New variable confLIBSEARCHPATH to specify the paths that
		will be search for the libraries specified in confLIBSEARCH.
		Defaults to "/lib /usr/lib /usr/shlib".
	DEVTOOLS: New variables confSTRIP and confSTRIPOPTS for specifying
		how to strip binaries.  These are used by the new
		install-strip target.
	DEVTOOLS: New config file site.post.m4 which is included after
		the others (if it exists).
	DEVTOOLS: Change order of LIBS: first product specific libraries
		then the default ones.
	MAIL.LOCAL: Will not be installed set-user-ID root.  To use mail.local
		as local delivery agent without LMTP mode, use
		MODIFY_MAILER_FLAGS(`LOCAL', `+S')
		to set the S flag.
	MAIL.LOCAL: Do not reject addresses which would otherwise be
		accepted by sendmail.  Suggested by Neil Rickert of
		Northern Illinois University.
	MAIL.LOCAL: New -7 option which causes LMTP mode not to advertise
		8BITMIME in the LHLO response.  Suggested by Kari Hurtta of
		the Finnish Meteorological Institute.
	MAIL.LOCAL: Add support for the maillock() routines by defining
		MAILLOCK when compiling.  Also requires linking with
		-lmail.  Patch from Neil Rickert of Northern Illinois
		University.
	MAIL.LOCAL: Create a Content-Length: header if CONTENTLENGTH is
		defined when compiling.  Automatically set for Solaris 2.3
		and later.  Patch from Neil Rickert of Northern Illinois
		University.
	MAIL.LOCAL: Move the initialization of the 'notifybiff' address
		structure to the beginning of the program.  This ensures that
		the getservbyname() is done before any seteuid to a possibly
		unauthenticated user.  If you are using NIS+ and secure RPC
		on a Solaris system, this avoids syslog messages such as,
		"authdes_refresh: keyserv(1m) is unable to encrypt session
		key."  Patch from Neil Rickert of Northern Illinois
		University.
	MAIL.LOCAL: Support group writable mail spool files when MAILGID is
		set to the gid to use (-DMAILGID=6) when compiling.
		Patch from Neil Rickert of Northern Illinois University.
	MAIL.LOCAL: When a mail message included lines longer than 2046
		characters (in LMTP mode), mail.local split the incoming
		line up into 2046-character output lines (excluding the
		newline).  If an input line was 2047 characters long
		(excluding CR-LF) and the last character was a '.',
		mail.local saw it as the end of input, transferred it to the
		user mailbox and tried to write an `ok' back to sendmail.
		If the message was much longer, both sendmail and
		mail.local would deadlock waiting for each other to read
		what they have written.  Problem noted by Peter Jeremy of
		Alcatel Australia Limited.
	MAIL.LOCAL: New option -b to return a permanent error instead of a
		temporary error if a mailbox exceeds quota.  Suggested by
		Neil Rickert of Northern Illinois University.
	MAIL.LOCAL: The creation of a lockfile is subject to a global
		timeout to avoid starvation.
	MAIL.LOCAL: Properly parse addresses with multiple quoted
		local-parts.  Problem noted by Ronald F. Guilmette of
		Infinite Monkeys & Co.
	MAIL.LOCAL: NCR MP/RAS 3.X portability from Tom J. Moore of NCR.
	MAILSTATS: New -p option to invoke program mode in which stats are
		printed in a machine readable fashion and the stats file
		is reset.  Patch from Kevin Hildebrand of the University
		of Maryland.
	MAKEMAP: If running as root, automatically change the ownership of
		generated maps to the TrustedUser as specified in the
		sendmail configuration file.
	MAKEMAP: New -C option to accept an alternate sendmail
		configuration file to use for finding the TrustedUser
		option.
	MAKEMAP: New -u option to dump (unmap) a database.  Based on
		code contributed by Roy Mongiovi of Georgia Tech.
	MAKEMAP: New -e option to allow empty values.  Suggested by Philip
		A. Prindeville of Enteka Enterprise Technology Services.
	MAKEMAP: Compile cleanly on 64-bit operating systems.  Problem
		noted by Gerald Rinske of Siemens Business Services.
	OP.ME: Correctly document interaction between F=S and U= mailer
		equates.  Problem noted by Bob Halley of Internet Engines.
	OP.ME: Fixup Timeout documentation.  From Graeme Hewson of Oracle
		Corporation UK.
	OP.ME: The Timeout [r] option was incorrectly listed as "safe"
		(e.g., sendmail would not drop root privileges if the
		option was specified on the command line).  Problem noted
		by Todd C. Miller of Courtesan Consulting.
	PRALIASES: Handle the hash and btree map specifications for
		Berkeley DB.  Patch from Brian J. Coan of the
		Institute for Global Communications.
	PRALIASES: Read the sendmail.cf file for the location(s) of the
		alias file(s) if the -f option is not used.  Patch from
		John Beck of Sun Microsystems.
	PRALIASES: New -C option to specify an alternate sendmail
		configuration file to use for finding alias file(s).  Patch
		from John Beck of Sun Microsystems.
	SMRSH: allow shell commands echo, exec, and exit.  Allow command
		lists using || and &&.  Based on patch from Brian J. Coan
		of the Institute for Global Communications.
	SMRSH: Update README for the new Build system.  From Tim Pierce
		of RootsWeb Genealogical Data Cooperative.
	VACATION: Added vacation auto-responder to sendmail distribution.
	LIBSMDB: Added abstracted database library.  Works with Berkeley
		DB 1.85, Berkeley DB 2.X, Berkeley DB 3.X, and NDBM.
	Changed Files:
		The Build script in the various program subdirectories are
			no longer symbolic links.  They are now scripts
			which execute the actual Build script in
			devtools/bin.
		All the manual pages are now written against -man and not
			-mandoc as they were previously.
		Add a simple Makefile to every directory so make instead
			of Build will work (unless parameters are
			required for Build).
	New Directories:
		devtools/M4/UNIX
		include
		libmilter
		libsmdb
		libsmutil
		vacation
	Renamed Directories:
		BuildTools => devtools
		src => sendmail
	Deleted Files:
		cf/m4/nullrelay.m4
		devtools/OS/Linux.ppc
		devtools/OS/ReliantUNIX
		devtools/OS/SINIX
		sendmail/ldap_map.h
	New Files:
		INSTALL
		PGPKEYS
		cf/cf/generic-linux.cf
		cf/cf/generic-linux.mc
		cf/feature/delay_checks.m4
		cf/feature/dnsbl.m4
		cf/feature/generics_entire_domain.m4
		cf/feature/no_default_msa.m4
		cf/feature/relay_mail_from.m4
		cf/feature/virtuser_entire_domain.m4
		cf/mailer/qpage.m4
		cf/ostype/bsdi.m4
		cf/ostype/hpux11.m4
		cf/ostype/openbsd.m4
		contrib/bounce-resender.pl
		contrib/domainmap.m4
		contrib/qtool.8
		contrib/qtool.pl
		devtools/M4/depend/AIX.m4
		devtools/M4/list.m4
		devtools/M4/string.m4
		devtools/M4/subst_ext.m4
		devtools/M4/switch.m4
		devtools/OS/Darwin
		devtools/OS/GNU
		devtools/OS/SINIX.5.43
		devtools/OS/SINIX.5.44
		devtools/OS/m88k
		devtools/bin/find_in_path.sh
		mail.local/Makefile
		mailstats/Makefile
		makemap/Makefile
		praliases/Makefile
		rmail/Makefile
		sendmail/Makefile
		sendmail/bf.h
		sendmail/bf_portable.c
		sendmail/bf_portable.h
		sendmail/bf_torek.c
		sendmail/bf_torek.h
		sendmail/shmticklib.c
		sendmail/statusd_shm.h
		sendmail/timers.c
		sendmail/timers.h
		smrsh/Makefile
		vacation/Makefile
	Renamed Files:
		cf/ostype/gnuhurd.m4 => cf/ostype/gnu.m4
		sendmail/cdefs.h => include/sendmail/cdefs.h
		sendmail/sendmail.hf => sendmail/helpfile
		sendmail/mailstats.h => include/sendmail/mailstats.h
		sendmail/pathnames.h => include/sendmail/pathnames.h
		sendmail/safefile.c => libsmutil/safefile.c
		sendmail/snprintf.c => libsmutil/snprintf.c
		sendmail/useful.h => include/sendmail/useful.h
		cf/ostype/solaris2.m4 => cf/ostype/solaris2.pre5.m4
	Copied Files:
		cf/ostype/solaris2.ml.m4 => cf/ostype/solaris2.m4

8.9.3/8.9.3	1999/02/04
	SECURITY: Limit message headers to a maximum of 32K bytes (total
		of all headers in a single message) to prevent a denial of
		service attack.  This limit will be configurable in 8.10.
		Problem noted by Michal Zalewski of the "Internet for
		Schools" project (IdS).
	Prevent segmentation fault on an LDAP lookup if the LDAP map
		was closed due to an earlier failure.  Problem noted by
		Jeff Wasilko of smoe.org.  Fix from Booker Bense of
		Stanford University and Per Hedeland of Ericsson.
	Preserve the order of the MIME headers in multipart messages
		when performing the MIME header length check.  This
		will allow PGP signatures to function properly.  Problem
		noted by Lars Hecking of University College, Cork, Ireland.
	If ruleset 5 rewrote the local address to an :include: directive,
		the delivery would fail with an "aliasing/forwarding loop
		broken" error.  Problem noted by Eric C Hagberg of Morgan
		Stanley.  Fix from Per Hedeland of Ericsson.
	Allow -T to work for bestmx maps.  Fix from Aaron Schrab of
		ExecPC Internet Systems.
	During the transfer of a message in an SMTP transaction, if a
		TCP timeout occurs, the message would be properly queued
		for later retry but the failure would be logged as
		"Illegal Seek" instead of a timeout.  Problem noted by
		Piotr Kucharski of the Warsaw School of Economics (SGH)
		and Carles Xavier Munyoz Baldo of CTV Internet.
	Prevent multiple deliveries on a self-referencing alias if the
		F=w mailer flag is not set.  Problem noted by Murray S.
		Kucherawy of Concentric Network Corporation and Per
		Hedeland of Ericsson.
	Do not strip empty headers but if there is no value and a
		default is defined in sendmail.cf, use the default.
		Problem noted by Philip Guenther of Gustavus Adolphus
		College and Christopher McCrory of Netus, Inc.
	Don't inherit information about the sender (notably the full name)
		in SMTP (-bs) mode, since this might be called from inetd.
	Accept any 3xx reply code in response to DATA command instead of
		requiring 354.  This change will match the wording to be
		published in the updated SMTP specification from the DRUMS
		group of the IETF.
	Portability:
		AIX 4.2.0 or 4.2.1 may become updated by the fileset
			bos.rte.net level 4.2.0.2.  This introduces the
			softlink /usr/lib/libbind.a which should
			not be used.  It conflicts with the resolver
			built into libc.a.  "bind" has been removed
			from the confLIBSEARCH BuildTools variable.
			Users who have installed BIND 8.X will have
			to add it back in their site.config.m4 file.
			Problem noted by Ole Holm Nielsen of the
			Technical University of Denmark.
		CRAY TS 10.0.x from Sven Nielsen of San Diego
			Supercomputer Center.
		Improved LDAP version 3 integration based on input
			from Kurt D. Zeilenga of the OpenLDAP Foundation,
			John Beck of Sun Microsystems, and Booker Bense
			of Stanford University.
		Linux doesn't have a standard way to get the timezone
			between different releases.  Back out the
			change in 8.9.2 and don't attempt to derive
			a timezone.  Problem reported by Igor S. Livshits
			of the University of Illinois at Urbana-Champaign
			and Michael Dickens of Tetranet Communications.
		Reliant UNIX, the new name for SINIX, from Gert-Jan Looy
			of Siemens/SNI.
		SunOS 5.8 from John Beck of Sun Microsystems.
	CONFIG: SCO UnixWare 2.1 and 7.0 need TZ to get the proper
		timezone.  Problem noted by Petr Lampa of Technical
		University of Brno.
	CONFIG: Handle <@bestmx-host:user@otherhost> addressing properly
		when using FEATURE(bestmx_is_local).  Patch from Neil W.
		Rickert of Northern Illinois University.
	CONFIG: Properly handle source routed and %-hack addresses on
		hosts which the mailertable remaps to local:.  Patch from
		Neil W. Rickert of Northern Illinois University.
	CONFIG: Internal fixup of mailertable local: map value.  Patch from
		Larry Parmelee of Cornell University.
	CONFIG: Only add back +detail from host portion of mailer triplet
		on local mailer triplets if it was originally +detail.
		Patch from Neil W. Rickert of Northern Illinois University.
	CONFIG: The bestmx_is_local checking done in check_rcpt would
		cause later checks to fail.  Patch from Paul J Murphy of
		MIDS Europe.
	New Files:
		BuildTools/OS/CRAYTS.10.0.x
		BuildTools/OS/ReliantUNIX
		BuildTools/OS/SunOS.5.8

8.9.2/8.9.2	1998/12/30
	SECURITY: Remove five second sleep on accepting daemon connections
		due to an accept() failure.  This sleep could be used
		for a denial of service attack.
	Do not silently ignore queue files with names which are too long.
		Patch from Bryan Costales of InfoBeat, Inc.
	Do not store failures closing an SMTP session in persistent
		host status.  Reported by Graeme Hewson of Oracle
		Corporation UK.
	Allow symbolic link forward files if they are in safe directories.
		Problem noted by Andreas Schott of the Max Planck Society.
	Missing columns in a text map could cause a segmentation fault.
		Fix from David Lee of the University of Durham.
	Note that for 8.9.X, PrivacyOptions=goaway also includes the
		noetrn flag.  This is scheduled to change in a future
		version of sendmail.  Problem noted by Theo Van Dinter of
		Chrysalis Symbolic Designa and Alan Brown of Manawatu
		Internet Services.
	When trying to do host canonification in a Wildcard MX
		environment, try an MX lookup of the hostname without the
		default domain appended.  Problem noted by Olaf Seibert of
		Polderland Language & Speech Technology.
	Reject SMTP RCPT To: commands with only comments (i.e.
		'RCPT TO: (comment)'.  Problem noted by Earle Ake of
		Hassler Communication Systems Technology, Inc.
	Handle any number of %s in the LDAP filter spec.  Patch from
		Per Hedeland of Ericsson.
	Clear ldapx open timeouts even if the map open failed to prevent
		a segmentation fault.  Patch from Wayne Knowles of the
		National Institute of Water & Atmospheric Research Ltd.
	Do not syslog envelope clone messages when using address
		verification (-bv).  Problem noted by Kari Hurtta of the
		Finnish Meteorological Institute.
	Continue to perform queue runs while in daemon mode even if the
		daemon is rejecting connections due to a disk full
		condition.  Problem noted by JR Oldroyd of TerraNet
		Internet Services.
	Include full filename on installation of the sendmail.hf file
		in case the $HFDIR directory does not exist.  Problem
		noted by Josef Svitak of Montana State University.
	Close all maps when exiting the process with one exception.
		Berkeley DB can use internal shared memory locking for
		its memory pool.  Closing a map opened by another process
		will interfere with the shared memory and locks of the
		parent process leaving things in a bad state.  For
		Berkeley DB, only close the map if the current process
		is also the one that opened the map, otherwise only close
		the map file descriptor.  Thanks to Yoseff Francus of
		Collective Technologies for volunteering his system for
		extended testing.
	Avoid null pointer dereference on XDEBUG output for SMTP reply
		failures.  Problem noted by Carlos Canau of EUnet Portugal.
	On mailq and hoststat listings being piped to another program, such
		as more, if the pipe closes (i.e., the user quits more),
		stop sending output and exit.  Patch from Allan E Johannesen
		of Worcester Polytechnic Institute.
	In accordance with the documentation, LDAP map lookup failures
		are now considered temporary failures instead of permanent
		failures unless the -t flag is used in the map definition.
		Problem noted by Booker Bense of Stanford University and
		Eric C. Hagberg of Morgan Stanley.
	Fix by one error reporting on long alias names.  Problem noted by
		H. Paul Hammann of the Missouri Research and Education
		Network.
	Fix DontBlameSendmail=IncludeFileInUnsafeDirPath behavior.  Problem
		noted by Barry S. Finkel of Argonne National Laboratory.
	When automatically converting from 8 bit to quoted printable MIME,
		be careful not to miss a multi-part boundary if that
		boundary is preceded by a boundary-like line.  Problem
		noted by Andreas Raschle of Ansid Inc.  Fix from
		Kari Hurtta of the Finnish Meteorological Institute.
	Avoid bogus reporting of "LMTP tobuf overflow" when the buffer
		has enough space for the additional address.  Problem
		noted by Steve Cliffe of the University of Wollongong.
	Fix DontBlameSendmail=FileDeliveryToSymlink behavior.  Problem
		noted by Alex Vorobiev of Swarthmore College.
	If the check_compat ruleset resolves to the $#discard mailer,
		discard the current recipient.  Unlike check_relay,
		check_mail, and check_rcpt, the entire envelope is not
		discarded.  Problem noted by RZ D. Rahlfs.  Fix from
		Claus Assmann of Christian-Albrechts-University of Kiel.
	Avoid segmentation fault when reading ServiceSwitchFile files with
		bogus formatting.  Patch from Kari Hurtta of the Finnish
		Meteorological Institute.
	Support Berkeley DB 2.6.4 API change.
	OP.ME: Pages weren't properly output on duplexed printers.  Fix
		from Matthew Black of CSU Long Beach.
	Portability:
		Apple Rhapsody from Wilfredo Sanchez of Apple Computer, Inc.
		Avoid a clash with IRIX 6.2 getopt.h and the UserDatabase
			option structure.  Problem noted by Ashley M.
			Kirchner of Photo Craft Laboratories, Inc.
		Break out IP address to hostname translation for
			reading network interface addresses into
			class 'w'.  Patch from John Kennedy of
			Cal State University, Chico.
		AIX 4.x use -qstrict with -O3 to prevent the optimized
			from changing the semantics of the compiled
			program.  From Simon Travaglia of the
			University of Waikato, New Zealand.
		FreeBSD 2.2.2 and later support setusercontext().  From
			Peter Wemm of DIALix.
		FreeBSD 3.x fix from Peter Wemm of DIALix.
		IRIX 5.x has a syslog buffer size of 512 bytes.  From
			Nao NINOMIYA of Utsunomiya University.
		IRIX 6.5 64-bit Build support.
		LDAP Version 3 support from John Beck and Ravi Iyer
			of Sun Microsystems.
		Linux does not implement seteuid() properly.  From
			John Kennedy of Cal State University, Chico.
		Linux timezone type was set improperly.  From Takeshi Itoh
			of Bits Co., Ltd.
		NCR MP-RAS 3.x needs -lresolv for confLIBS.  From
			Tom J. Moore of NCR.
		NeXT 4.x correction to man page path.  From J. P. McCann
			of E I A.
		System V Rel 5.x (a.k.a UnixWare7 w/o BSD-Compatibility Libs)
			from Paul Gampe of the Asia Pacific Network
			Information Center.
		ULTRIX now requires an optimization limit of 970 from
			Allan E Johannesen of Worcester Polytechnic
			Institute.
		Fix extern declaration for sm_dopr().  Fix from Henk
			van Oers of Algemeen Nederlands Persbureau.
	CONFIG: Catch @hostname,user@anotherhost.domain as relaying.
		Problem noted by Mark Rogov of AirMedia, Inc.  Fix from
		Claus Assmann of Christian-Albrechts-University of Kiel.
	CONFIG: Do not refer to http://maps.vix.com/ on RBL rejections as
		there are multiple RBL's available and the MAPS RBL may
		not be the one in use.  Suggested by Alan Brown of
		Manawatu Internet Services.
	CONFIG: Properly strip route addresses (i.e., @host1:user@host2)
		when stripping down a recipient address to check for
		relaying.  Patch from Claus Assmann of
		Christian-Albrechts-University of Kiel and Neil W Rickert
		of Northern Illinois University.
	CONFIG: Allow the access database to override RBL lookups.  Patch
		from Claus Assmann of Christian-Albrechts-University of
		Kiel.
	CONFIG: UnixWare 7 support from Phillip P. Porch of The Porch
		Dot Com.
	CONFIG: Fixed check for deferred delivery mode warning.  Patch
		from Claus Assmann of Christian-Albrechts-University of
		Kiel and Per Hedeland of Ericsson.
	CONFIG: If a recipient using % addressing is used, e.g.
		user%site@othersite, and othersite's MX records are now
		checked for local hosts if FEATURE(relay_based_on_MX) is
		used.  Problem noted by Alexander Litvin of Lucky Net Ltd.
		Patch from Alexander Litvin of Lucky Net Ltd and
		Claus Assmann of Christian-Albrechts-University of Kiel.
	MAIL.LOCAL: Prevent warning messages from appearing in the LMTP
		stream.  Do not allow more than one response per recipient.
	MAIL.LOCAL: Handle routed addresses properly when using LMTP.  Fix
		from John Beck of Sun Microsystems.
	MAIL.LOCAL: Properly check for CRLF when using LMTP.  Fix from
		John Beck of Sun Microsystems.
	MAIL.LOCAL: Substitute MAILER-DAEMON for the LMTP empty sender in
		the envelope From header.
	MAIL.LOCAL: Accept underscores in hostnames in LMTP mode.
		Problem noted by Glenn A. Malling of Syracuse University.
	MAILSTATS: Document msgsrej and msgsdis fields in the man page.
		Problem noted by Richard Wong of Princeton University.
	MAKEMAP: Build group list so group writable files are allowed with
		the -s flag.  Problem noted by Curt Sampson of Internet
		Portal Services, Inc.
	PRALIASES: Automatically handle alias files created without the
		NULL byte at the end of the key.  Patch from John Beck of
		Sun Microsystems.
	PRALIASES: Support Berkeley DB 2.6.4 API change.
	New Files:
		BuildTools/OS/IRIX64.6.5
		BuildTools/OS/UnixWare.5.i386
		cf/ostype/unixware7.m4
		contrib/smcontrol.pl
		src/control.c

8.9.1/8.9.1	1998/07/02
	If both an OS specific site configuration file and a generic
		site.config.m4 file existed, only the latter was used
		instead of both.  Problem noted by Geir Johannessen of
		the Norwegian University of Science and Technology.
	Fix segmentation fault while converting 8 bit to 7 bit MIME
		multipart messages by trying to write to an unopened
		file descriptor.  Fix from Kari Hurtta of the Finnish
		Meteorological Institute.
	Do not assume Message: and Text: headers indicate the end of
		the header area when parsing MIME headers.  Problem noted
		by Kari Hurtta of the Finnish Meteorological Institute.
	Setting the confMAN#SRC Build variable would only effect the
		installation commands.  The man pages would still be
		built with .0 extensions.  Problem noted by Bryan
		Costales of InfoBeat, Inc.
	Installation of manual pages didn't honor the DESTDIR environment
		variable.  Problem noted by Bryan Costales of InfoBeat, Inc.
	If the check_relay ruleset resolved to the discard mailer, messages
		were still delivered.  Problem noted by Mirek Luc of NASK.
	Mail delivery to files would fail with an Operating System Error
		if sendmail was not running as root, i.e., RunAsUser was set.
		Problem noted by Leonard N. Zubkoff of Dandelion Digital.
	Prevent MinQueueAge from interfering from queued items created
		in the future, i.e., if the system clock was set ahead
		and then back.  Problem noted by Michael Miller of the
		University of Natal, Pietermaritzburg.
	Do not advertise ETRN support in ESTMP EHLO reply if noetrn is
		set in the PrivacyOptions option.  Fix from Ted Rule of
		Flextech TV.
	Log invalid persistent host status file lines instead of
		bouncing the message.  Problem noted by David Lindes of
		DaveLtd Enterprises.
	Move creation of empty sendmail.st file from installation to
		compilation.  Installation may be done from a read-only
		mount.  Fix from Bryan Costales of InfoBeat, Inc. and Ric
		Anderson of the Oasis Research Center, Inc.
	Enforce the maximum number of User Database entries limit.  Problem
		noted by Gary Buchanan of Credence Systems Inc.
	Allow dead.letter files in root's home directory.  Problem noted
		by Anna Ullman of Sun Microsystems.
	Program deliveries in forward files could be marked unsafe if
		any directory listed in the ForwardPath option did not
		exist.  Problem noted by Jorg Bielak of Coastal Web Online.
	Do not trust the length of the address structure returned by
		gethostbyname().  Problem noted by Chris Evans of Oxford
		University.
	If the SIZE= MAIL From: ESMTP parameter is too large, use the
		5.3.4 DSN status code instead of 5.2.2.  Similarly, for
		non-local deliveries, if the message is larger than the
		mailer maximum message size, use 5.3.4 instead of 5.2.3.
		Suggested by Antony Bowesman of
		Fujitsu/TeaWARE Mail/MIME System.
	Portability:
		Fix the check for an IP address reverse lookup for
			use in $&{client_name} on 64 bit platforms.
			From Gilles Gallot of Institut for Development
			and Resources in Intensive Scientific computing.
		BSD-OS uses .0 for man page extensions.  From Jeff Polk
			of BSDI.
		DomainOS detection for Build.  Also, version 10.4 and later
			ship a unistd.h.  Fixes from Takanobu Ishimura of
			PICT Inc.
		NeXT 4.x uses /usr/lib/man/cat for its man pages.  From
			J. P. McCann of E I A.
		SCO 4.X and 5.X include NDBM support.  From Vlado Potisk
			of TEMPEST, Ltd.
	CONFIG: Do not pass spoofed PTR results through resolver for
		qualification.  Problem noted by Michiel Boland of
		Digital Valley Internet Professionals; fix from
		Kari Hurtta of the Finnish Meteorological Institute.
	CONFIG: Do not try to resolve non-DNS hostnames such as UUCP,
		BITNET, and DECNET addresses for resolvable senders.
		Problem noted by Alexander Litvin of Lucky Net Ltd.
	CONFIG: Work around Sun's broken configuration which sends bounce
		messages as coming from @@hostname instead of <>.  LMTP
		would not accept @@hostname.
	OP.ME: Corrections to complex sendmail startup script from Rick
		Troxel of the National Institutes of Health.
	RMAIL: Do not install rmail by default, require 'make force-install'
		as this rmail isn't the same as others.  Suggested by
		Kari Hurtta of the Finnish Meteorological Institute.
	New Files:
		BuildTools/OS/DomainOS.10.4

8.9.0/8.9.0	1998/05/19
	SECURITY: To prevent users from reading files not normally
		readable, sendmail will no longer open forward, :include:,
		class, ErrorHeader, or HelpFile files located in unsafe
		(i.e., group or world writable) directory paths.  Sites
		which need the ability to override security can use the
		DontBlameSendmail option.  See the README file for more
		information.
	SECURITY: Problems can occur on poorly managed systems, specifically,
		if maps or alias files are in world writable directories.
		This fixes the change added to 8.8.6 to prevent links in these
		world writable directories.
	SECURITY: Make sure ServiceSwitchFile option file is not a link if
		it is in a world writable directory.
	SECURITY: Never pass a tty to a mailer -- if a mailer can get at the
		tty it may be able to push bytes back to the senders input.
		Unfortunately this breaks -v mode.  Problem noted by
		Wietse Venema of the Global Security Analysis Lab at
		IBM T.J. Watson Research.
	SECURITY: Empty group list if DontInitGroups is set to true to
		prevent program deliveries from picking up extra group
		privileges.  Problem reported by Wolfgang Ley of DFN-CERT.
	SECURITY: The default value for DefaultUser is now set to the uid and
		gid of the first existing user mailnull, sendmail, or daemon
		that has a non-zero uid.  If none of these exist, sendmail
		reverts back to the old behavior of using uid 1 and gid 1.
		This is a security problem for Linux which has chosen that
		uid and gid for user bin instead of daemon.  If DefaultUser
		is set in the configuration file, that value overrides this
		default.
	SECURITY: Since 8.8.7, the check for non-set-user-ID binaries
		interfered with setting an alternate group id for the
		RunAsUser option.  Problem noted by Randall Winchester of
		the University of Maryland.
	Add support for Berkeley DB 2.X.  Based on patch from John Kennedy
		of Cal State University, Chico.
	Remove support for OLD_NEWDB (pre-1.5 version of Berkeley DB).  Users
		which previously defined OLD_NEWDB=1 must now upgrade to the
		current version of Berkeley DB.
	Added support for regular expressions using the new map class regex.
		From Jan Krueger of Unix-AG of University of Hannover.
	Support for BIND 8.1.1's hesiod for hesiod maps and hesiod
		UserDatabases from Randall Winchester of the University
		of Maryland.
	Allow any shell for user shell on program deliveries on V1
		configurations for backwards compatibility on machines which
		do not have getusershell().  Fix from John Beck of Sun
		Microsystems.
	On operating systems which change the process title by reusing the
		argument vector memory, sendmail could corrupt memory if the
		last argument was either "-q" or "-d".  Problem noted by
		Frank Langbein of the University of Stuttgart.
	Support Local Mail Transfer Protocol (LMTP) between sendmail and
		mail.local on the F=z flag.
	Macro-expand the contents of the ErrMsgFile.  Previously this was
		only done if you had magic characters (0x81) to indicate
		macro expansion.  Now $x will be expanded.  This means that
		real dollar signs have to be backslash escaped.
	TCP Wrappers expects "unknown" in the hostname argument if the
		reverse DNS lookup for the incoming connection fails.
		Problem noted by Randy Grimshaw of Syracuse University and
		Wietse Venema of the Global Security Analysis Lab at
		IBM T.J. Watson Research.
	DSN success bounces generated from an invocation of sendmail -t
		would be sent to both the sender and MAILER-DAEMON.
		Problem noted by Claus Assmann of
		Christian-Albrechts-University of Kiel.
	Avoid "Error 0" messages on delivery mailers which exit with a
		valid exit value such as EX_NOPERM.  Fix from Andreas Luik
		of ISA Informationssysteme GmbH.
	Tokenize $&x expansions on right hand side of rules.  This eliminates
		the need to use tricks like $(dequote "" $&{client_name} $)
		to cause the ${client_name} macro to be properly tokenized.
	Add the MaxRecipientsPerMessage option: this limits the number of
		recipients that will be accepted in a single SMTP
		transaction.  After this number is reached, sendmail
		starts returning "452 Too many recipients" to all RCPT
		commands.  This can be used to limit the number of recipients
		per envelope (in particular, to discourage use of the server
		for spamming).  Note: a better approach is to restrict
		relaying entirely.
	Fixed pointer initialization for LDAP lmap struct, fixed -s option
		to ldapx map and added timeout for ldap_open call to
		avoid hanging sendmail in the event of hung LDAP servers.
		Patch from Booker Bense of Stanford University.
	Allow multiple -qI, -qR, or -qS queue run limiters.  For example,
		'-qRfoo -qRbar' would deliver mail to recipients with foo or
		bar in their address.  Patch from Allan E Johannesen of
		Worcester Polytechnic Institute.
	The bestmx map will now return a list of the MX servers for a host if
		passed a column delimiter via the -z map flag.  This can be
		used to check if the server is an MX server for the recipient
		of a message.  This can be used to help prevent relaying.
		Patch from Mitchell Blank Jr of Exec-PC.
	Mark failures for the *file* mailer and return bounce messages to the
		sender for those failures.
	Prevent bogus syslog timestamps on errors in sendmail.cf by
		preserving the TZ environment variable until TimeZoneSpec
		has been determined.  Problem noted by Ralf Hildebrandt of
		Technical University of Braunschweig.  Patch from Per Hedeland
		of Ericsson.
	Print test input in address test mode when input is not from the tty
		when the -v flag is given (i.e., sendmail -bt -v) to make
		output easier to decipher.  Problem noted by Aidan Nichol
		of Procter & Gamble.
	The LDAP map -s flag was not properly parsed and the error message
		given included the remainder of the arguments instead of
		solely the argument in error.  Problem noted by Aidan Nichol
		of Procter & Gamble.
	New DontBlameSendmail option.  This option allows administrators to
		bypass some of sendmail's file security checks at the expense
		of system security.  This should only be used if you are
		absolutely sure you know the consequences.  The available
		DontBlameSendmail options are:
			Safe
			AssumeSafeChown
			ClassFileInUnsafeDirPath
			ErrorHeaderInUnsafeDirPath
			GroupWritableDirPathSafe
			GroupWritableForwardFileSafe
			GroupWritableIncludeFileSafe
			GroupWritableAliasFile
			HelpFileinUnsafeDirPath
			WorldWritableAliasFile
			ForwardFileInGroupWritableDirPath
			IncludeFileInGroupWritableDirPath
			ForwardFileInUnsafeDirPath
			IncludeFileInUnsafeDirPath
			ForwardFileInUnsafeDirPathSafe
			IncludeFileInUnsafeDirPathSafe
			MapInUnsafeDirPath
			LinkedAliasFileInWritableDir
			LinkedClassFileInWritableDir
			LinkedForwardFileInWritableDir
			LinkedIncludeFileInWritableDir
			LinkedMapInWritableDir
			LinkedServiceSwitchFileInWritableDir
			FileDeliveryToHardLink
			FileDeliveryToSymLink
			WriteMapToHardLink
			WriteMapToSymLink
			WriteStatsToHardLink
			WriteStatsToSymLink
			RunProgramInUnsafeDirPath
			RunWritableProgram
	New DontProbeInterfaces option to turn off the inclusion of all the
		interface names in $=w on startup.  In particular, if you
		have lots of virtual interfaces, this option will speed up
		startup.  However, unless you make other arrangements, mail
		sent to those addresses will be bounced.
	Automatically create alias databases if they don't exist and
		AutoRebuildAliases is set.
	Add PrivacyOptions=noetrn flag to disable the SMTP ETRN command.
		Suggested by Christophe Wolfhugel of the Institut Pasteur.
	Add PrivacyOptions=noverb flag to disable the SMTP VERB command.
	When determining the client host name ($&{client_name} macro), do
		a forward (A) DNS lookup on the result of the PTR lookup
		and compare results.  If they differ or if the PTR lookup
		fails, &{client_name} will contain the IP address
		surrounded by square brackets (e.g., [127.0.0.1]).
	New map flag: -Tx appends "x" to lookups that return temporary failure
		(i.e, it is like -ax for the temporary failure case, in
		contrast to the success case).
	New syntax to do limited checking of header syntax.  A config line
		of the form:
			HHeader: $>Ruleset
		causes the indicated Ruleset to be invoked on the Header
		when read.  This ruleset works like the check_* rulesets --
		that is, it can reject mail on the basis of the contents.
	Limit the size of the HELO/EHLO parameter to prevent spammers
		from hiding their connection information in Received:
		headers.
	When SingleThreadDelivery is active, deliveries to locked hosts
		are skipped.  This will cause the delivering process to
		try the next MX host or queue the message if no other MX
		hosts are available.  Suggested by Alexander Litvin.
	The [FILE] mailer type now delivers to the file specified in the
		A= equate of the mailer definition instead of $u.  It also
		obeys all of the F= mailer flags such as the MIME
		7/8 bit conversion flags.  This is useful for defining
		a mailer which delivers to the same file regardless of the
		recipient (e.g., 'A=FILE /dev/null' to discard unwanted mail).
	Do not assume the identity of a remote connection is root@localhost
		if the remote connection closes the socket before the
		remote identity can be queried.
	Change semantics of the F=S mailer flag back to 8.7.5 behavior.
		Some mailers, including procmail, require that the real
		uid is left unchanged by sendmail.  Problem noted by Per
		Hedeland of Ericsson.
	No longer is the src/obj*/Makefile selected from a large list -- it
		is now generated using the information in BuildTools/OS/ --
		some of the details are determined dynamically via
		BuildTools/bin/configure.sh.
	The other programs in the sendmail distribution -- mail.local,
		mailstats, makemap, praliases, rmail, and smrsh -- now use
		the new Build method which creates an operating system
		specific Makefile using the information in BuildTools.
	Make 4xx reply codes to the SMTP MAIL command be non-sticky (i.e.,
		a failure on one message won't affect future messages to the
		same host).  This is necessary if the remote host sends
		a 451 error if the domain of the sender does not resolve
		as is common in anti-spam configurations.  Problem noted
		by Mitchell Blank Jr of Exec-PC.
	New "discard" mailer for check_* rulesets and header checking
		rulesets.  If one of the above rulesets resolves to the
		$#discard mailer, the commands will be accepted but the
		message will be completely discarded after it is accepting.
		This means that even if only one of the recipients
		resolves to the $#discard mailer, none of the recipients
		will receive the mail.  Suggested by Brian Kantor.
	All but the last cloned envelope of a split envelope were queued
		instead of being delivered.  Problem noted by John Caruso
		of CNET: The Computer Network.
	Fix deadlock situation in persistent host status file locking.
	Syslog an error if a user forward file could not be read due to
		an error.  Patch from John Beck of Sun Microsystems.
	Use the first name returned on machine lookups when canonifying a
		hostname via NetInfo.  Patch from Timm Wetzel of GWDG.
	Clear the $&{client_addr}, $&{client_name}, and $&{client_port}
		macros when delivering a bounce message to prevent
		rejection by a check_compat ruleset which uses these macros.
		Problem noted by Jens Hamisch of AgiX Internetservices GmbH.
	If the check_relay ruleset resolves to the the error mailer, the
		error in the $: portion of the resolved triplet is used
		in the rejection message given to the remote machine.
		Suggested by Scott Gifford of The Internet Ramp.
	Set the $&{client_addr}, $&{client_name}, and $&{client_port} macros
		before calling the check_relay ruleset.  Suggested by Scott
		Gifford of The Internet Ramp.
	Sendmail would get a segmentation fault if a mailer exited with an
		exit code of 79.  Problem noted by Aaron Schrab of ExecPC
		Internet.  Fix from Christophe Wolfhugel of the Pasteur
		Institute.
	Separate snprintf/vsnprintf routines into separate file for use by
		mail.local.
	Allow multiple map lookups on right hand side, e.g.,
		R$*	$( host $1 $) $| $( passwd $1 $).  Patch from
		Christophe Wolfhugel of the Pasteur Institute.
	Properly generate success DSN messages if requested for aliases
		which have owner- aliases.  Problem noted by Kari Hurtta
		of the Finnish Meteorological Institute.
	Properly display delayed-expansion macros ($&{macroname}) in
		address test mode (-bt).  Problem noted by Bryan Costales
		of InfoBeat, Inc.
	-qR could sometimes match names incorrectly.  Problem noted by
		Lutz Euler of Lavielle EDV Systemberatung GmbH & Co.
	Include a magic number and version in the StatusFile for the
		mailstats command.
	Record the number of rejected and discarded messages in the
		StatusFile for display by the mailstats command.  Patch
		from Randall Winchester of the University of Maryland.
	IDENT returns where the OSTYPE field equals "OTHER" now list the
		user portion as IDENT:username@site instead of
		username@site to differentiate the two.  Suggested by
		Kari Hurtta of the Finnish Meteorological Institute.
	Enforce timeout for LDAP queries.  Patch from Per Hedeland of
		Ericsson.
	Change persistent host status filename substitution so '/' is
		replaced by ':' instead of '|' to avoid clashes.  Also
		avoid clashes with hostnames with leading dots.  Fix from
		Mitchell Blank Jr. of Exec-PC.
	If the system lock table is full, only attempt to create a new
		queue entry five times before giving up.  Previously, it
		was attempted indefinitely which could cause the partition
		to run out of inodes.  Problem noted by Suzie Weigand of
		Stratus Computer, Inc.
	In verbose mode, warn if the sendmail.cf version is less than the
		currently supported version.
	Sorting for QueueSortOrder=host is now case insensitive.  Patch
		from Randall S. Winchester of the University of Maryland.
	Properly quote a full name passed via the -F command line option,
		the Full-Name: header, or the NAME environment variable if
		it contains characters which must be quoted.  Problem noted
		by Kari Hurtta of the Finnish Meteorological Institute.
	Avoid possible race condition that unlocked a mail job before
		releasing the transcript file on systems that use flock(2).
		In some cases, this might result in a "Transcript Unavailable"
		message in error bounces.
	Accept SMTP replies which contain only a reply code and no
		accompanying text.  Problem noted by Fernando Fraticelli of
		Digital Equipment Corporation.
	Portability:
		AIX 4.1 uses int for SOCKADDR_LEN_T from Motonori Nakamura
			of Kyoto University.
		AIX 4.2 requires <userpw.h> before <usersec.h>.  Patch from
			Randall S. Winchester of the University of
			Maryland.
		AIX 4.3 from Valdis Kletnieks of Virginia Tech CNS.
		CRAY T3E from Manu Mahonen of Center for Scientific Computing
			in Finland.
		Digital UNIX now uses statvfs for determining free
			disk space.  Patch from Randall S. Winchester of
			the University of Maryland.
		HP-UX 11.x from Richard Allen of Opin Kerfi HF and
			Regis McEwen of Progress Software Corporation.
		IRIX 64 bit fixes from Kari Hurtta of the Finnish
			Meteorological Institute.
		IRIX 6.2 configuration fix for mail.local from Michael Kyle
			of CIC/Advanced Computing Laboratory.
		IRIX 6.5 from Thomas H Jones II of SGI.
		IRIX 6.X load average code from Bob Mende of SGI.
		QNX from Glen McCready <glen@qnx.com>.
		SCO 4.2 and 5.x use /usr/bin instead of /usr/ucb for links
			to sendmail.  Install with group bin instead of kmem
			as kmem does not exist.  From Guillermo Freige of
			Gobernacion de la Pcia de Buenos Aires and Paul
			Fischer of BTG, Inc.
		SunOS 4.X does not include memmove().  Patch from
			Per Hedeland of Ericsson.
		SunOS 5.7 includes getloadavg() function for determining
			load average.  Patch from John Beck of Sun
			Microsystems.
	CONFIG: Increment version number of config file.
	CONFIG: add DATABASE_MAP_TYPE to set the default type of database
		map for the various maps.  The default is hash.  Patch from
		Robert Harker of Harker Systems.
	CONFIG: new confEBINDIR m4 variable for defining the executable
		directory for certain programs.
	CONFIG: new FEATURE(local_lmtp) to use the new LMTP support for
		local mail delivery.  By the default, /usr/libexec/mail.local
		is used.  This is expected to be the mail.local shipped
		with 8.9 which is LMTP capable.  The path is based on the
		new confEBINDIR m4 variable.
	CONFIG: Use confEBINDIR in determining path to smrsh for
		FEATURE(smrsh).  Note that this changes the default from
		/usr/local/etc/smrsh to /usr/libexec/smrsh.  To obtain the
		old path for smrsh, use FEATURE(smrsh, /usr/local/etc/smrsh).
	CONFIG: DOMAIN(generic) changes the default confFORWARD_PATH to
		include $z/.forward.$w+$h and $z/.forward+$h which allow
		the user to setup different .forward files for
		user+detail addressing.
	CONFIG: add confMAX_RCPTS_PER_MESSAGE, confDONT_PROBE_INTERFACES,
		and confDONT_BLAME_SENDMAIL to set MaxRecipientsPerMessage,
		DontProbeInterfaces, and DontBlameSendmail options.
	CONFIG: by default do not allow relaying (that is, accepting mail
		from outside your domain and sending it to another host
		outside your domain).
	CONFIG: new FEATURE(promiscuous_relay) to allow mail relaying from
		any site to any site.
	CONFIG: new FEATURE(relay_entire_domain) allows any host in your
		domain as defined by the 'm' class ($=m) to relay.
	CONFIG: new FEATURE(relay_based_on_MX) to allow relaying based on
		the MX records of the host portion of an incoming recipient.
	CONFIG: new FEATURE(access_db) which turns on the access database
		feature.  This database gives you the ability to allow
		or refuse to accept mail from specified domains for
		administrative reasons.  By default, names that are listed
		as "OK" in the access db are domain names, not host names.
	CONFIG: new confCR_FILE m4 variable for defining the name of the file
		used for class 'R'.  Defaults to /etc/mail/relay-domains.
	CONFIG: new command RELAY_DOMAIN(domain) and RELAY_DOMAIN_FILE(file)
		to add items to class 'R' ($=R) for hosts allowed to relay.
	CONFIG: new FEATURE(relay_hosts_only) to change the behavior
		of FEATURE(access_db) and class 'R' to lookup individual
		host names only.
	CONFIG: new FEATURE(loose_relay_check).  Normally, if a recipient
		using % addressing is used, e.g.  user%site@othersite,
		and othersite is in class 'R', the check_rcpt ruleset
		will strip @othersite and recheck user@site for relaying.
		This feature changes that behavior.  It should not be
		needed for most installations.
	CONFIG: new FEATURE(relay_local_from) to allow relaying if the
		domain portion of the mail sender is a local host.  This
		should only be used if absolutely necessary as it opens
		a window for spammers.  Patch from Randall S. Winchester of
		the University of Maryland.
	CONFIG: new FEATURE(blacklist_recipients) turns on the ability to
		block incoming mail destined for certain recipient
		usernames, hostnames, or addresses.
	CONFIG: By default, MAIL FROM: commands in the SMTP session will be
		refused if the host part of the argument to MAIL FROM: cannot
		be located in the host name service (e.g., DNS).
	CONFIG: new FEATURE(accept_unresolvable_domains) accepts
		unresolvable hostnames in MAIL FROM: SMTP commands.
	CONFIG: new FEATURE(accept_unqualified_senders) accepts
		MAIL FROM: senders which do not include a domain.
	CONFIG: new FEATURE(rbl) Turns on rejection of hosts found in the
		Realtime Blackhole List.  You can specify the RBL name
		server to contact by specifying it as an optional argument.
		The default is rbl.maps.vix.com.  For details, see
		http://maps.vix.com/rbl/.
	CONFIG: Call Local_check_relay, Local_check_mail, and
		Local_check_rcpt from check_relay, check_mail, and
		check_rcpt.  Users with local rulesets should place the
		rules using LOCAL_RULESETS.  If a Local_check_* ruleset
		returns $#OK, the message is accepted.  If the ruleset
		returns a mailer, the appropriate action is taken, else
		the return of the ruleset is ignored.
	CONFIG: CYRUS_MAILER_FLAGS now includes the /:| mailer flags by
		default to support file, :include:, and program deliveries.
	CONFIG: Remove the default for confDEF_USER_ID so the binary can
		pick the proper default value.  See the SECURITY note
		above for more information.
	CONFIG: FEATURE(nodns) now warns the user that the feature is a
		no-op.  Patch from Kari Hurtta of the Finnish
		Meteorological Institute.
	CONFIG: OSTYPE(osf1) now sets DefaultUser (confDEF_USER_ID) to
		daemon since DEC's /bin/mail will drop the envelope
		sender if run as mailnull.  See the Digital UNIX section
		of src/README for more information.  Problem noted by
		Kari Hurtta of the Finnish Meteorological Institute.
	CONFIG: .cf files are now stored in the same directory with the
		.mc files instead of in the obj directory.
	CONFIG: New options confSINGLE_LINE_FROM_HEADER,
		confALLOW_BOGUS_HELO, and confMUST_QUOTE_CHARS for
		setting SingleLineFromHeader, AllowBogusHELO, and
		MustQuoteChars respectively.
	MAIL.LOCAL: support -l flag to run LMTP on stdin/stdout.  This
		SMTP-like protocol allows detailed reporting of delivery
		status on a per-user basis.  Code donated by John Myers of
		CMU (now of Netscape).
	MAIL.LOCAL: HP-UX support from Randall S. Winchester of the
		University of Maryland.  NOTE: mail.local is not
		compatible with the stock HP-UX mail format.  Be sure to
		read mail.local/README.
	MAIL.LOCAL: Prevent other mail delivery agents from stealing a
		mailbox lock.  Patch from Randall S. Winchester of the
		University of Maryland.
	MAIL.LOCAL: glibc portability from John Kennedy of Cal State
		University, Chico.
	MAIL.LOCAL: IRIX portability from Kari Hurtta of the Finnish
		Meteorological Institute.
	MAILSTATS: Display the number of rejected and discarded messages
		in the StatusFile.  Patch from Randall Winchester of the
		University of Maryland.
	MAKEMAP: New -s flag to ignore safety checks on database map files
		such as linked files in world writable directories.
	MAKEMAP: Add support for Berkeley DB 2.X.  Remove OLD_NEWDB support.
	PRALIASES: Add support for Berkeley DB 2.X.
	PRALIASES: Do not automatically include NDBM support.  Problem
		noted by Ralf Hildebrandt of the Technical University of
		Braunschweig.
	RMAIL: Improve portability for other platforms.  Patches from
		Randall S. Winchester of the University of Maryland and
		Kari Hurtta of the Finnish Meteorological Institute.
	Changed Files:
		src/Makefiles/Makefile.* files have been modified to use
			the new build mechanism and are now BuildTools/OS/*.
		src/makesendmail changed to symbolic link to src/Build.
	New Files:
		BuildTools/M4/header.m4
		BuildTools/M4/depend/BSD.m4
		BuildTools/M4/depend/CC-M.m4
		BuildTools/M4/depend/NCR.m4
		BuildTools/M4/depend/Solaris.m4
		BuildTools/M4/depend/X11.m4
		BuildTools/M4/depend/generic.m4
		BuildTools/OS/AIX.4.2
		BuildTools/OS/AIX.4.x
		BuildTools/OS/CRAYT3E.2.0.x
		BuildTools/OS/HP-UX.11.x
		BuildTools/OS/IRIX.6.5
		BuildTools/OS/NEXTSTEP.4.x
		BuildTools/OS/NeXT.4.x
		BuildTools/OS/NetBSD.8.3
		BuildTools/OS/QNX
		BuildTools/OS/SunOS.5.7
		BuildTools/OS/dcosx.1.x.NILE
		BuildTools/README
		BuildTools/Site/README
		BuildTools/bin/Build
		BuildTools/bin/configure.sh
		BuildTools/bin/find_m4.sh
		BuildTools/bin/install.sh
		Makefile
		cf/cf/Build
		cf/cf/generic-hpux10.cf
		cf/feature/accept_unqualified_senders.m4
		cf/feature/accept_unresolvable_domains.m4
		cf/feature/access_db.m4
		cf/feature/blacklist_recipients.m4
		cf/feature/loose_relay_check.m4
		cf/feature/local_lmtp.m4
		cf/feature/promiscuous_relay.m4
		cf/feature/rbl.m4
		cf/feature/relay_based_on_MX.m4
		cf/feature/relay_entire_domain.m4
		cf/feature/relay_hosts_only.m4
		cf/feature/relay_local_from.m4
		cf/ostype/qnx.m4
		contrib/doublebounce.pl
		mail.local/Build
		mail.local/Makefile.m4
		mail.local/README
		mailstats/Build
		mailstats/Makefile.m4
		makemap/Build
		makemap/Makefile.m4
		praliases/Build
		praliases/Makefile.m4
		rmail/Build
		rmail/Makefile.m4
		rmail/rmail.0
		smrsh/Build
		smrsh/Makefile.m4
		src/Build
		src/Makefile.m4
		src/snprintf.c
	Deleted Files:
		cf/cf/Makefile (replaced by Makefile.dist)
		mail.local/Makefile
		mail.local/Makefile.dist
		mailstats/Makefile
		mailstats/Makefile.dist
		makemap/Makefile
		makemap/Makefile.dist
		praliases/Makefile
		praliases/Makefile.dist
		rmail/Makefile
		smrsh/Makefile
		smrsh/Makefile.dist
		src/Makefile
		src/Makefiles/Makefile.AIX.4 (split into AIX.4.x and AIX.4.2)
		src/Makefiles/Makefile.SMP_DC.OSx.NILE
			(renamed BuildTools/OS/dcosx.1.x.NILE)
		src/Makefiles/Makefile.Utah (obsolete platform)
	Renamed Files:
		READ_ME => README
		cf/cf/Makefile.dist => Makefile
		cf/cf/obj/* => cf/cf/*
		src/READ_ME => src/README

8.8.8/8.8.8	1997/10/24
	If the check_relay ruleset failed, the relay= field was logged
		incorrectly.  Problem noted by Kari Hurtta of the Finnish
		Meteorological Institute.
	If /usr/tmp/dead.letter already existed, sendmail could not
		add additional bounces to it.  Problem noted by Thomas J.
		Arseneault of SRI International.
	If an SMTP mailer used a non-standard port number for the outgoing
		connection, it would be displayed incorrectly in verbose mode.
		Problem noted by John Kennedy of Cal State University, Chico.
	Log the ETRN parameter specified by the client before altering them
		to internal form.  Suggested by Bob Kupiec of GES-Verio.
	EXPN and VRFY SMTP commands on malformed addresses were logging as
		User unknown with bogus delay= values.  Change them to log
		the same as compliant addresses.  Problem noted by Kari E.
		Hurtta of the Finnish Meteorological Institute.
	Ignore the debug resolver option unless using sendmail debug trace
		option for resolver.  Problem noted by Greg Nichols of Wind
		River Systems.
	If SingleThreadDelivery was enabled and the remote server returned a
		protocol error on the DATA command, the connection would be
		closed but the persistent host status file would not be
		unlocked so other sendmail processes could not deliver to
		that host.  Problem noted by Peter Wemm of DIALix.
	If queueing up a message due to an expensive mailer, don't increment
		the number of delivery attempts or set the last delivery
		attempt time so the message will be delivered on the next
		queue run regardless of MinQueueAge.  Problem noted by
		Brian J. Coan of the Institute for Global Communications.
	Authentication warnings of "Processed from queue _directory_" and
		"Processed by _username_ with -C _filename_" would be logged
		with the incorrect timestamp.  Problem noted by Kari E. Hurtta
		of the Finnish Meteorological Institute.
	Use a better heuristic for detecting GDBM.
	Log null connections on dropped connections.  Problem noted by
		Jon Lewis of Florida Digital Turnpike.
	If class dbm maps are rebuilt, sendmail will now detect this and
		reopen the map.  Previously, they could give stale
		results during a single message processing (but would
		recover when the next message was received).  Fix from
		Joe Pruett of Q7 Enterprises.
	Do not log failures such as "User unknown" on -bv or SMTP VRFY
		requests.  Problem noted by Kari E. Hurtta of the
		Finnish Meteorological Institute.
	Do not send a bounce message back to the sender regarding bad
		recipients if the SMTP connection is dropped before the
		message is accepted.  Problem noted by Kari E. Hurtta of the
		Finnish Meteorological Institute.
	Use "localhost" instead of "[UNIX: localhost]" when connecting to
		sendmail via a UNIX pipe.  This will allow rulesets using
		$&{client_name} to process without sending the string through
		dequote.  Problem noted by Alan Barrett of Internet Africa.
	A combination of deferred delivery mode, a double bounce situation,
		and the inability to save a bounce message to
		/var/tmp/dead.letter would cause sendmail to send a bounce
		to postmaster but not remove the offending envelope from the
		queue causing it to create a new bounce message each time the
		queue was run.  Problem noted by Brad Doctor of Net Daemons
		Associates.
	Remove newlines from hostname information returned via DNS.  There are
		no known security implications of newlines in hostnames as
		sendmail filters newlines in all vital areas; however, this
		could cause confusing error messages.
	Starting with sendmail 8.8.6, mail sent with the '-t' option would be
		rejected if any of the specified addresses were bad.  This
		behavior was modified to only reject the bad addresses and not
		the entire message.  Problem noted by Jozsef Hollosi of
		SuperNet, Inc.
	Use Timeout.fileopen when delivering mail to a file.  Suggested by
		Bryan Costales of InfoBeat, Inc.
	Display the proper Final-Recipient on DSN messages for non-SMTP
		mailers.  Problem noted by Kari E. Hurtta of the
		Finnish Meteorological Institute.
	An error in calculating the available space in the list of addresses
		for logging deliveries could cause an address to be silently
		dropped.
	Include the initial user environment if sendmail is restarted via
		a HUP signal.  This will give room for the process title.
		Problem noted by Jon Lewis of Florida Digital Turnpike.
	Mail could be delivered without a body if the machine does not
		support flock locking and runs out of processes during
		delivery.  Fix from Chuck Lever of the University of Michigan.
	Drop recipient address from 251 and 551 SMTP responses per RFC 821.
		Problem noted by Kari E. Hurtta of the Finnish Meteorological
		Institute.
	Make sure non-rebuildable database maps are opened before the
		rebuildable maps (i.e., alias files) in case the database maps
		are needed for verifying the left hand side of the aliases.
		Problem noted by Lloyd Parkes of Victoria University.
	Make sure sender RFC822 source route addresses are alias expanded for
		bounce messages.  Problem noted by Juergen Georgi of
		RUS University of Stuttgart.
	Minor lint fixes.
	Return a temporary error instead of a permanent error if an LDAP map
		search returns an error.  This will allow sequenced maps which
		use other LDAP servers to be checked.  Fix from Booker Bense
		of Stanford University.
	When automatically converting from quoted printable to 8bit text do
		not pad bare linefeeds with a space.  Problem noted by Theo
		Nolte of the University of Technology Aachen, Germany.
	Portability:
		Non-standard C compilers may have had a problem compiling
			conf.c due to a standard C external declaration of
			setproctitle().  Problem noted by Ted Roberts of
			Electronic Data Systems.
		AUX: has a broken O_EXCL implementation.  Reported by Jim
			Jagielski of jaguNET Access Services.
		BSD/OS: didn't compile if HASSETUSERCONTEXT was defined.
		Digital UNIX: Digital UNIX (and possibly others) moves
			loader environment variables into the loader memory
			area.  If one of these environment variables (such as
			LD_LIBRARY_PATH) was the last environment variable,
			an invalid memory address would be used by the process
			title routine causing memory corruption.  Problem
			noted by Sam Hartman of Mesa Internet Systems.
		GNU libc: uses an enum for _PC_CHOWN_RESTRICTED which caused
			chownsafe() to always return 0 even if the OS does
			not permit file giveaways.  Problem noted by
			Yasutaka Sumi of The University of Tokyo.
		IRIX6: Syslog buffer size set to 512 bytes.  Reported by
			Gerald Rinske of Siemens Business Services VAS.
		Linux: Pad process title with NULLs.  Problem noted by
			Jon Lewis of Florida Digital Turnpike.
		SCO OpenServer 5.0: SIOCGIFCONF ioctl call returns an
			incorrect value for the number of interfaces.
			Problem noted by Chris Loelke of JetStream Internet
			Services.
		SINIX: Update for Makefile and syslog buffer size from Gerald
			Rinske of Siemens Business Services VAS.
		Solaris: Make sure HASGETUSERSHELL setting for SunOS is not
			used on a Solaris machine.  Problem noted by
			Stephen Ma of Jtec Pty Limited.
		CONFIG: SINIX: Update from Gerald Rinske of Siemens Business
			Services VAS.
	MAKEMAP: Use a better heuristic for detecting GDBM.
	CONTRIB: expn.pl: Updated version from the author, David Muir Sharnoff.
	OP.ME: Document the F=i mailer flag.  Problem noted by Per Hedeland of
			Ericsson.

8.8.7/8.8.7	1997/08/03
	If using Berkeley DB on systems without O_EXLOCK (open a file with
		an exclusive lock already set -- i.e., almost all systems
		except 4.4-BSD derived systems), the initial attempt at
		rebuilding aliases file if the database didn't already
		exist would fail.  Patch from Raymund Will of LST Software
		GmbH.
	Bogus incoming SMTP commands would reset the SMTP conversation.
		Problem noted by Fredrik Jönsson of the Royal Institute
		of Technology, Stockholm.
	Since TCP Wrappers includes setenv(), unsetenv(), and putenv(),
		some environments could give "multiple definitions" for these
		routines during compilation.  If using TCP Wrappers, assume
		that these routines are included as though they were in the
		C library.  Patch from Robert La Ferla.
	When a NEWDB database map was rebuilt at the same time it was being
		used by a queue run, the maps could be left locked for the
		duration of the queue run, causing other processes to hang.
		Problem noted by Kendall Libby of Shore.NET.
	In some cases, NoRecipientAction=add-bcc was being ignored, so the
		mail was passed on without any recipient header.  This could
		cause problems downstream.  Problem noted by Xander Jansen
		of SURFnet ExpertiseCentrum.
	Give error when GDBM is used with sendmail.  GDBM's locking and
		linking of the .dir and .pag files interferes with sendmail's
		locking and security checks.  Problems noted by Fyodor
		Yarochkin of the Kyrgyz Republic FreeNet.
	Don't fsync qf files if SuperSafe option is not set.
	Avoid extra calls to gethostbyname for addresses for which a
		gethostbyaddr found no value.  Also, ignore any returns
		from gethostbyaddr that look like a dotted quad.
	If PTR lookup fails when looking up an SMTP peer, don't tag it as
		"may be forged", since at the network level we pretty much
		have to assume that the information is good.
	In some cases, errors during an SMTP session could leave files
		open or locked.
	Better handling of missing file descriptors (0, 1, 2) on startup.
	Better handling of non-set-user-ID binaries -- avoids certain obnoxious
		errors during testing.
	Errors in file locking of NEWDB maps had the incorrect file name
		printed in the error message.
	If the AllowBogusHELO option were set and an EHLO with a bad or
		missing parameter were issued, the EHLO behaved like a HELO.
	Load limiting never kicked in for incoming SMTP transactions if the
		DeliveryMode=background and any recipient was an alias or
		had a .forward file.  From Nik Conwell of Boston University.
	On some non-Posix systems, the decision of whether chown(2) permits
		file giveaway was undefined.  From Tetsu Ushijima of the
		Tokyo Institute of Technology.
	Fix race condition that could cause the body of a message to be
		lost (so only the header was delivered).  This only occurs
		on systems that do not use flock(2), and only when a queue
		runner runs during a critical section in another message
		delivery.  Based on a patch from Steve Schweinhart of
		Results Computing.
	If a qf file was found in a mail queue directory that had a problem
		(wrong ownership, bad format, etc.) and the file name was
		exactly MAXQFNAME bytes long, then instead of being tried
		once, it would be tried on every queue run.  Problem noted
		by Bryan Costales of Mercury Mail.
	If the system supports an st_gen field in the status structure,
		include it when reporting that a file has changed after open.
		This adds a new compile flag, HAS_ST_GEN (0/1 option).
		This out to be checked as well as reported, since it is
		theoretically possible for an attacker to remove a file after
		it is opened and replace it with another file that has the
		same i-number, but some filesystems (notably AFS) return
		garbage in this field, and hence always look like the file
		has changed.  As a practical matter this is not a security
		problem, since the files can be neither hard nor soft links,
		and on no filesystem (that I am aware of) is it possible to
		have two files on the same filesystem with the same i-number
		simultaneously.
	Delete the root Makefile from the distribution -- it is only for
		use internally, and does not work at customer sites.
	Fix botch that caused the second MAIL FROM: command in a single
		transaction to clear the entire transaction.  Problem
		noted by John Kennedy of Cal State University, Chico.
	Work properly on machines that have _PATH_VARTMP defined without
		a trailing slash.  (And a pox on vendors that decide to
		ignore the established conventions!)  Problem noted by
		Gregory Neil Shapiro of WPI.
	Internal changes to make it easier to add another protocol family
		(intended for IPv6).  Patches are from John Kennedy of
		CSU Chico.
	In certain cases, 7->8 bit MIME decoding of Base64 text could leave
		an extra space at the beginning of some lines.  Problem
		noted by Charles Karney of Princeton University; fix based
		on a patch from Christophe Wolfhugel.
	Portability:
		Allow _PATH_VENDOR_CF to be set in Makefile for consistency
			with the _Sendmail_ book, 2nd edition.  Note that
			the book is actually wrong: _PATH_SENDMAILCF should
			be used instead.
		AIX 3.x: Include <sys/select.h>.  Patch from Gene Rackow
			of Argonne National Laboratory.
		OpenBSD from from Paul DuBois of the University of Wisconsin.
		RISC/os 4.0 from Paul DuBois of the University of Wisconsin.
		SunOS: Include <memory.h> to fix warning from util.c.  From
			James Aldridge of EUnet Ltd.
		Solaris: Change STDIR (location of status file) to /etc/mail
			in Makefiles.
		Linux, Dynix, UNICOS: Remove -DNDBM and -lgdbm from
			Makefiles.  Use NEWDB on Linux instead.
		NCR MP-RAS 3.x with STREAMware TCP/IP: SIOCGIFNUM ioctl
			exists but behaves differently than other OSes.
			Add SIOCGIFNUM_IS_BROKEN compile flag to get
			around the problem.  Problem noted by Tom Moore of
			NCR Corp.
		HP-UX 9.x: fix compile warnings for old select API.  Problem
			noted by Tom Smith of Digital Equipment Corp.
		UnixWare 2.x: compile warnings on offsetof macro.  Problem
			noted by Tom Good of the Community Access Information
			Resource Network
		SCO 4.2: compile problems caused by a change in the type of
			the "length" parameters passed to accept, getpeername,
			getsockname, and getsockopt.  Adds new compile flags
			SOCKADDR_SIZE_T and SOCKOPT_SIZE_T.  Problem reported
			by Tom Good of St. Vincent's North Richmond Community
			Mental Health Center Residential Services.
		AIX 4: Use size_t for SOCKADDR_SIZE_T and SOCKOPT_SIZE_T.
			Suggested by Brett Hogden of Rochester Gas & Electric
			Corp.
		Linux: avoid compile problem for versions of <setjmp.h> that
			#define both setjmp and longjmp.  Problem pointed out
			by J.R. Oldroyd of TerraNet.
		CONFIG: SCO UnixWare 2.1: Support for OSTYPE(sco-uw-2.1)
			from Christopher Durham of SCO.
		CONFIG: NEXTSTEP: define confCW_FILE to
			/etc/sendmail/sendmail.cw to match the usual
			configuration.  Patch from Dennis Glatting of
			PlainTalk.
	CONFIG: MAILER(fax) called a program that hasn't existed for a long
		time.  Convert to use the HylaFAX 4.0 conventions.  Suggested
		by Harry Styron.
	CONFIG: Improve sample anti-spam rulesets in cf/cf/knecht.mc.  These
		are the rulesets in use on sendmail.org.
	MAKEMAP: give error on GDBM files.
	MAIL.LOCAL: Make error messages a bit more explicit, for example,
		telling more details on what actually changed when "file
		changed after open".
	CONTRIB: etrn.pl: Ignore comments in Fw files.  Support multiple Fw
		files.
	CONTRIB: passwd-to-alias.pl: Handle 8 bit characters and '-'.
	NEW FILES:
		src/Makefiles/Makefile.OpenBSD
		src/Makefiles/Makefile.RISCos.4_0
		test/t_exclopen.c
		cf/ostype/sco-uw-2.1.m4
	DELETED FILES:
		Makefile

8.8.6/8.8.6	1997/06/14
	    *************************************************************
	    * The extensive assistance of Gregory Neil Shapiro of WPI	*
	    * in preparing this release is gratefully appreciated.	*
	    * Sun Microsystems has also provided resources toward	*
	    * continued sendmail development.				*
	    *************************************************************
	SECURITY: A few systems allow an open with the O_EXCL|O_CREAT open
		mode bits set to create a file that is a symbolic link that
		points nowhere.  This makes it possible to create a root
		owned file in an arbitrary directory by inserting the symlink
		into a writable directory after the initial lstat(2) check
		determined that the file did not exist.  The only verified
		example of a system having these odd semantics for O_EXCL
		and symbolic links was HP-UX prior to version 9.07.  Most
		systems do not have the problem, since a exclusive create
		of a file disallows symbolic links.  Systems that have been
		verified to NOT have the problem include AIX 3.x, *BSD,
		DEC OSF/1, HP-UX 9.07 and higher, Linux, SunOS, Solaris,
		and Ultrix.  This is a potential exposure on systems that
		have this bug and which do not have a MAILER-DAEMON alias
		pointing at a legitimate account, since this will cause old
		mail to be dropped in /var/tmp/dead.letter.
	SECURITY: Problems can occur on poorly managed systems, specifically,
		if maps or alias files are in world writable directories.
		If your system has alias maps in writable directories, it
		is potentially possible for an attacker to replace the .db
		(or .dir and .pag) files by symbolic links pointing at
		another database; this can be used either to expose
		information (e.g., by pointing an alias file at /etc/spwd.db
		and probing for accounts), or as a denial-of-service attack
		(by trashing the password database).  The fix disallows
		symbolic links entirely when rebuilding alias files or on
		maps that are in writable directories, and always warns on
		writable directories; 8.9 will probably consider writable
		directories to be fatal errors.  This does not represent an
		exposure on systems that have alias files in unwritable
		system directories.
	SECURITY: disallow .forward or :include: files that are links (hard
		or soft) if the parent directory (or any directory in the
		path) is writable by anyone other than the owner.  This is
		similar to the previous case for user files.  This change
		should not affect most systems, but is necessary to prevent
		an attacker who can write the directory from pointing such
		files at other files that are readable only by the owner.
	SECURITY: Tighten safechown rules: many systems will say that they
		have a safe (restricted to root) chown even on files that
		are mounted from another system that allows owners to give
		away files.  The new rules are very strict, trusting file
		ownership only in those few cases where the system has
		been verified to be at least as paranoid as necessary.
		However, it is possible to relax the rules to partially
		trust the ownership if the directory path is not world or
		group writable.  This might allow someone who has a legitimate
		:include: file (referenced directly from /etc/aliases) to
		become another non-root user if the :include: file is in a
		non-writable directory on an NFS-mounted filesystem where
		the local system says that giveaway is denied but it is
		actually permitted.  I believe this to be a very small set
		of cases.  If in doubt, do not point :include: aliases at
		NFS-mounted filesystems.
	SECURITY: When setting a numeric group id using the RunAsUser option
		(e.g., "O RunAsUser=10:20", the group id would not be set.
		Implicit group ids (e.g., "O RunAsUser=mailnull") or alpha
		group ids (e.g., "O RunAsUser=mailuser:mailgrp") worked fine.
		The user id was still set properly.  Problem noted by Uli
		Pralle of the Technical University of Berlin.
	Save the initial gid set for use when checking for if the
		PrivacyOptions=restrictmailq option is set.  Problem reported
		by Wolfgang Ley of DFN-CERT.
	Make 55x reply codes to the SMTP DATA-"." be non-sticky (i.e., a
		failure on one message won't affect future messages to the
		same host).
	IP source route printing had an "off by one" error that would
		affect any options that came after the route option.  Patch
		from Theo de Raadt.
	The "Message is too large" error didn't successfully bounce the error
		back to the sender.  Problem reported by Stephen More of
		PSI; patch from Gregory Neil Shapiro of WPI.
	Change SMTP status code 553 to map into Extended code 5.1.0 (instead
		of 5.1.3); it apparently gets used in multiple ways.
		Suggested by John Myers of Portola Communications.
	Fix possible extra null byte generated during collection if errors
		occur at the beginning of the stream.  Patch contributed by
		Andrey A. Chernov and Gregory Neil Shapiro.
	Code changes to avoid possible reentrant call of malloc/free within
		a signal handler.  Problem noted by John Beck of Sun
		Microsystems.
	Move map initialization to be earlier so that check_relay ruleset
		will have the latest version of the map data.  Problem noted
		by Paul Forgey of Metainfo; patch from Gregory Neil Shapiro.
	If there are fatal errors during the collection phase (e.g., message
		too large) don't send the bogus message.
	Avoid "cannot open xfAAA00000" messages when sending to aliases that
		have errors and have owner- aliases.  Problem noted by Michael
		Barber of MTU; fix from Gregory Neil Shapiro of WPI.
	Avoid null pointer dereference on illegal Boundary= parameters in
		multipart/mixed Content-Type: header.  Problem noted by
		Richard Muirden of RMIT University.
	Always print error messages during newaliases (-bi) even if the
		ErrorMode is not set to "print".  Fix from Gregory Neil
		Shapiro.
	Test mode could core dump if you did a /map lookup in an optional map
		that could not be opened.  Based on a fix from John Beck of
		Sun Microsystems.
	If DNS is misconfigured so that the last MX record tried points to
		a host that does not have an A record, but other MX records
		pointed to something reasonable, don't bounce the message
		with a "host unknown" error.  Note that this should really
		be fixed in the zone file for the domain.  Problem noted by
		Joe Rhett of Navigist, Inc.
	If a map fails (e.g., DNS times out) on all recipient addresses, mark
		the message as having been tried; otherwise the next queue
		run will not realize that this is a second attempt and will
		retry immediately.  Problem noted by Bryan Costales of
		Mercury Mail.
	If the clock is set backwards, and a MinQueueAge is set, no jobs
		will be run until the later setting of the clock is reached.
		"Problem" (I use the term loosely) noted by Eric Hagberg of
		Morgan Stanley.
	If the load average rises above the cutoff threshold (above which
		sendmail will not process the queue at all) during a queue
		run, abort the queue run immediately.  Problem noted by
		Bryan Costales of Mercury Mail.
	The variable queue processing algorithm (based on the message size,
		number of recipients, message precedence, and job age) was
		non-functional -- either the entire queue was processed or
		none of the queue was processed.  The updated algorithm
		does no queue run if a single recipient zero size job will
		not be run.
	If there is a fatal ("panic") message that will cause sendmail to
		die immediately, never hold the error message for future
		printing.
	Force ErrorMode=print in -bt mode so that all errors are printed
		regardless of the setting of the ErrorMode option in the
		configuration file.  Patch from Gregory Neil Shapiro.
	New compile flag HASSTRERROR says that this OS has the strerror(3)
		routine available in one of the libraries.  Use it in conf.h.
	The -m (match only) flag now works on host class maps.
